import {
  i
} from "./chunk.Z3O73C4R.js";

// src/components/checkbox/checkbox.styles.ts
var checkbox_styles_default = i`
  :host {
    display: inline-block;
  }

  .checkbox {
    position: relative;
    display: inline-flex;
    align-items: flex-start;
    font-family: var(--lynk-input-font-family);
    font-weight: var(--lynk-input-font-weight);
    color: var(--lynk-input-color);
    vertical-align: middle;
    cursor: pointer;
  }

  .checkbox--small {
    --toggle-size: var(--lynk-toggle-size-small);
    font-size: var(--lynk-input-label-font-size-small);
  }

  .checkbox--medium {
    --toggle-size: var(--lynk-toggle-size-medium);
    font-size: var(--lynk-input-label-font-size-medium);
  }

  .checkbox--large {
    --toggle-size: var(--lynk-toggle-size-large);
    font-size: var(--lynk-input-label-font-size-large);
  }

  .checkbox__control {
    flex: 0 0 auto;
    position: relative;
    display: inline-flex;
    align-items: center;
    justify-content: center;
    width: var(--toggle-size);
    height: var(--toggle-size);
    border: solid var(--lynk-input-border-width) var(--lynk-input-border-color);
    border-radius: 2px;
    background-color: var(--lynk-input-background-color);
    color: var(--lynk-color-neutral-0);
    transition:
      var(--lynk-transition-fast) border-color,
      var(--lynk-transition-fast) background-color,
      var(--lynk-transition-fast) color,
      var(--lynk-transition-fast) box-shadow;
  }

  .checkbox__input {
    position: absolute;
    opacity: 0;
    padding: 0;
    margin: 0;
    pointer-events: none;
  }

  .checkbox__checked-icon,
  .checkbox__indeterminate-icon {
    display: inline-flex;
    width: var(--toggle-size);
    height: var(--toggle-size);
  }

  /* Hover */
  .checkbox:not(.checkbox--checked):not(.checkbox--disabled) .checkbox__control:hover {
    border-color: var(--lynk-input-border-color-hover);
    background-color: var(--lynk-input-background-color-hover);
  }

  /* Focus */
  .checkbox:not(.checkbox--checked):not(.checkbox--disabled) .checkbox__input:focus-visible ~ .checkbox__control {
    outline: var(--lynk-focus-ring);
    outline-offset: var(--lynk-focus-ring-offset);
  }

  /* Checked/indeterminate */
  .checkbox--checked .checkbox__control,
  .checkbox--indeterminate .checkbox__control {
    border-color: var(--lynk-color-primary-600);
    background-color: var(--lynk-color-primary-600);
  }

  /* Checked/indeterminate + hover */
  .checkbox.checkbox--checked:not(.checkbox--disabled) .checkbox__control:hover,
  .checkbox.checkbox--indeterminate:not(.checkbox--disabled) .checkbox__control:hover {
    border-color: var(--lynk-color-primary-500);
    background-color: var(--lynk-color-primary-500);
  }

  /* Checked/indeterminate + focus */
  .checkbox.checkbox--checked:not(.checkbox--disabled) .checkbox__input:focus-visible ~ .checkbox__control,
  .checkbox.checkbox--indeterminate:not(.checkbox--disabled) .checkbox__input:focus-visible ~ .checkbox__control {
    outline: var(--lynk-focus-ring);
    outline-offset: var(--lynk-focus-ring-offset);
  }

  /* Disabled */
  .checkbox--disabled {
    opacity: 0.5;
    cursor: not-allowed;
  }

  .checkbox--has-label .checkbox__label {
    margin-inline-start: 0.5em;
  }

  .checkbox__label {
    display: inline-block;
    color: var(--lynk-input-label-color);
    font-size: inherit;
    line-height: var(--toggle-size);
    user-select: none;
  }

  :host([required]) .checkbox__label::after {
    content: var(--lynk-input-required-content);
    margin-inline-start: var(--lynk-input-required-content-offset);
  }

  /*
   * Error & Warning States
   */

  .checkbox--has-error .checkbox__control,
  .checkbox--has-error:not(.checkbox--checked):not(.checkbox--disabled) .checkbox__control:hover {
    border-color: var(--lynk-color-danger-500);
  }

  .checkbox--has-error.checkbox--focused:not(.checkbox--disabled) .checkbox__control {
    border-color: var(--lynk-color-danger-500);
    box-shadow: 0 0 2px var(--lynk-focus-ring-width) var(--lynk-color-danger-a50);
  }

  .checkbox--has-error .checkbox__label {
    color: var(--lynk-color-danger-500);
  }

  .checkbox--has-error.checkbox--checked .checkbox__control {
    background-color: var(--lynk-color-success-500);
    outline: none;
  }

  .checkbox--has-warning .checkbox__control,
  .checkbox--has-warning:not(.checkbox--checked):not(.checkbox--disabled) .checkbox__control:hover {
    border-color: var(--lynk-color-warning-500);
  }

  .checkbox--has-warning.checkbox--focused:not(.checkbox--disabled) .checkbox__control {
    border-color: var(--lynk-color-warning-500);
    box-shadow: 0 0 2px var(--lynk-focus-ring-width) var(--lynk-color-warning-a50);
  }

  .checkbox--has-warning .checkbox__label {
    color: var(--lynk-color-warning-500);
  }

  .checkbox--has-warning.checkbox--checked .checkbox__control {
    background-color: var(--lynk-color-warning-500);
    outline: none;
  }

  .checkbox--has-success .checkbox__control,
  .checkbox--has-success:not(.checkbox--checked):not(.checkbox--disabled) .checkbox__control:hover {
    border-color: var(--lynk-color-success-500);
  }

  .checkbox--has-success.checkbox--focused:not(.checkbox--disabled) .checkbox__control {
    border-color: var(--lynk-color-success-500);
    box-shadow: 0 0 2px var(--lynk-focus-ring-width) var(--lynk-color-success-a50);
  }

  .checkbox--has-success .checkbox__label {
    color: var(--lynk-color-success-500);
  }

  .checkbox--has-success.checkbox--checked .checkbox__control {
    background-color: var(--lynk-color-success-500);
    outline: none;
  }
`;

export {
  checkbox_styles_default
};
