import {
  input_styles_default
} from "./chunk.3MFVOZI2.js";
import {
  LynkTooltip
} from "./chunk.ZYCYIAT3.js";
import {
  LynkStack
} from "./chunk.A4PVTMWO.js";
import {
  l
} from "./chunk.ENUMKHAK.js";
import {
  defaultValue
} from "./chunk.NEEAUM7I.js";
import {
  form_control_styles_default
} from "./chunk.GJLY5JLB.js";
import {
  FormControlController
} from "./chunk.UDRCCTEL.js";
import {
  o
} from "./chunk.J4J6TZIX.js";
import {
  HasSlotController
} from "./chunk.OW5NIGGX.js";
import {
  LocalizeController
} from "./chunk.AFESEORB.js";
import {
  LynkIcon
} from "./chunk.4HTNL6JH.js";
import {
  watch
} from "./chunk.JMZM2TDT.js";
import {
  e
} from "./chunk.4VMW2AZ2.js";
import {
  LynkElement,
  e as e2,
  n,
  r
} from "./chunk.2EAGJTRH.js";
import {
  component_styles_default
} from "./chunk.V6UNAAZX.js";
import {
  x
} from "./chunk.Z3O73C4R.js";
import {
  __decorateClass
} from "./chunk.W27M6RDR.js";

// src/components/input/input.component.ts
var LynkInput = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.formControlController = new FormControlController(this, {
      assumeInteractionOn: ["ev-blur", "ev-input"]
    });
    this.hasSlotController = new HasSlotController(this, "action", "help-text", "help-tip", "label");
    this.localize = new LocalizeController(this);
    this.hasFocus = false;
    this.title = "";
    // make reactive to pass through
    this.__numberInput = Object.assign(document.createElement("input"), { type: "number" });
    this.__dateInput = Object.assign(document.createElement("input"), { type: "date" });
    this.type = "text";
    this.name = "";
    this.value = "";
    this.defaultValue = "";
    this.state = "default";
    this.size = "medium";
    this.filled = false;
    this.pill = false;
    this.label = "";
    this.helpText = "";
    this.helpTip = "";
    this.clearable = false;
    this.disabled = false;
    this.placeholder = "";
    this.readonly = false;
    this.restricted = false;
    this.passwordToggle = false;
    this.passwordVisible = false;
    this.noSpinButtons = false;
    this.autoPicker = false;
    this.form = "";
    this.required = false;
    this.autocomplete = "off";
    this.spellcheck = true;
  }
  //
  // NOTE: We use an in-memory input for these getters/setters instead of the one in the template because the properties
  // can be set before the component is rendered.
  //
  /**
   * Gets or sets the current value as a `Date` object. Returns `null` if the value can't be converted. This will use the native `<input type="{{type}}">` implementation and may result in an error.
   */
  get valueAsDate() {
    var _a;
    this.__dateInput.type = this.type;
    this.__dateInput.value = this.value;
    return ((_a = this.input) == null ? void 0 : _a.valueAsDate) || this.__dateInput.valueAsDate;
  }
  set valueAsDate(newValue) {
    this.__dateInput.type = this.type;
    this.__dateInput.valueAsDate = newValue;
    this.value = this.__dateInput.value;
  }
  /** Gets or sets the current value as a number. Returns `NaN` if the value can't be converted. */
  get valueAsNumber() {
    var _a;
    this.__numberInput.value = this.value;
    return ((_a = this.input) == null ? void 0 : _a.valueAsNumber) || this.__numberInput.valueAsNumber;
  }
  set valueAsNumber(newValue) {
    this.__numberInput.valueAsNumber = newValue;
    this.value = this.__numberInput.value;
  }
  /** Gets the validity state object */
  get validity() {
    return this.input.validity;
  }
  /** Gets the validation message */
  get validationMessage() {
    return this.input.validationMessage;
  }
  firstUpdated() {
    this.formControlController.updateValidity();
  }
  handleBlur() {
    this.hasFocus = false;
    this.emit("ev-blur");
  }
  handleChange() {
    this.value = this.input.value;
    this.emit("ev-change");
  }
  handleClearClick(event) {
    event.preventDefault();
    if (this.value !== "") {
      this.value = "";
      this.emit("ev-clear");
      this.emit("ev-input");
      this.emit("ev-change");
    }
    this.input.focus();
  }
  handleFocus() {
    this.hasFocus = true;
    this.emit("ev-focus");
    if (this.autoPicker) {
      this.showPicker();
    }
  }
  handleInput() {
    this.value = this.input.value;
    this.formControlController.updateValidity();
    this.emit("ev-input");
  }
  handleInvalid(event) {
    this.formControlController.setValidity(false);
    this.formControlController.emitInvalidEvent(event);
  }
  handleKeyDown(event) {
    const hasModifier = event.metaKey || event.ctrlKey || event.shiftKey || event.altKey;
    if (event.key === "Enter" && !hasModifier) {
      setTimeout(() => {
        if (!event.defaultPrevented && !event.isComposing) {
          this.formControlController.submit();
          this.emit("ev-enter");
        }
      });
    }
  }
  handlePasswordToggle() {
    this.passwordVisible = !this.passwordVisible;
  }
  handleDisabledChange() {
    if (this.disabled || this.restricted) {
      this.formControlController.setValidity(true);
    }
  }
  handleStepChange() {
    this.input.step = String(this.step);
    this.formControlController.updateValidity();
  }
  async handleValueChange() {
    await this.updateComplete;
    this.formControlController.updateValidity();
  }
  /** Sets focus on the input. */
  focus(options) {
    this.input.focus(options);
  }
  /** Removes focus from the input. */
  blur() {
    this.input.blur();
  }
  /** Selects all the text in the input. */
  select() {
    this.input.select();
  }
  /** Sets the start and end positions of the text selection (0-based). */
  setSelectionRange(selectionStart, selectionEnd, selectionDirection = "none") {
    this.input.setSelectionRange(selectionStart, selectionEnd, selectionDirection);
  }
  /** Replaces a range of text with a new string. */
  setRangeText(replacement, start, end, selectMode = "preserve") {
    const selectionStart = start != null ? start : this.input.selectionStart;
    const selectionEnd = end != null ? end : this.input.selectionEnd;
    this.input.setRangeText(replacement, selectionStart, selectionEnd, selectMode);
    if (this.value !== this.input.value) {
      this.value = this.input.value;
    }
  }
  /** Displays the browser picker for an input element (only works if the browser supports it for the input type). */
  showPicker() {
    if ("showPicker" in HTMLInputElement.prototype) {
      this.input.showPicker();
    }
  }
  /** Increments the value of a numeric input type by the value of the step attribute. */
  stepUp() {
    this.input.stepUp();
    if (this.value !== this.input.value) {
      this.value = this.input.value;
    }
  }
  /** Decrements the value of a numeric input type by the value of the step attribute. */
  stepDown() {
    this.input.stepDown();
    if (this.value !== this.input.value) {
      this.value = this.input.value;
    }
  }
  /** Checks for validity but does not show a validation message. Returns `true` when valid and `false` when invalid. */
  checkValidity() {
    return this.input.checkValidity();
  }
  /** Gets the associated form, if one exists. */
  getForm() {
    return this.formControlController.getForm();
  }
  /** Checks for validity and shows the browser's validation message if the control is invalid. */
  reportValidity() {
    return this.input.reportValidity();
  }
  /** Sets a custom validation message. Pass an empty string to restore validity. */
  setCustomValidity(message) {
    this.input.setCustomValidity(message);
    this.formControlController.updateValidity();
  }
  render() {
    const hasLabelSlot = this.hasSlotController.test("label");
    const hasHelpTextSlot = this.hasSlotController.test("help-text");
    const hasHelpTipSlot = this.hasSlotController.test("help-tip");
    const hasLabel = this.label ? true : !!hasLabelSlot;
    const hasHelpText = this.helpText ? true : !!hasHelpTextSlot;
    const hasHelpTip = this.helpTip ? true : !!hasHelpTipSlot;
    const hasClearIcon = this.clearable && !this.disabled && !this.readonly;
    const isClearIconVisible = hasClearIcon && (typeof this.value === "number" || this.value.length > 0);
    return x`
      <div
        part="form-control"
        class=${e({
      "form-control": true,
      "form-control--small": this.size === "small",
      "form-control--medium": this.size === "medium",
      "form-control--large": this.size === "large",
      "form-control--has-label": hasLabel,
      "form-control--has-help-text": hasHelpText,
      "form-control--has-error": this.state === "error" || this.hasAttribute("data-user-invalid"),
      "form-control--has-warning": this.state === "warning",
      "form-control--has-success": this.state === "success"
    })}
      >
        <label
          part="form-control-label"
          for="input"
          aria-hidden=${hasLabel ? "false" : "true"}
          class=${e({
      "form-control__label": true,
      "form-control--focused": this.hasFocus
    })}
        >
          <slot name="label">${this.label}</slot>

          ${this.required ? x`
                <lynk-tooltip content="Required" hoist>
                  <lynk-icon style="font-size: 9px;" name="asterisk" library="system"></lynk-icon>
                </lynk-tooltip>
              ` : ""}
          ${hasHelpTip ? x`
                <lynk-tooltip hoist>
                  <div slot="content">
                    <slot name="help-tip">${this.helpTip}</slot>
                  </div>
                  <lynk-icon style="font-size: 11px;" name="question-fill" library="system"></lynk-icon>
                </lynk-tooltip>
              ` : ""}
        </label>

        <lynk-stack part="form-control-input" class="form-control-input" gap="var(--lynk-spacing-2x-small)" horizontal>
          <div
            part="base"
            class=${e({
      input: true,
      // Sizes
      "input--small": this.size === "small",
      "input--medium": this.size === "medium",
      "input--large": this.size === "large",
      // States
      "input--pill": this.pill,
      "input--standard": !this.filled,
      "input--filled": this.filled,
      "input--disabled": this.disabled,
      "input--restricted": this.restricted,
      "input--focused": this.hasFocus,
      "input--empty": !this.value,
      "input--has-error": this.state === "error" || this.hasAttribute("data-user-invalid"),
      "input--has-warning": this.state === "warning",
      "input--has-success": this.state === "success",
      "input--no-spin-buttons": this.noSpinButtons
    })}
          >
            <span part="prefix" class="input__prefix">
              <slot name="prefix"></slot>
            </span>

            ${this.restricted ? x`
                  <div part="input" aria-describedby="help-text" class="input__control-preview">
                    ${this.value || "None"}
                  </div>
                ` : ""}

            <input
              part="input"
              id="input"
              class="input__control"
              type=${this.type === "password" && this.passwordVisible ? "text" : this.type}
              title=${this.title}
              name=${o(this.name)}
              ?disabled=${this.disabled || this.restricted}
              ?readonly=${this.readonly}
              ?required=${this.required}
              placeholder=${o(this.placeholder)}
              minlength=${o(this.minlength)}
              maxlength=${o(this.maxlength)}
              min=${o(this.min)}
              max=${o(this.max)}
              step=${o(this.step)}
              .value=${l(this.value)}
              autocapitalize=${o(this.autocapitalize)}
              autocomplete=${o(this.autocomplete) || "off"}
              autocorrect=${o(this.autocorrect)}
              ?autofocus=${this.autofocus}
              spellcheck=${this.spellcheck}
              pattern=${o(this.pattern)}
              enterkeyhint=${o(this.enterkeyhint)}
              inputmode=${o(this.inputmode)}
              aria-describedby="help-text"
              @change=${this.handleChange}
              @input=${this.handleInput}
              @invalid=${this.handleInvalid}
              @keydown=${this.handleKeyDown}
              @focus=${this.handleFocus}
              @blur=${this.handleBlur}
            />

            ${isClearIconVisible ? x`
                  <button
                    part="clear-button"
                    class="input__clear"
                    type="button"
                    aria-label=${this.localize.term("clearEntry")}
                    @click=${this.handleClearClick}
                    tabindex="-1"
                  >
                    <slot name="clear-icon">
                      <lynk-icon name="x-circle-fill" library="system"></lynk-icon>
                    </slot>
                  </button>
                ` : ""}
            ${this.passwordToggle && !this.disabled ? x`
                  <button
                    part="password-toggle-button"
                    class="input__password-toggle"
                    type="button"
                    aria-label=${this.localize.term(this.passwordVisible ? "hidePassword" : "showPassword")}
                    @click=${this.handlePasswordToggle}
                    tabindex="-1"
                  >
                    ${this.passwordVisible ? x`
                          <slot name="show-password-icon">
                            <lynk-icon name="eye-slash" library="system"></lynk-icon>
                          </slot>
                        ` : x`
                          <slot name="hide-password-icon">
                            <lynk-icon name="eye" library="system"></lynk-icon>
                          </slot>
                        `}
                  </button>
                ` : ""}

            <span part="suffix" class="input__suffix">
              <slot name="suffix"></slot>
            </span>
          </div>
          <slot name="action"></slot>
        </lynk-stack>

        <div
          part="form-control-help-text"
          id="help-text"
          class="form-control__help-text"
          aria-hidden=${hasHelpText ? "false" : "true"}
        >
          <slot name="help-text">${this.helpText}</slot>
        </div>
      </div>
    `;
  }
};
LynkInput.styles = [component_styles_default, form_control_styles_default, input_styles_default];
LynkInput.dependencies = {
  "lynk-icon": LynkIcon,
  "lynk-stack": LynkStack,
  "lynk-tooltip": LynkTooltip
};
__decorateClass([
  e2(".input__control")
], LynkInput.prototype, "input", 2);
__decorateClass([
  r()
], LynkInput.prototype, "hasFocus", 2);
__decorateClass([
  n()
], LynkInput.prototype, "title", 2);
__decorateClass([
  n({ reflect: true })
], LynkInput.prototype, "type", 2);
__decorateClass([
  n()
], LynkInput.prototype, "name", 2);
__decorateClass([
  n()
], LynkInput.prototype, "value", 2);
__decorateClass([
  defaultValue()
], LynkInput.prototype, "defaultValue", 2);
__decorateClass([
  n({ reflect: true })
], LynkInput.prototype, "state", 2);
__decorateClass([
  n({ reflect: true })
], LynkInput.prototype, "size", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkInput.prototype, "filled", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkInput.prototype, "pill", 2);
__decorateClass([
  n()
], LynkInput.prototype, "label", 2);
__decorateClass([
  n({ attribute: "help-text" })
], LynkInput.prototype, "helpText", 2);
__decorateClass([
  n({ attribute: "help-tip" })
], LynkInput.prototype, "helpTip", 2);
__decorateClass([
  n({ type: Boolean })
], LynkInput.prototype, "clearable", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkInput.prototype, "disabled", 2);
__decorateClass([
  n()
], LynkInput.prototype, "placeholder", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkInput.prototype, "readonly", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkInput.prototype, "restricted", 2);
__decorateClass([
  n({ attribute: "password-toggle", type: Boolean })
], LynkInput.prototype, "passwordToggle", 2);
__decorateClass([
  n({ attribute: "password-visible", type: Boolean })
], LynkInput.prototype, "passwordVisible", 2);
__decorateClass([
  n({ attribute: "no-spin-buttons", type: Boolean })
], LynkInput.prototype, "noSpinButtons", 2);
__decorateClass([
  n({ attribute: "auto-picker", type: Boolean })
], LynkInput.prototype, "autoPicker", 2);
__decorateClass([
  n({ reflect: true })
], LynkInput.prototype, "form", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkInput.prototype, "required", 2);
__decorateClass([
  n()
], LynkInput.prototype, "pattern", 2);
__decorateClass([
  n({ type: Number })
], LynkInput.prototype, "minlength", 2);
__decorateClass([
  n({ type: Number })
], LynkInput.prototype, "maxlength", 2);
__decorateClass([
  n({ type: Number })
], LynkInput.prototype, "min", 2);
__decorateClass([
  n({ type: Number })
], LynkInput.prototype, "max", 2);
__decorateClass([
  n()
], LynkInput.prototype, "step", 2);
__decorateClass([
  n()
], LynkInput.prototype, "autocapitalize", 2);
__decorateClass([
  n()
], LynkInput.prototype, "autocorrect", 2);
__decorateClass([
  n({ type: String })
], LynkInput.prototype, "autocomplete", 2);
__decorateClass([
  n({ type: Boolean })
], LynkInput.prototype, "autofocus", 2);
__decorateClass([
  n()
], LynkInput.prototype, "enterkeyhint", 2);
__decorateClass([
  n({
    type: Boolean,
    converter: {
      // Allow "true|false" attribute values but keep the property boolean
      fromAttribute: (value) => !value || value === "false" ? false : true,
      toAttribute: (value) => value ? "true" : "false"
    }
  })
], LynkInput.prototype, "spellcheck", 2);
__decorateClass([
  n()
], LynkInput.prototype, "inputmode", 2);
__decorateClass([
  watch(["disabled", "restricted"], { waitUntilFirstUpdate: true })
], LynkInput.prototype, "handleDisabledChange", 1);
__decorateClass([
  watch("step", { waitUntilFirstUpdate: true })
], LynkInput.prototype, "handleStepChange", 1);
__decorateClass([
  watch("value", { waitUntilFirstUpdate: true })
], LynkInput.prototype, "handleValueChange", 1);

export {
  LynkInput
};
