import {
  LynkPageContent
} from "./chunk.Z5N2JEFS.js";
import {
  page_header_styles_default
} from "./chunk.YE7QWULT.js";
import {
  LynkPage
} from "./chunk.F6A2LG7N.js";
import {
  LynkElement,
  n
} from "./chunk.2EAGJTRH.js";
import {
  component_styles_default
} from "./chunk.V6UNAAZX.js";
import {
  x
} from "./chunk.Z3O73C4R.js";
import {
  __decorateClass
} from "./chunk.W27M6RDR.js";

// src/components/page-header/page-header.component.ts
var LynkPageHeader = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.width = "fluid";
  }
  connectedCallback() {
    super.connectedCallback();
    if (!this.slot && this.hasParentLayout()) {
      this.slot = "header";
    }
  }
  // Checks whether the heading is nested into a lynk-page
  hasParentLayout() {
    const parent = this.parentElement;
    return parent instanceof LynkPage;
  }
  render() {
    return x`
      <lynk-page-content width="${this.width}" style="--padding-top: 0; --padding-bottom: 0;">
        <header part="base" class="page-header">
          <slot name="breadcrumb" part="breadcrumb" class="page-header__breadcrumb"></slot>
          <slot name="aux" part="aux" class="page-header__aux"></slot>
          <slot class="page-header__main"></slot>
          <slot name="controls" part="controls" class="page-header__controls"></slot>
          <slot name="tabs" part="tabs" class="page-header__tabs"></slot>
        </header>
      </lynk-page-content>
    `;
  }
};
LynkPageHeader.styles = [component_styles_default, page_header_styles_default];
LynkPageHeader.dependencies = { "lynk-page-content": LynkPageContent, "lynk-page": LynkPage };
__decorateClass([
  n({ reflect: true })
], LynkPageHeader.prototype, "width", 2);

export {
  LynkPageHeader
};
