import {
  textarea_styles_default
} from "./chunk.EVFIGM3H.js";
import {
  LynkTooltip
} from "./chunk.ZYCYIAT3.js";
import {
  l
} from "./chunk.ENUMKHAK.js";
import {
  defaultValue
} from "./chunk.NEEAUM7I.js";
import {
  form_control_styles_default
} from "./chunk.GJLY5JLB.js";
import {
  FormControlController
} from "./chunk.UDRCCTEL.js";
import {
  o
} from "./chunk.J4J6TZIX.js";
import {
  HasSlotController
} from "./chunk.OW5NIGGX.js";
import {
  LynkIcon
} from "./chunk.4HTNL6JH.js";
import {
  watch
} from "./chunk.JMZM2TDT.js";
import {
  e
} from "./chunk.4VMW2AZ2.js";
import {
  LynkElement,
  e as e2,
  n,
  r
} from "./chunk.2EAGJTRH.js";
import {
  component_styles_default
} from "./chunk.V6UNAAZX.js";
import {
  x
} from "./chunk.Z3O73C4R.js";
import {
  __decorateClass
} from "./chunk.W27M6RDR.js";

// src/components/textarea/textarea.component.ts
var LynkTextarea = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.formControlController = new FormControlController(this, {
      assumeInteractionOn: ["ev-blur", "ev-input"]
    });
    this.hasSlotController = new HasSlotController(this, "help-text", "help-tip", "label");
    this.hasFocus = false;
    this.title = "";
    this.name = "";
    this.value = "";
    this.state = "default";
    this.size = "medium";
    this.filled = false;
    this.label = "";
    this.helpText = "";
    this.helpTip = "";
    this.placeholder = "";
    this.rows = 4;
    this.resize = "vertical";
    this.disabled = false;
    this.readonly = false;
    this.restricted = false;
    this.form = "";
    this.required = false;
    this.spellcheck = true;
    this.defaultValue = "";
  }
  /** Gets the validity state object */
  get validity() {
    return this.input.validity;
  }
  /** Gets the validation message */
  get validationMessage() {
    return this.input.validationMessage;
  }
  connectedCallback() {
    super.connectedCallback();
    this.resizeObserver = new ResizeObserver(() => this.setTextareaHeight());
    this.updateComplete.then(() => {
      this.setTextareaHeight();
      this.resizeObserver.observe(this.input);
    });
  }
  firstUpdated() {
    this.formControlController.updateValidity();
  }
  disconnectedCallback() {
    var _a;
    super.disconnectedCallback();
    if (this.input) {
      (_a = this.resizeObserver) == null ? void 0 : _a.unobserve(this.input);
    }
  }
  handleBlur() {
    this.hasFocus = false;
    this.emit("ev-blur");
  }
  handleChange() {
    this.value = this.input.value;
    this.setTextareaHeight();
    this.emit("ev-change");
  }
  handleFocus() {
    this.hasFocus = true;
    this.emit("ev-focus");
  }
  handleInput() {
    this.value = this.input.value;
    this.emit("ev-input");
  }
  handleInvalid(event) {
    this.formControlController.setValidity(false);
    this.formControlController.emitInvalidEvent(event);
  }
  setTextareaHeight() {
    if (this.resize === "auto") {
      this.sizeAdjuster.style.height = `${this.input.clientHeight}px`;
      this.input.style.height = "auto";
      this.input.style.height = `${this.input.scrollHeight}px`;
    } else {
      this.input.style.height = "";
    }
  }
  handleDisabledChange() {
    this.formControlController.setValidity(this.disabled);
  }
  handleRowsChange() {
    this.setTextareaHeight();
  }
  async handleValueChange() {
    await this.updateComplete;
    this.formControlController.updateValidity();
    this.setTextareaHeight();
  }
  /** Sets focus on the textarea. */
  focus(options) {
    this.input.focus(options);
  }
  /** Removes focus from the textarea. */
  blur() {
    this.input.blur();
  }
  /** Selects all the text in the textarea. */
  select() {
    this.input.select();
  }
  /** Gets or sets the textarea's scroll position. */
  scrollPosition(position) {
    if (position) {
      if (typeof position.top === "number") this.input.scrollTop = position.top;
      if (typeof position.left === "number") this.input.scrollLeft = position.left;
      return void 0;
    }
    return {
      top: this.input.scrollTop,
      left: this.input.scrollTop
    };
  }
  /** Sets the start and end positions of the text selection (0-based). */
  setSelectionRange(selectionStart, selectionEnd, selectionDirection = "none") {
    this.input.setSelectionRange(selectionStart, selectionEnd, selectionDirection);
  }
  /** Replaces a range of text with a new string. */
  setRangeText(replacement, start, end, selectMode) {
    this.input.setRangeText(replacement, start, end, selectMode);
    if (this.value !== this.input.value) {
      this.value = this.input.value;
    }
    if (this.value !== this.input.value) {
      this.value = this.input.value;
      this.setTextareaHeight();
    }
  }
  /** Checks for validity but does not show the browser's validation message. */
  checkValidity() {
    return this.input.checkValidity();
  }
  /** Gets the associated form, if one exists. */
  getForm() {
    return this.formControlController.getForm();
  }
  /** Checks for validity and shows the browser's validation message if the control is invalid. */
  reportValidity() {
    return this.input.reportValidity();
  }
  /** Sets a custom validation message. If `message` is not empty, the field will be considered invalid. */
  setCustomValidity(message) {
    this.input.setCustomValidity(message);
    this.formControlController.updateValidity();
  }
  render() {
    const hasLabelSlot = this.hasSlotController.test("label");
    const hasHelpTextSlot = this.hasSlotController.test("help-text");
    const hasHelpTipSlot = this.hasSlotController.test("help-tip");
    const hasLabel = this.label ? true : !!hasLabelSlot;
    const hasHelpText = this.helpText ? true : !!hasHelpTextSlot;
    const hasHelpTip = this.helpTip ? true : !!hasHelpTipSlot;
    return x`
      <div
        part="form-control"
        class=${e({
      "form-control": true,
      "form-control--small": this.size === "small",
      "form-control--medium": this.size === "medium",
      "form-control--large": this.size === "large",
      "form-control--has-label": hasLabel,
      "form-control--has-help-text": hasHelpText,
      "form-control--has-error": this.state === "error" || this.hasAttribute("data-user-invalid"),
      "form-control--has-warning": this.state === "warning",
      "form-control--has-success": this.state === "success"
    })}
      >
        <label
          part="form-control-label"
          class=${e({
      "form-control__label": true,
      "form-control--focused": this.hasFocus
    })}
          for="input"
          aria-hidden=${hasLabel ? "false" : "true"}
        >
          <slot name="label">${this.label}</slot>

          ${this.required ? x`
                <lynk-tooltip content="Required" hoist>
                  <lynk-icon style="font-size: 9px;" name="asterisk" library="system"></lynk-icon>
                </lynk-tooltip>
              ` : ""}
          ${hasHelpTip ? x`
                <lynk-tooltip hoist>
                  <div slot="content">
                    <slot name="help-tip">${this.helpTip}</slot>
                  </div>
                  <lynk-icon style="font-size: 11px;" name="question-fill" library="system"></lynk-icon>
                </lynk-tooltip>
              ` : ""}
        </label>

        <div part="form-control-input" class="form-control-input">
          <div
            part="base"
            class=${e({
      textarea: true,
      "textarea--small": this.size === "small",
      "textarea--medium": this.size === "medium",
      "textarea--large": this.size === "large",
      "textarea--standard": !this.filled,
      "textarea--filled": this.filled,
      "textarea--disabled": this.disabled,
      "textarea--restricted": this.restricted,
      "textarea--focused": this.hasFocus,
      "textarea--empty": !this.value,
      "textarea--resize-none": this.resize === "none",
      "textarea--resize-vertical": this.resize === "vertical",
      "textarea--resize-auto": this.resize === "auto",
      "textarea--has-error": this.state === "error" || this.hasAttribute("data-user-invalid"),
      "textarea--has-warning": this.state === "warning",
      "textarea--has-success": this.state === "success"
    })}
          >
            ${this.restricted ? x`
                  <div
                    part="textarea"
                    aria-describedby="help-text"
                    class="textarea__control textarea__control--restricted"
                  >
                    ${this.value || "None"}
                  </div>
                ` : x`
                  <textarea
                    part="textarea"
                    id="input"
                    class="textarea__control"
                    title=${this.title}
                    name=${o(this.name)}
                    .value=${l(this.value)}
                    ?disabled=${this.disabled}
                    ?readonly=${this.readonly}
                    ?required=${this.required}
                    placeholder=${o(this.placeholder)}
                    rows=${o(this.rows)}
                    minlength=${o(this.minlength)}
                    maxlength=${o(this.maxlength)}
                    autocapitalize=${o(this.autocapitalize)}
                    autocorrect=${o(this.autocorrect)}
                    ?autofocus=${this.autofocus}
                    spellcheck=${o(this.spellcheck)}
                    enterkeyhint=${o(this.enterkeyhint)}
                    inputmode=${o(this.inputmode)}
                    aria-describedby="help-text"
                    @change=${this.handleChange}
                    @input=${this.handleInput}
                    @invalid=${this.handleInvalid}
                    @focus=${this.handleFocus}
                    @blur=${this.handleBlur}
                  ></textarea>
                `}
            <!-- This "adjuster" exists to prevent layout shifting. https://github.com/shoelace-style/shoelace/issues/2180 -->
            <div part="textarea-adjuster" class="textarea__size-adjuster" ?hidden=${this.resize !== "auto"}></div>
          </div>
        </div>

        <div
          part="form-control-help-text"
          id="help-text"
          class="form-control__help-text"
          aria-hidden=${hasHelpText ? "false" : "true"}
        >
          <slot name="help-text">${this.helpText}</slot>
        </div>
      </div>
    `;
  }
};
LynkTextarea.styles = [component_styles_default, form_control_styles_default, textarea_styles_default];
LynkTextarea.dependencies = { "lynk-icon": LynkIcon, "lynk-tooltip": LynkTooltip };
__decorateClass([
  e2(".textarea__control")
], LynkTextarea.prototype, "input", 2);
__decorateClass([
  e2(".textarea__size-adjuster")
], LynkTextarea.prototype, "sizeAdjuster", 2);
__decorateClass([
  r()
], LynkTextarea.prototype, "hasFocus", 2);
__decorateClass([
  n()
], LynkTextarea.prototype, "title", 2);
__decorateClass([
  n()
], LynkTextarea.prototype, "name", 2);
__decorateClass([
  n()
], LynkTextarea.prototype, "value", 2);
__decorateClass([
  n({ reflect: true })
], LynkTextarea.prototype, "state", 2);
__decorateClass([
  n({ reflect: true })
], LynkTextarea.prototype, "size", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkTextarea.prototype, "filled", 2);
__decorateClass([
  n()
], LynkTextarea.prototype, "label", 2);
__decorateClass([
  n({ attribute: "help-text" })
], LynkTextarea.prototype, "helpText", 2);
__decorateClass([
  n({ attribute: "help-tip" })
], LynkTextarea.prototype, "helpTip", 2);
__decorateClass([
  n()
], LynkTextarea.prototype, "placeholder", 2);
__decorateClass([
  n({ type: Number })
], LynkTextarea.prototype, "rows", 2);
__decorateClass([
  n()
], LynkTextarea.prototype, "resize", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkTextarea.prototype, "disabled", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkTextarea.prototype, "readonly", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkTextarea.prototype, "restricted", 2);
__decorateClass([
  n({ reflect: true })
], LynkTextarea.prototype, "form", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkTextarea.prototype, "required", 2);
__decorateClass([
  n({ type: Number })
], LynkTextarea.prototype, "minlength", 2);
__decorateClass([
  n({ type: Number })
], LynkTextarea.prototype, "maxlength", 2);
__decorateClass([
  n()
], LynkTextarea.prototype, "autocapitalize", 2);
__decorateClass([
  n()
], LynkTextarea.prototype, "autocorrect", 2);
__decorateClass([
  n()
], LynkTextarea.prototype, "autocomplete", 2);
__decorateClass([
  n({ type: Boolean })
], LynkTextarea.prototype, "autofocus", 2);
__decorateClass([
  n()
], LynkTextarea.prototype, "enterkeyhint", 2);
__decorateClass([
  n({
    type: Boolean,
    converter: {
      // Allow "true|false" attribute values but keep the property boolean
      fromAttribute: (value) => !value || value === "false" ? false : true,
      toAttribute: (value) => value ? "true" : "false"
    }
  })
], LynkTextarea.prototype, "spellcheck", 2);
__decorateClass([
  n()
], LynkTextarea.prototype, "inputmode", 2);
__decorateClass([
  defaultValue()
], LynkTextarea.prototype, "defaultValue", 2);
__decorateClass([
  watch("disabled", { waitUntilFirstUpdate: true })
], LynkTextarea.prototype, "handleDisabledChange", 1);
__decorateClass([
  watch("rows", { waitUntilFirstUpdate: true })
], LynkTextarea.prototype, "handleRowsChange", 1);
__decorateClass([
  watch("value", { waitUntilFirstUpdate: true })
], LynkTextarea.prototype, "handleValueChange", 1);

export {
  LynkTextarea
};
