import {
  i
} from "./chunk.Z3O73C4R.js";

// src/components/combobox/combobox.styles.ts
var combobox_styles_default = i`
  :host {
    display: block;
  }

  /** The popup */
  .combobox {
    flex: 1 1 auto;
    display: inline-flex;
    width: 100%;
    position: relative;
    vertical-align: middle;
  }

  .combobox::part(popup) {
    z-index: var(--lynk-z-index-dropdown);
  }

  .combobox[data-current-placement^='top']::part(popup) {
    transform-origin: bottom;
  }

  .combobox[data-current-placement^='bottom']::part(popup) {
    transform-origin: top;
  }

  /* Combobox */
  .combobox__inputs {
    flex: 1;
    display: flex;
    width: 100%;
    min-width: 0;
    position: relative;
    align-items: center;
    justify-content: start;
    font-family: var(--lynk-input-font-family);
    font-weight: var(--lynk-input-font-weight);
    letter-spacing: var(--lynk-input-letter-spacing);
    vertical-align: middle;
    overflow: hidden;
    cursor: pointer;
    transition:
      var(--lynk-transition-fast) color,
      var(--lynk-transition-fast) border,
      var(--lynk-transition-fast) box-shadow,
      var(--lynk-transition-fast) background-color;
  }

  .combobox__display-input {
    position: relative;
    width: 100%;
    font: inherit;
    border: none;
    background: none;
    color: var(--lynk-input-color);
    cursor: inherit;
    overflow: hidden;
    padding: 0;
    margin: 0;
    -webkit-appearance: none;
  }

  .combobox__display-input::placeholder {
    color: var(--lynk-input-placeholder-color);
  }

  .combobox:not(.combobox--disabled):hover .combobox__display-input {
    color: var(--lynk-input-color-hover);
  }

  .combobox__display-input:focus {
    outline: none;
  }

  .combobox__value-input {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    padding: 0;
    margin: 0;
    opacity: 0;
    z-index: -1;
  }

  /* Standard combobox */
  .combobox--standard .combobox__inputs {
    background-color: var(--lynk-input-background-color);
    border: solid var(--lynk-input-border-width) var(--lynk-input-border-color);
  }

  .combobox--standard.combobox--disabled .combobox__inputs {
    background-color: var(--lynk-input-background-color-disabled);
    border-color: var(--lynk-input-border-color-disabled);
    color: var(--lynk-input-color-disabled);
    opacity: 0.5;
    cursor: not-allowed;
    outline: none;
  }

  .combobox--standard:not(.combobox--disabled).combobox--open .combobox__inputs,
  .combobox--standard:not(.combobox--disabled).combobox--focused .combobox__inputs {
    background-color: var(--lynk-input-background-color-focus);
    border-color: var(--lynk-input-border-color-focus) !important;
    box-shadow: 0 0 0 var(--lynk-focus-ring-width) var(--lynk-input-focus-ring-color);
  }

  /* Sizes */
  .combobox--small .combobox__inputs {
    border-radius: var(--lynk-input-border-radius-small);
    font-size: var(--lynk-input-font-size-small);
    min-height: var(--lynk-input-height-small);
    padding-block: 0;
    padding-inline: var(--lynk-input-spacing-small);
  }

  .combobox--small .combobox__clear {
    margin-inline-start: var(--lynk-input-spacing-small);
  }

  .combobox--small .combobox__prefix::slotted(*) {
    margin-inline-end: var(--lynk-input-spacing-small);
  }

  .combobox--medium .combobox__inputs {
    border-radius: var(--lynk-input-border-radius-medium);
    font-size: var(--lynk-input-font-size-medium);
    min-height: var(--lynk-input-height-medium);
    padding-block: 0;
    padding-inline: var(--lynk-input-spacing-medium);
  }

  .combobox--medium .combobox__clear {
    margin-inline-start: var(--lynk-input-spacing-medium);
  }

  .combobox--medium .combobox__prefix::slotted(*) {
    margin-inline-end: var(--lynk-input-spacing-medium);
  }

  .combobox--large .combobox__inputs {
    border-radius: var(--lynk-input-border-radius-large);
    font-size: var(--lynk-input-font-size-large);
    min-height: var(--lynk-input-height-large);
    padding-block: 0;
    padding-inline: var(--lynk-input-spacing-large);
  }

  .combobox--large .combobox__clear {
    margin-inline-start: var(--lynk-input-spacing-large);
  }

  .combobox--large .combobox__prefix::slotted(*) {
    margin-inline-end: var(--lynk-input-spacing-large);
  }

  /* Prefix and Suffix */
  .combobox__prefix,
  .combobox__suffix {
    flex: 0;
    display: inline-flex;
    align-items: center;
    color: var(--lynk-input-placeholder-color);
  }

  .combobox__suffix::slotted(*) {
    margin-inline-start: var(--lynk-spacing-small);
  }

  /* Clear button */
  .combobox__clear {
    display: inline-flex;
    align-items: center;
    justify-content: center;
    font-size: inherit;
    color: var(--lynk-input-icon-color);
    border: none;
    background: none;
    padding: 0;
    transition: var(--lynk-transition-fast) color;
    cursor: pointer;
  }

  .combobox__clear:hover {
    color: var(--lynk-input-icon-color-hover);
  }

  .combobox__clear:focus {
    outline: none;
  }

  .combobox--medium .combobox__clear {
    margin-inline-start: var(--lynk-spacing-small);
  }

  /* Expand icon */
  .combobox__expand-icon {
    flex: 0 0 auto;
    display: flex;
    align-items: center;
    transition: var(--lynk-transition-medium) rotate ease;
    rotate: 0;
    margin-inline-start: var(--lynk-spacing-small);
  }

  .combobox--open .combobox__expand-icon {
    rotate: -180deg;
  }

  /* Listbox */
  .combobox__listbox {
    display: block;
    position: relative;
    font-family: var(--lynk-font-sans);
    font-size: var(--lynk-font-size-medium);
    font-weight: var(--lynk-font-weight-normal);
    box-shadow: var(--lynk-shadow-large);
    background: var(--lynk-panel-background-color);
    border: solid var(--lynk-panel-border-width) var(--lynk-panel-border-color);
    border-radius: var(--lynk-border-radius-medium);
    padding-block: var(--lynk-spacing-x-small);
    padding-inline: 0;
    overflow: auto;
    overscroll-behavior: none;

    /* Make sure it adheres to the popup's auto size */
    max-width: var(--auto-size-available-width);
    max-height: var(--auto-size-available-height);
  }

  .combobox__listbox ::slotted(lynk-divider) {
    --spacing: var(--lynk-spacing-x-small);
  }

  .combobox__listbox ::slotted(small) {
    display: block;
    font-size: var(--lynk-font-size-small);
    font-weight: var(--lynk-font-weight-semibold);
    color: var(--lynk-color-neutral-500);
    padding-block: var(--lynk-spacing-2x-small);
    padding-inline: var(--lynk-spacing-x-large);
  }

  /**
   * Invalid user data
   */
  :host([data-user-invalid]) .combobox__inputs {
    border-color: var(--lynk-input-border-color-focus-error);
  }

  :host([data-user-invalid]) .combobox--standard:not(.combobox--disabled).combobox--open .combobox__inputs,
  :host([data-user-invalid]) .combobox--standard:not(.combobox--disabled).combobox--focused .combobox__inputs {
    border-color: var(--lynk-input-border-color-focus-error);
    box-shadow: 0 0 0 var(--lynk-focus-ring-width) var(--lynk-input-focus-ring-error);
  }

  /* Expand icon */
  .combobox__expand-icon {
    color: var(--lynk-color-neutral-950);
    margin-inline-start: var(--lynk-spacing-small);
  }

  /* Change combobox border on hover */
  .combobox:not(.combobox--disabled):hover .combobox__inputs {
    background-color: var(--lynk-input-background-color-hover);
    border-color: var(--lynk-input-border-color-hover);
  }

  /* Prefix and Suffix */

  /* Small */
  .combobox--small .combobox__prefix::slotted(*) {
    margin-inline-end: var(--lynk-spacing-x-small);
  }

  .combobox--small .combobox__suffix::slotted(*) {
    margin-inline-start: var(--lynk-spacing-x-small);
  }

  .combobox--small .combobox__suffix::slotted(lynk-icon),
  .combobox--small .combobox__prefix::slotted(lynk-icon) {
    font-size: var(--lynk-font-size-medium);
  }

  /* Medium */
  .combobox--medium .combobox__prefix::slotted(*) {
    margin-inline-end: var(--lynk-input-spacing-small);
  }

  .combobox--medium .combobox__suffix::slotted(*) {
    margin-inline-start: var(--lynk-input-spacing-small);
  }

  .combobox--medium .combobox__suffix::slotted(lynk-icon),
  .combobox--medium .combobox__prefix::slotted(lynk-icon) {
    font-size: var(--lynk-font-size-x-large);
  }

  /* Large */
  .combobox--large .combobox__prefix::slotted(*) {
    margin-inline-end: var(--lynk-input-spacing-medium);
  }

  .combobox--large .combobox__suffix::slotted(*) {
    margin-inline-start: var(--lynk-input-spacing-medium);
  }

  .combobox--large .combobox__suffix::slotted(lynk-icon),
  .combobox--large .combobox__prefix::slotted(lynk-icon) {
    font-size: var(--lynk-font-size-2x-large);
  }

  .combobox__prefix,
  .combobox__suffix {
    color: var(--lynk-input-help-text-color);
  }

  /* Listbox */
  .combobox__listbox {
    /* @todo: Should be --lynk-border-radius-medium, which should be set to 0 */
    border-radius: var(--lynk-border-radius-none);
    box-shadow: var(--lynk-shadow-medium);
  }

  /**
   * Make sure to hide the lynk-divider for the first lynk-optgroup
   * Note! ::slotted does currently not work with ::part, so we
   * opted for using a css variable here.
   */
  .combobox__listbox ::slotted(lynk-optgroup:first-of-type) {
    --display-divider: none;
  }
`;

export {
  combobox_styles_default
};
