import {
  popover_styles_default
} from "./chunk.IKTH4A4O.js";
import {
  getTabbableBoundary
} from "./chunk.LXDTFLWU.js";
import {
  LynkPopup
} from "./chunk.W3SQO27X.js";
import {
  animateTo,
  stopAnimations,
  waitForEvent
} from "./chunk.ZSWHGSJ7.js";
import {
  getAnimation,
  setDefaultAnimation
} from "./chunk.25TVLSB6.js";
import {
  o
} from "./chunk.J4J6TZIX.js";
import {
  HasSlotController
} from "./chunk.OW5NIGGX.js";
import {
  LocalizeController
} from "./chunk.AFESEORB.js";
import {
  watch
} from "./chunk.JMZM2TDT.js";
import {
  e
} from "./chunk.4VMW2AZ2.js";
import {
  LynkElement,
  e as e2,
  n
} from "./chunk.2EAGJTRH.js";
import {
  component_styles_default
} from "./chunk.V6UNAAZX.js";
import {
  x
} from "./chunk.Z3O73C4R.js";
import {
  __decorateClass
} from "./chunk.W27M6RDR.js";

// src/components/popover/popover.component.ts
var LynkPopover = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.hasSlotController = new HasSlotController(this, "footer");
    this.localize = new LocalizeController(this);
    this.open = false;
    this.label = "";
    this.noHeader = false;
    this.noArrow = false;
    this.clickToHide = false;
    this.placement = "right";
    this.disabled = false;
    this.distance = 10;
    this.skidding = 0;
    this.block = false;
    this.hoist = false;
  }
  connectedCallback() {
    super.connectedCallback();
    this.handleKeyDown = this.handleKeyDown.bind(this);
    this.handleDocumentKeyDown = this.handleDocumentKeyDown.bind(this);
    this.handleDocumentMouseDown = this.handleDocumentMouseDown.bind(this);
    if (!this.containingElement) {
      this.containingElement = this;
    }
  }
  firstUpdated() {
    this.panel.hidden = !this.open;
    if (this.open) {
      this.addOpenListeners();
      this.popup.active = true;
    }
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.removeOpenListeners();
    this.hide();
  }
  focusOnTrigger() {
    const trigger = this.trigger.assignedElements({ flatten: true })[0];
    if (typeof (trigger == null ? void 0 : trigger.focus) === "function") {
      trigger.focus();
    }
  }
  handleKeyDown(event) {
    if (this.open && event.key === "Escape") {
      event.stopPropagation();
      this.hide();
      this.focusOnTrigger();
    }
  }
  handleDocumentKeyDown(event) {
    if (event.key === "Tab") {
      setTimeout(() => {
        var _a, _b, _c;
        const activeElement = ((_a = this.containingElement) == null ? void 0 : _a.getRootNode()) instanceof ShadowRoot ? (_c = (_b = document.activeElement) == null ? void 0 : _b.shadowRoot) == null ? void 0 : _c.activeElement : document.activeElement;
        if (!this.containingElement || (activeElement == null ? void 0 : activeElement.closest(this.containingElement.tagName.toLowerCase())) !== this.containingElement) {
          this.hide();
        }
      });
    }
  }
  handleDocumentMouseDown(event) {
    const path = event.composedPath();
    if (this.clickToHide && this.containingElement && !path.includes(this.containingElement)) {
      this.hide();
    }
  }
  handleTriggerClick() {
    if (this.open) {
      this.hide();
    } else {
      this.show();
    }
  }
  handleTriggerKeyDown(event) {
    if (event.key === "Escape" && this.open) {
      event.stopPropagation();
      this.focusOnTrigger();
      this.hide();
      return;
    }
    if ([" ", "Enter"].includes(event.key)) {
      const target = event.target;
      const isInputTrigger = target.tagName.toLowerCase() === "lynk-input";
      if (!isInputTrigger) {
        event.preventDefault();
      }
      this.handleTriggerClick();
    }
  }
  handleTriggerKeyUp(event) {
    if (event.key === " ") {
      event.preventDefault();
    }
  }
  handleTriggerSlotChange() {
    this.updateAccessibleTrigger();
  }
  //
  // Slotted triggers can be arbitrary content, but we need to link them to the popover panel with `aria-haspopup` and
  // `aria-expanded`. These must be applied to the "accessible trigger" (the tabbable portion of the trigger element
  // that gets slotted in) so screen readers will understand them. The accessible trigger could be the slotted element,
  // a child of the slotted element, or an element in the slotted element's shadow root.
  //
  // For example, the accessible trigger of an <lynk-button> is a <button> located inside its shadow root.
  //
  // To determine this, we assume the first tabbable element in the trigger slot is the "accessible trigger."
  //
  updateAccessibleTrigger() {
    const assignedElements = this.trigger.assignedElements({ flatten: true });
    const accessibleTrigger = assignedElements.find((el) => getTabbableBoundary(el).start);
    let target;
    if (accessibleTrigger) {
      switch (accessibleTrigger.tagName.toLowerCase()) {
        // Lynk buttons have to update the internal button so it's announced correctly by screen readers
        case "lynk-button":
        case "lynk-icon-button":
          target = accessibleTrigger.button;
          break;
        default:
          target = accessibleTrigger;
      }
      target.setAttribute("aria-haspopup", "true");
      target.setAttribute("aria-expanded", this.open ? "true" : "false");
    }
  }
  /** Shows the popover panel. */
  async show() {
    if (this.open) {
      return void 0;
    }
    this.open = true;
    return waitForEvent(this, "ev-after-show");
  }
  /** Hides the popover panel */
  async hide() {
    var _a;
    if (!this.open) {
      return void 0;
    }
    const { activeElement } = document;
    if (activeElement && this.contains(activeElement)) {
      (_a = document.activeElement) == null ? void 0 : _a.blur();
    }
    this.open = false;
    return waitForEvent(this, "ev-after-hide");
  }
  /**
   * Instructs the popover menu to reposition. Useful when the position or size of the trigger changes when the menu
   * is activated.
   */
  reposition() {
    this.popup.reposition();
  }
  addOpenListeners() {
    this.panel.addEventListener("keydown", this.handleKeyDown);
    document.addEventListener("keydown", this.handleDocumentKeyDown);
    document.addEventListener("mousedown", this.handleDocumentMouseDown);
  }
  removeOpenListeners() {
    if (this.panel) {
      this.panel.removeEventListener("keydown", this.handleKeyDown);
    }
    document.removeEventListener("keydown", this.handleDocumentKeyDown);
    document.removeEventListener("mousedown", this.handleDocumentMouseDown);
  }
  async handleOpenChange() {
    if (this.disabled) {
      this.open = false;
      return;
    }
    this.updateAccessibleTrigger();
    if (this.open) {
      this.emit("ev-show");
      this.addOpenListeners();
      const autoFocusTarget = this.querySelector("[autofocus]");
      if (autoFocusTarget) {
        autoFocusTarget.removeAttribute("autofocus");
      }
      await stopAnimations(this);
      this.panel.hidden = false;
      this.popup.active = true;
      const { keyframes, options } = getAnimation(this, "popover.show", { dir: this.localize.dir() });
      await animateTo(this.popup.popup, keyframes, options);
      if (autoFocusTarget) {
        autoFocusTarget.focus({ preventScroll: true });
        autoFocusTarget.setAttribute("autofocus", "");
      }
      this.emit("ev-after-show");
    } else {
      this.emit("ev-hide");
      this.removeOpenListeners();
      await stopAnimations(this);
      const { keyframes, options } = getAnimation(this, "popover.hide", { dir: this.localize.dir() });
      await animateTo(this.popup.popup, keyframes, options);
      this.panel.hidden = true;
      this.popup.active = false;
      this.emit("ev-after-hide");
    }
  }
  render() {
    return x`
      <lynk-popup
        part="base"
        id="popover"
        placement=${this.placement}
        distance=${this.distance}
        skidding=${this.skidding}
        strategy=${this.hoist ? "fixed" : "absolute"}
        flip
        shift
        ?arrow=${!this.noArrow}
        auto-size="vertical"
        auto-size-padding="10"
        class=${e({
      popover: true,
      "popover--open": this.open,
      "popover--has-footer": this.hasSlotController.test("footer")
    })}
      >
        <slot
          name="trigger"
          slot="anchor"
          part="trigger"
          class="popover__trigger"
          @click=${this.handleTriggerClick}
          @keydown=${this.handleTriggerKeyDown}
          @keyup=${this.handleTriggerKeyUp}
          @slotchange=${this.handleTriggerSlotChange}
        ></slot>

        <div
          part="panel"
          class="popover__panel"
          role="popover"
          aria-hidden=${this.open ? "false" : "true"}
          aria-label=${o(this.noHeader ? this.label : void 0)}
          aria-labelledby=${o(!this.noHeader ? "title" : void 0)}
          tabindex="0"
        >
          ${!this.noHeader ? x`
                <header part="header" class="popover__header">
                  <h2 part="title" class="popover__title" id="title">
                    <slot name="label"> ${this.label.length > 0 ? this.label : String.fromCharCode(65279)} </slot>
                  </h2>
                  <lynk-icon-button
                    part="close-button"
                    exportparts="base:close-button__base"
                    class="popover__close"
                    name="x-lg"
                    label=${this.localize.term("close")}
                    library="system"
                    @click="${() => this.hide()}"
                  ></lynk-icon-button>
                </header>
              ` : ""}

          <slot part="body" class="popover__body"></slot>

          ${this.hasSlotController.test("footer") ? x`
                <footer part="footer" class="popover__footer">
                  <slot name="footer"></slot>
                </footer>
              ` : ""}
        </div>
      </lynk-popup>
    `;
  }
};
LynkPopover.styles = [component_styles_default, popover_styles_default];
LynkPopover.dependencies = { "lynk-popup": LynkPopup };
__decorateClass([
  e2(".popover")
], LynkPopover.prototype, "popup", 2);
__decorateClass([
  e2(".popover__trigger")
], LynkPopover.prototype, "trigger", 2);
__decorateClass([
  e2(".popover__panel")
], LynkPopover.prototype, "panel", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkPopover.prototype, "open", 2);
__decorateClass([
  n({ reflect: true })
], LynkPopover.prototype, "label", 2);
__decorateClass([
  n({ attribute: "no-header", type: Boolean, reflect: true })
], LynkPopover.prototype, "noHeader", 2);
__decorateClass([
  n({ attribute: "no-arrow", type: Boolean, reflect: true })
], LynkPopover.prototype, "noArrow", 2);
__decorateClass([
  n({ attribute: "click-to-hide", type: Boolean, reflect: true })
], LynkPopover.prototype, "clickToHide", 2);
__decorateClass([
  n({ reflect: true })
], LynkPopover.prototype, "placement", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkPopover.prototype, "disabled", 2);
__decorateClass([
  n({ attribute: false })
], LynkPopover.prototype, "containingElement", 2);
__decorateClass([
  n({ type: Number })
], LynkPopover.prototype, "distance", 2);
__decorateClass([
  n({ type: Number })
], LynkPopover.prototype, "skidding", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkPopover.prototype, "block", 2);
__decorateClass([
  n({ type: Boolean })
], LynkPopover.prototype, "hoist", 2);
__decorateClass([
  watch("open", { waitUntilFirstUpdate: true })
], LynkPopover.prototype, "handleOpenChange", 1);
setDefaultAnimation("popover.show", {
  keyframes: [
    { opacity: 0, scale: 0.9 },
    { opacity: 1, scale: 1 }
  ],
  options: { duration: 100, easing: "ease" }
});
setDefaultAnimation("popover.hide", {
  keyframes: [
    { opacity: 1, scale: 1 },
    { opacity: 0, scale: 0.9 }
  ],
  options: { duration: 100, easing: "ease" }
});

export {
  LynkPopover
};
