import {
  tag_styles_default
} from "./chunk.7SZPNZXC.js";
import {
  LynkIconButton
} from "./chunk.OI2YJPCU.js";
import {
  LocalizeController
} from "./chunk.AFESEORB.js";
import {
  e
} from "./chunk.4VMW2AZ2.js";
import {
  LynkElement,
  n
} from "./chunk.2EAGJTRH.js";
import {
  component_styles_default
} from "./chunk.V6UNAAZX.js";
import {
  x
} from "./chunk.Z3O73C4R.js";
import {
  __decorateClass
} from "./chunk.W27M6RDR.js";

// src/components/tag/tag.component.ts
var LynkTag = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.localize = new LocalizeController(this);
    this.size = "medium";
    this.pill = false;
    this.removable = false;
    this.pulse = false;
    this.badge = false;
  }
  handleRemoveClick() {
    this.emit("ev-remove");
  }
  render() {
    return x`
      <span
        part="base"
        class=${e({
      tag: true,
      // Types
      "tag--primary": this.type === "primary",
      "tag--success": this.type === "success",
      "tag--neutral": this.type === "neutral",
      "tag--warning": this.type === "warning",
      "tag--danger": this.type === "danger",
      "tag--accent": this.type === "accent",
      "tag--info": this.type === "info",
      "tag--text": this.type === "text",
      // Sizes
      "tag--tiny": this.size === "tiny",
      "tag--small": this.size === "small",
      "tag--medium": this.size === "medium",
      "tag--large": this.size === "large",
      // Modifiers
      "tag--pill": this.pill,
      "tag--pulse": this.pulse,
      "tag--badge": this.badge,
      "tag--removable": this.removable
    })}
      >
        <slot part="content" class="tag__content"></slot>

        ${this.removable ? x`
              <lynk-icon-button
                part="remove-button"
                exportparts="base:remove-button__base"
                name="x"
                library="system"
                label=${this.localize.term("remove")}
                class="tag__remove"
                @click=${this.handleRemoveClick}
              ></lynk-icon-button>
            ` : ""}
      </span>
    `;
  }
};
LynkTag.styles = [component_styles_default, tag_styles_default];
LynkTag.dependencies = { "lynk-icon-button": LynkIconButton };
__decorateClass([
  n({ reflect: true })
], LynkTag.prototype, "type", 2);
__decorateClass([
  n({ reflect: true })
], LynkTag.prototype, "size", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkTag.prototype, "pill", 2);
__decorateClass([
  n({ type: Boolean })
], LynkTag.prototype, "removable", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkTag.prototype, "pulse", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkTag.prototype, "badge", 2);

export {
  LynkTag
};
