import {
  grid_styles_default
} from "./chunk.KRMTFPTC.js";
import {
  LynkElement,
  n
} from "./chunk.2EAGJTRH.js";
import {
  component_styles_default
} from "./chunk.V6UNAAZX.js";
import {
  x
} from "./chunk.Z3O73C4R.js";
import {
  __decorateClass
} from "./chunk.W27M6RDR.js";

// src/components/grid/grid.component.ts
var LynkGrid = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.container = false;
    this.item = false;
    this.gap = "base";
  }
  getBreakpointClasses() {
    return this.span ? this.span.split(",").map((key) => `span--${key.trim()}`).join(" ") : "";
  }
  render() {
    const containerClass = this.container ? "grid" : null;
    const directionClass = this.direction && this.container ? `grid--${this.direction}` : null;
    const justifyClass = this.justify && this.container ? `grid--justify-${this.justify}` : null;
    const alignClass = this.align && this.container ? `grid--align-${this.align}` : null;
    const itemClass = this.item ? "grid__item" : null;
    const spanClass = this.span && this.item ? this.getBreakpointClasses() : null;
    const classList = [containerClass, directionClass, justifyClass, alignClass, itemClass, spanClass];
    return x`
      <div part="base" class="${classList.join(" ")}" style="--gap: var(--lynk-spacing-${this.gap})">
        <slot></slot>
      </div>
    `;
  }
};
LynkGrid.styles = [component_styles_default, grid_styles_default];
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkGrid.prototype, "container", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkGrid.prototype, "item", 2);
__decorateClass([
  n({ reflect: true })
], LynkGrid.prototype, "direction", 2);
__decorateClass([
  n({ reflect: true })
], LynkGrid.prototype, "justify", 2);
__decorateClass([
  n({ reflect: true })
], LynkGrid.prototype, "align", 2);
__decorateClass([
  n({ reflect: true })
], LynkGrid.prototype, "span", 2);
__decorateClass([
  n({ reflect: true })
], LynkGrid.prototype, "gap", 2);

export {
  LynkGrid
};
