import {
  i
} from "./chunk.Z3O73C4R.js";

// src/components/page-sidebar/page-sidebar.styles.ts
var page_sidebar_styles_default = i`
  :host {
    display: contents;
    --width: 240px;
    --collapsed-width: 24px;
    --header-spacing: var(--lynk-spacing-large);
    --body-spacing: var(--lynk-spacing-large);
    --footer-spacing: var(--lynk-spacing-large);
    --background-color: var(--lynk-color-neutral-0);
  }

  .page-sidebar {
    position: relative;
    display: flex;
    min-width: var(--collapsed-width);
    max-width: 0;
    width: var(--width);
    max-height: 100%;
    height: 100%;
    background-color: var(--background-color);
    transition: max-width var(--lynk-transition-medium);
  }

  .page-sidebar.page-sidebar--open {
    max-width: var(--width);
  }

  .page-sidebar__container {
    width: var(--width);
    height: 100%;
    overflow: hidden;
    display: flex;
    flex: 1;
    flex-direction: column;
    pointer-events: none;
    opacity: 0;
    transition: opacity var(--lynk-transition-medium);
  }

  .page-sidebar--open .page-sidebar__container {
    opacity: 1;
    pointer-events: auto;
    transition-delay: var(--lynk-transition-fast);
  }

  .page-sidebar__nav {
    display: inline-block;
  }

  .page-sidebar--open .page-sidebar__nav {
    border-right: 1px solid var(--lynk-color-neutral-100);
  }

  .page-sidebar.page-sidebar--left {
    border-inline-end: 1px solid var(--lynk-color-neutral-200);
    height: 100%;
  }

  .page-sidebar.page-sidebar--right {
    border-inline-start: 1px solid var(--lynk-color-neutral-200);
    height: 100%;
  }

  .page-sidebar.page-sidebar--right-inset,
  .page-sidebar.page-sidebar--left-inset {
    border-radius: 8px;
    border: 1px solid var(--lynk-color-neutral-200);
    margin: var(--lynk-spacing-base) auto;
    height: calc(100% - 32px);
  }

  .page-sidebar.page-sidebar--left-inset {
    margin-left: var(--lynk-page-margin);
    margin-right: 0;
  }

  .page-sidebar.page-sidebar--right-inset {
    margin-right: var(--lynk-page-margin);
    margin-left: 0;
  }

  .page-sidebar__header {
    display: none;
  }

  .page-sidebar--has-header .page-sidebar__header {
    display: flex;
    padding: var(--header-spacing);
    gap: var(--header-spacing);
    align-items: center;
  }

  .page-sidebar__title {
    flex: 1 1 auto;
    font: inherit;
    font-size: var(--lynk-font-size-base);
    font-weight: var(--lynk-font-weight-semibold);
    line-height: var(--lynk-line-height-dense);
    margin: 0;
  }

  .page-sidebar__header-actions {
    flex-shrink: 0;
    display: flex;
    flex-wrap: wrap;
    justify-content: end;
    gap: var(--lynk-spacing-2x-small);
  }

  .page-sidebar__header-actions lynk-button,
  .page-sidebar__header-actions ::slotted(lynk-button) {
    flex: 0 0 auto;
    display: flex;
    align-items: center;
    margin: 0;
    font-size: var(--lynk-font-size-medium);
  }

  .page-sidebar__body {
    flex: 1 1 auto;
    padding: var(--body-spacing);
    overflow: hidden auto;
    display: block;
    -webkit-overflow-scrolling: touch;
  }

  .page-sidebar__toggle {
    position: absolute;
    top: var(--header-spacing);
    z-index: 1;
  }

  .page-sidebar__toggle.page-sidebar__toggle--center {
    top: 50%;
  }

  .page-sidebar__toggle.page-sidebar__toggle--bottom {
    top: unset;
    bottom: var(--footer-spacing);
  }

  .page-sidebar__toggle.page-sidebar__toggle--hidden {
    display: none;
  }

  .page-sidebar--left .page-sidebar__toggle,
  .page-sidebar--left-inset .page-sidebar__toggle {
    right: -13px;
  }

  .page-sidebar--right .page-sidebar__toggle,
  .page-sidebar--right-inset .page-sidebar__toggle {
    left: -13px;
    rotate: 180deg;
  }

  .page-sidebar__footer {
    padding: var(--footer-spacing);
  }

  .page-sidebar__footer ::slotted(lynk-button:not(:last-of-type)) {
    margin-inline-end: var(--lynk-spacing-x-small);
  }

  .page-sidebar:not(.page-sidebar--has-footer) .page-sidebar__footer {
    display: none;
  }
`;

export {
  page_sidebar_styles_default
};
