import {
  radio_button_styles_default
} from "./chunk.5CZ3SGVX.js";
import {
  u
} from "./chunk.RVFZXBWN.js";
import {
  o
} from "./chunk.J4J6TZIX.js";
import {
  HasSlotController
} from "./chunk.OW5NIGGX.js";
import {
  watch
} from "./chunk.JMZM2TDT.js";
import {
  e
} from "./chunk.4VMW2AZ2.js";
import {
  LynkElement,
  e as e2,
  n,
  r
} from "./chunk.2EAGJTRH.js";
import {
  component_styles_default
} from "./chunk.V6UNAAZX.js";
import {
  __decorateClass
} from "./chunk.W27M6RDR.js";

// src/components/radio-button/radio-button.component.ts
var LynkRadioButton = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.hasSlotController = new HasSlotController(this, "[default]", "prefix", "suffix");
    this.hasFocus = false;
    this.checked = false;
    this.disabled = false;
    this.size = "medium";
    this.pill = false;
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "presentation");
  }
  handleBlur() {
    this.hasFocus = false;
    this.emit("ev-blur");
  }
  handleClick(e3) {
    if (this.disabled) {
      e3.preventDefault();
      e3.stopPropagation();
      return;
    }
    this.checked = true;
  }
  handleFocus() {
    this.hasFocus = true;
    this.emit("ev-focus");
  }
  handleDisabledChange() {
    this.setAttribute("aria-disabled", this.disabled ? "true" : "false");
  }
  /** Sets focus on the radio button. */
  focus(options) {
    this.input.focus(options);
  }
  /** Removes focus from the button. */
  blur() {
    this.input.blur();
  }
  render() {
    return u`
      <div part="base" role="presentation">
        <button
          part="${`button${this.checked ? " button--checked" : ""}`}"
          role="radio"
          aria-checked="${this.checked}"
          class=${e({
      button: true,
      "button--standard": true,
      "button--default": true,
      "button--tiny": this.size === "tiny",
      "button--small": this.size === "small",
      "button--medium": this.size === "medium",
      "button--large": this.size === "large",
      "button--checked": this.checked,
      "button--disabled": this.disabled,
      "button--focused": this.hasFocus,
      "button--pill": this.pill,
      "button--has-label": this.hasSlotController.test("[default]"),
      "button--has-prefix": this.hasSlotController.test("prefix"),
      "button--has-suffix": this.hasSlotController.test("suffix")
    })}
          aria-disabled=${this.disabled}
          type="button"
          value=${o(this.value)}
          tabindex="${this.checked ? "0" : "-1"}"
          @blur=${this.handleBlur}
          @focus=${this.handleFocus}
          @click=${this.handleClick}
        >
          <slot name="prefix" part="prefix" class="button__prefix"></slot>
          <slot part="label" class="button__label"></slot>
          <slot name="suffix" part="suffix" class="button__suffix"></slot>
        </button>
      </div>
    `;
  }
};
LynkRadioButton.styles = [component_styles_default, radio_button_styles_default];
__decorateClass([
  e2(".button")
], LynkRadioButton.prototype, "input", 2);
__decorateClass([
  e2(".hidden-input")
], LynkRadioButton.prototype, "hiddenInput", 2);
__decorateClass([
  r()
], LynkRadioButton.prototype, "hasFocus", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkRadioButton.prototype, "checked", 2);
__decorateClass([
  n()
], LynkRadioButton.prototype, "value", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkRadioButton.prototype, "disabled", 2);
__decorateClass([
  n({ reflect: true })
], LynkRadioButton.prototype, "size", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkRadioButton.prototype, "pill", 2);
__decorateClass([
  watch("disabled", { waitUntilFirstUpdate: true })
], LynkRadioButton.prototype, "handleDisabledChange", 1);

export {
  LynkRadioButton
};
