import {
  button_group_styles_default
} from "./chunk.ORG56WJX.js";
import {
  LynkElement,
  e,
  n,
  r
} from "./chunk.2EAGJTRH.js";
import {
  component_styles_default
} from "./chunk.V6UNAAZX.js";
import {
  x
} from "./chunk.Z3O73C4R.js";
import {
  __decorateClass
} from "./chunk.W27M6RDR.js";

// src/components/button-group/button-group.component.ts
var LynkButtonGroup = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.disableRole = false;
    this.label = "";
  }
  handleFocus(event) {
    const button = findButton(event.target);
    button == null ? void 0 : button.toggleAttribute("data-lynk-button-group__button--focus", true);
  }
  handleBlur(event) {
    const button = findButton(event.target);
    button == null ? void 0 : button.toggleAttribute("data-lynk-button-group__button--focus", false);
  }
  handleMouseOver(event) {
    const button = findButton(event.target);
    button == null ? void 0 : button.toggleAttribute("data-lynk-button-group__button--hover", true);
  }
  handleMouseOut(event) {
    const button = findButton(event.target);
    button == null ? void 0 : button.toggleAttribute("data-lynk-button-group__button--hover", false);
  }
  handleSlotChange() {
    const slottedElements = [...this.defaultSlot.assignedElements({ flatten: true })];
    slottedElements.forEach((el) => {
      const index = slottedElements.indexOf(el);
      const button = findButton(el);
      if (button) {
        button.toggleAttribute("data-lynk-button-group__button", true);
        button.toggleAttribute("data-lynk-button-group__button--first", index === 0);
        button.toggleAttribute(
          "data-lynk-button-group__button--inner",
          index > 0 && index < slottedElements.length - 1
        );
        button.toggleAttribute("data-lynk-button-group__button--last", index === slottedElements.length - 1);
        button.toggleAttribute(
          "data-lynk-button-group__button--radio",
          button.tagName.toLowerCase() === "lynk-radio-button"
        );
      }
    });
  }
  render() {
    return x`
      <div
        part="base"
        class="button-group"
        role="${this.disableRole ? "presentation" : "group"}"
        aria-label=${this.label}
        @focusout=${this.handleBlur}
        @focusin=${this.handleFocus}
        @mouseover=${this.handleMouseOver}
        @mouseout=${this.handleMouseOut}
      >
        <slot @slotchange=${this.handleSlotChange}></slot>
      </div>
    `;
  }
};
LynkButtonGroup.styles = [component_styles_default, button_group_styles_default];
__decorateClass([
  e("slot")
], LynkButtonGroup.prototype, "defaultSlot", 2);
__decorateClass([
  r()
], LynkButtonGroup.prototype, "disableRole", 2);
__decorateClass([
  n()
], LynkButtonGroup.prototype, "label", 2);
function findButton(el) {
  var _a;
  const selector = "lynk-button, lynk-radio-button";
  return (_a = el.closest(selector)) != null ? _a : el.querySelector(selector);
}

export {
  LynkButtonGroup
};
