import {
  nav_group_styles_default
} from "./chunk.UXXYMTUK.js";
import {
  HasSlotController
} from "./chunk.OW5NIGGX.js";
import {
  watch
} from "./chunk.JMZM2TDT.js";
import {
  e
} from "./chunk.4VMW2AZ2.js";
import {
  LynkElement,
  n,
  r
} from "./chunk.2EAGJTRH.js";
import {
  component_styles_default
} from "./chunk.V6UNAAZX.js";
import {
  x
} from "./chunk.Z3O73C4R.js";
import {
  __decorateClass
} from "./chunk.W27M6RDR.js";

// src/components/nav-group/nav-group.component.ts
var LynkNavGroup = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.hasSlotController = new HasSlotController(this, "heading");
    this.squished = false;
    this.heading = "";
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "group");
  }
  firstUpdated() {
    this.handleSquished();
  }
  handleSquished() {
    if (this.squished) {
      this.setAttribute("squished", this.squished ? "true" : "false");
    } else {
      this.removeAttribute("squished");
    }
  }
  render() {
    const hasHeadingSlot = this.hasSlotController.test("heading");
    const hasHeading = this.heading ? true : !!hasHeadingSlot;
    return x`
      <div
        id="heading"
        part="base"
        class=${e({
      "nav-group__heading": true
    })}
        aria-hidden=${hasHeading ? "false" : "true"}
      >
        <slot name="heading">${this.heading}</slot>
      </div>

      <slot
        part="children"
        class=${e({
      "nav-group": true,
      "nav-group--squished": this.squished
    })}
      ></slot>
    `;
  }
};
LynkNavGroup.styles = [component_styles_default, nav_group_styles_default];
__decorateClass([
  r()
], LynkNavGroup.prototype, "squished", 2);
__decorateClass([
  n({ reflect: true })
], LynkNavGroup.prototype, "heading", 2);
__decorateClass([
  watch("squished", { waitUntilFirstUpdate: true })
], LynkNavGroup.prototype, "handleSquished", 1);

export {
  LynkNavGroup
};
