import {
  icon_button_styles_default
} from "./chunk.Y6APGER2.js";
import {
  i,
  u
} from "./chunk.RVFZXBWN.js";
import {
  o
} from "./chunk.J4J6TZIX.js";
import {
  HasSlotController
} from "./chunk.OW5NIGGX.js";
import {
  LynkIcon
} from "./chunk.4HTNL6JH.js";
import {
  e
} from "./chunk.4VMW2AZ2.js";
import {
  LynkElement,
  e as e2,
  n,
  r
} from "./chunk.2EAGJTRH.js";
import {
  component_styles_default
} from "./chunk.V6UNAAZX.js";
import {
  __decorateClass
} from "./chunk.W27M6RDR.js";

// src/components/icon-button/icon-button.component.ts
var LynkIconButton = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.hasFocus = false;
    this.hasSlotController = new HasSlotController(this, "prefix", "suffix");
    this.color = "default";
    this.label = "";
    this.disabled = false;
  }
  /** Simulates a click on the icon button. */
  click() {
    this.button.click();
  }
  /** Sets focus on the icon button. */
  focus(options) {
    this.button.focus(options);
  }
  /** Removes focus from the icon button. */
  blur() {
    this.button.blur();
  }
  handleBlur() {
    this.hasFocus = false;
    this.emit("ev-blur");
  }
  handleFocus() {
    this.hasFocus = true;
    this.emit("ev-focus");
  }
  handleClick(event) {
    if (this.disabled) {
      event.preventDefault();
      event.stopPropagation();
      return;
    }
    this.emit("ev-click");
  }
  render() {
    const isLink = this.href ? true : false;
    const tag = isLink ? i`a` : i`button`;
    return u`
      <${tag}
        part="base"
        class=${e({
      "icon-button": true,
      "icon-button--default": this.color === "default",
      "icon-button--primary": this.color === "primary",
      "icon-button--success": this.color === "success",
      "icon-button--neutral": this.color === "neutral",
      "icon-button--warning": this.color === "warning",
      "icon-button--danger": this.color === "danger",
      "icon-button--disabled": !isLink && this.disabled,
      "icon-button--focused": this.hasFocus,
      "icon-button--has-prefix": this.hasSlotController.test("prefix"),
      "icon-button--has-suffix": this.hasSlotController.test("suffix")
    })}
        ?disabled=${o(isLink ? void 0 : this.disabled)}
        type=${o(isLink ? void 0 : "button")}
        href=${o(isLink ? this.href : void 0)}
        target=${o(isLink ? this.target : void 0)}
        download=${o(isLink ? this.download : void 0)}
        rel=${o(isLink && this.target ? "noreferrer noopener" : void 0)}
        role=${o(isLink ? void 0 : "button")}
        aria-disabled=${this.disabled ? "true" : "false"}
        aria-label="${this.label}"
        tabindex=${this.disabled ? "-1" : "0"}
        @blur=${this.handleBlur}
        @focus=${this.handleFocus}
        @click=${this.handleClick}
      >
        <span part="prefix" class="icon-button__prefix">
          <slot name="prefix"></slot>
        </span>
        <lynk-icon
          class="icon-button__icon"
          name=${o(this.name)}
          library=${o(this.library)}
          src=${o(this.src)}
          aria-hidden="true"
        ></lynk-icon>
        <span part="suffix" class="icon-button__suffix">
          <slot name="suffix"></slot>
        </span>
      </${tag}>
    `;
  }
};
LynkIconButton.styles = [component_styles_default, icon_button_styles_default];
LynkIconButton.dependencies = { "lynk-icon": LynkIcon };
__decorateClass([
  e2(".icon-button")
], LynkIconButton.prototype, "button", 2);
__decorateClass([
  r()
], LynkIconButton.prototype, "hasFocus", 2);
__decorateClass([
  n({ reflect: true })
], LynkIconButton.prototype, "color", 2);
__decorateClass([
  n()
], LynkIconButton.prototype, "name", 2);
__decorateClass([
  n()
], LynkIconButton.prototype, "library", 2);
__decorateClass([
  n()
], LynkIconButton.prototype, "src", 2);
__decorateClass([
  n()
], LynkIconButton.prototype, "href", 2);
__decorateClass([
  n()
], LynkIconButton.prototype, "target", 2);
__decorateClass([
  n()
], LynkIconButton.prototype, "download", 2);
__decorateClass([
  n()
], LynkIconButton.prototype, "label", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkIconButton.prototype, "disabled", 2);

export {
  LynkIconButton
};
