import {
  table_styles_default
} from "./chunk.RXY33ZYX.js";
import {
  TableSortDirection
} from "./chunk.WGKOAZH2.js";
import {
  o as o2
} from "./chunk.J4J6TZIX.js";
import {
  M,
  m,
  p,
  r,
  v
} from "./chunk.2IFQF753.js";
import {
  e,
  i,
  t
} from "./chunk.MZ73UT6D.js";
import {
  LynkElement,
  n,
  o
} from "./chunk.2EAGJTRH.js";
import {
  component_styles_default
} from "./chunk.V6UNAAZX.js";
import {
  T,
  x
} from "./chunk.Z3O73C4R.js";
import {
  __decorateClass
} from "./chunk.W27M6RDR.js";

// node_modules/.pnpm/lit-html@3.2.1/node_modules/lit-html/directives/repeat.js
var u = (e2, s, t2) => {
  const r2 = /* @__PURE__ */ new Map();
  for (let l = s; l <= t2; l++) r2.set(e2[l], l);
  return r2;
};
var c = e(class extends i {
  constructor(e2) {
    if (super(e2), e2.type !== t.CHILD) throw Error("repeat() can only be used in text expressions");
  }
  dt(e2, s, t2) {
    let r2;
    void 0 === t2 ? t2 = s : void 0 !== s && (r2 = s);
    const l = [], o3 = [];
    let i2 = 0;
    for (const s2 of e2) l[i2] = r2 ? r2(s2, i2) : i2, o3[i2] = t2(s2, i2), i2++;
    return { values: o3, keys: l };
  }
  render(e2, s, t2) {
    return this.dt(e2, s, t2).values;
  }
  update(s, [t2, r2, c2]) {
    var _a;
    const d = p(s), { values: p2, keys: a } = this.dt(t2, r2, c2);
    if (!Array.isArray(d)) return this.ut = a, p2;
    const h = (_a = this.ut) != null ? _a : this.ut = [], v2 = [];
    let m2, y, x2 = 0, j = d.length - 1, k = 0, w = p2.length - 1;
    for (; x2 <= j && k <= w; ) if (null === d[x2]) x2++;
    else if (null === d[j]) j--;
    else if (h[x2] === a[k]) v2[k] = v(d[x2], p2[k]), x2++, k++;
    else if (h[j] === a[w]) v2[w] = v(d[j], p2[w]), j--, w--;
    else if (h[x2] === a[w]) v2[w] = v(d[x2], p2[w]), r(s, v2[w + 1], d[x2]), x2++, w--;
    else if (h[j] === a[k]) v2[k] = v(d[j], p2[k]), r(s, d[x2], d[j]), j--, k++;
    else if (void 0 === m2 && (m2 = u(a, k, w), y = u(h, x2, j)), m2.has(h[x2])) if (m2.has(h[j])) {
      const e2 = y.get(a[k]), t3 = void 0 !== e2 ? d[e2] : null;
      if (null === t3) {
        const e3 = r(s, d[x2]);
        v(e3, p2[k]), v2[k] = e3;
      } else v2[k] = v(t3, p2[k]), r(s, d[x2], t3), d[e2] = null;
      k++;
    } else M(d[j]), j--;
    else M(d[x2]), x2++;
    for (; k <= w; ) {
      const e2 = r(s, v2[w + 1]);
      v(e2, p2[k]), v2[k++] = e2;
    }
    for (; x2 <= j; ) {
      const e2 = d[x2++];
      null !== e2 && M(e2);
    }
    return this.ut = a, m(s, v2), T;
  }
});

// src/components/table/table.component.ts
var LynkTable = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.cols = [];
    this.rows = [];
    this.custom = false;
  }
  connectedCallback() {
    super.connectedCallback();
    this.addEventListener("ev-table-sort", this.handleSort);
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.removeEventListener("ev-table-sort", this.handleSort);
  }
  handleSort(event) {
    let direction;
    this.assignedHead.forEach((head) => {
      head.querySelectorAll("lynk-tr").forEach((row) => {
        row.querySelectorAll("lynk-th").forEach((th) => {
          if (th.key === event.detail.key) {
            switch (TableSortDirection[th.sortDirection]) {
              case TableSortDirection[1 /* DESC */]:
                th.sortDirection = -1 /* ASC */;
                break;
              case TableSortDirection[-1 /* ASC */]:
              case TableSortDirection[0 /* NONE */]:
                th.sortDirection = 1 /* DESC */;
                break;
            }
            direction = th.sortDirection;
          } else {
            th.sortDirection = 0 /* NONE */;
          }
        });
      });
    });
    this.rows.sort((rowA, rowB) => {
      let val1 = rowA[event.detail.key];
      let val2 = rowB[event.detail.key];
      if (val1 === null || val1 === void 0) val1 = "";
      if (val2 === null || val2 === void 0) val2 = "";
      if (!isNaN(parseFloat(val1)) && !isNaN(parseFloat(val2))) {
        return (Number(val1) - Number(val2)) * direction;
      }
      const str1 = val1.toString();
      const str2 = val2.toString();
      return str1.localeCompare(str2) * direction;
    });
    this.requestUpdate();
  }
  render() {
    return x`
      <slot part="base">
        <lynk-colgroup> ${c(this.cols, (col) => x`<lynk-col class="${col.key}"></lynk-col>`)} </lynk-colgroup>
        <lynk-thead>
          <lynk-tr>
            ${c(
      this.cols,
      (col) => x`
                <lynk-th
                  key="${col.key}"
                  sort-direction=${o2(col.sortDirection ? col.sortDirection : void 0)}
                  ?sortable=${o2(col.sortable ? col.sortable : void 0)}
                  >${col.title}</lynk-th
                >
              `
    )}
          </lynk-tr>
        </lynk-thead>
        <lynk-tbody>
          ${c(
      this.rows,
      (row) => x` <lynk-tr> ${c(this.cols, (col) => x`<lynk-td>${row[col.key]}</lynk-td>`)} </lynk-tr>`
    )}
        </lynk-tbody>
      </slot>
    `;
  }
};
LynkTable.styles = [component_styles_default, table_styles_default];
__decorateClass([
  n()
], LynkTable.prototype, "cols", 2);
__decorateClass([
  n()
], LynkTable.prototype, "rows", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkTable.prototype, "custom", 2);
__decorateClass([
  o({ selector: "lynk-thead", flatten: true })
], LynkTable.prototype, "assignedHead", 2);
__decorateClass([
  o({ selector: "lynk-tbody", flatten: true })
], LynkTable.prototype, "assignedBody", 2);

export {
  LynkTable
};
/*! Bundled license information:

lit-html/directives/repeat.js:
  (**
   * @license
   * Copyright 2017 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)
*/
