import {
  switch_styles_default
} from "./chunk.M73F6LH3.js";
import {
  l
} from "./chunk.ENUMKHAK.js";
import {
  defaultValue
} from "./chunk.NEEAUM7I.js";
import {
  form_control_styles_default
} from "./chunk.GJLY5JLB.js";
import {
  FormControlController
} from "./chunk.UDRCCTEL.js";
import {
  o
} from "./chunk.J4J6TZIX.js";
import {
  watch
} from "./chunk.JMZM2TDT.js";
import {
  e
} from "./chunk.4VMW2AZ2.js";
import {
  LynkElement,
  e as e2,
  n,
  r
} from "./chunk.2EAGJTRH.js";
import {
  component_styles_default
} from "./chunk.V6UNAAZX.js";
import {
  x
} from "./chunk.Z3O73C4R.js";
import {
  __decorateClass
} from "./chunk.W27M6RDR.js";

// src/components/switch/switch.component.ts
var LynkSwitch = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.formControlController = new FormControlController(this, {
      value: (control) => control.checked ? control.value || "on" : void 0,
      defaultValue: (control) => control.defaultChecked,
      setValue: (control, checked) => control.checked = checked
    });
    this.hasFocus = false;
    this.title = "";
    this.name = "";
    this.size = "medium";
    this.color = "default";
    this.disabled = false;
    this.checked = false;
    this.defaultChecked = false;
    this.form = "";
    this.required = false;
  }
  /** Gets the validity state object */
  get validity() {
    return this.input.validity;
  }
  /** Gets the validation message */
  get validationMessage() {
    return this.input.validationMessage;
  }
  firstUpdated() {
    this.formControlController.updateValidity();
  }
  handleBlur() {
    this.hasFocus = false;
    this.emit("ev-blur");
  }
  handleInput() {
    this.emit("ev-input");
  }
  handleInvalid(event) {
    this.formControlController.setValidity(false);
    this.formControlController.emitInvalidEvent(event);
  }
  handleClick() {
    this.checked = !this.checked;
    this.emit("ev-change");
  }
  handleFocus() {
    this.hasFocus = true;
    this.emit("ev-focus");
  }
  handleKeyDown(event) {
    if (event.key === "ArrowLeft") {
      event.preventDefault();
      this.checked = false;
      this.emit("ev-change");
      this.emit("ev-input");
    }
    if (event.key === "ArrowRight") {
      event.preventDefault();
      this.checked = true;
      this.emit("ev-change");
      this.emit("ev-input");
    }
  }
  handleCheckedChange() {
    this.input.checked = this.checked;
    this.formControlController.updateValidity();
  }
  handleDisabledChange() {
    this.formControlController.setValidity(true);
  }
  /** Simulates a click on the switch. */
  click() {
    this.input.click();
  }
  /** Sets focus on the switch. */
  focus(options) {
    this.input.focus(options);
  }
  /** Removes focus from the switch. */
  blur() {
    this.input.blur();
  }
  /** Checks for validity but does not show the browser's validation message. */
  checkValidity() {
    return this.input.checkValidity();
  }
  /** Gets the associated form, if one exists. */
  getForm() {
    return this.formControlController.getForm();
  }
  /** Checks for validity and shows the browser's validation message if the control is invalid. */
  reportValidity() {
    return this.input.reportValidity();
  }
  /** Sets a custom validation message. Pass an empty string to restore validity. */
  setCustomValidity(message) {
    this.input.setCustomValidity(message);
    this.formControlController.updateValidity();
  }
  render() {
    return x`
      <label
        part="base"
        class=${e({
      switch: true,
      "switch--checked": this.checked,
      "switch--disabled": this.disabled,
      "switch--focused": this.hasFocus,
      "switch--success": this.color === "success",
      "switch--warning": this.color === "warning",
      "switch--danger": this.color === "danger",
      "switch--small": this.size === "small",
      "switch--medium": this.size === "medium",
      "switch--large": this.size === "large"
    })}
      >
        <input
          class="switch__input"
          type="checkbox"
          title=${this.title}
          name=${this.name}
          value=${o(this.value)}
          .checked=${l(this.checked)}
          .disabled=${this.disabled}
          .required=${this.required}
          role="switch"
          aria-checked=${this.checked ? "true" : "false"}
          @click=${this.handleClick}
          @input=${this.handleInput}
          @invalid=${this.handleInvalid}
          @blur=${this.handleBlur}
          @focus=${this.handleFocus}
          @keydown=${this.handleKeyDown}
        />

        <span part="control" class="switch__control">
          <span part="thumb" class="switch__thumb"></span>
        </span>

        <slot part="label" class="switch__label"></slot>
      </label>
    `;
  }
};
LynkSwitch.styles = [component_styles_default, form_control_styles_default, switch_styles_default];
__decorateClass([
  e2('input[type="checkbox"]')
], LynkSwitch.prototype, "input", 2);
__decorateClass([
  r()
], LynkSwitch.prototype, "hasFocus", 2);
__decorateClass([
  n()
], LynkSwitch.prototype, "title", 2);
__decorateClass([
  n()
], LynkSwitch.prototype, "name", 2);
__decorateClass([
  n()
], LynkSwitch.prototype, "value", 2);
__decorateClass([
  n({ reflect: true })
], LynkSwitch.prototype, "size", 2);
__decorateClass([
  n({ reflect: true })
], LynkSwitch.prototype, "color", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkSwitch.prototype, "disabled", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkSwitch.prototype, "checked", 2);
__decorateClass([
  defaultValue("checked")
], LynkSwitch.prototype, "defaultChecked", 2);
__decorateClass([
  n({ reflect: true })
], LynkSwitch.prototype, "form", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkSwitch.prototype, "required", 2);
__decorateClass([
  watch("checked", { waitUntilFirstUpdate: true })
], LynkSwitch.prototype, "handleCheckedChange", 1);
__decorateClass([
  watch("disabled", { waitUntilFirstUpdate: true })
], LynkSwitch.prototype, "handleDisabledChange", 1);

export {
  LynkSwitch
};
