import {
  LynkTooltip
} from "./chunk.ZYCYIAT3.js";
import {
  copy_button_styles_default
} from "./chunk.V7DIMDC5.js";
import {
  getAnimation,
  setDefaultAnimation
} from "./chunk.25TVLSB6.js";
import {
  LocalizeController
} from "./chunk.AFESEORB.js";
import {
  LynkIcon
} from "./chunk.4HTNL6JH.js";
import {
  e
} from "./chunk.4VMW2AZ2.js";
import {
  LynkElement,
  e as e2,
  n,
  r
} from "./chunk.2EAGJTRH.js";
import {
  component_styles_default
} from "./chunk.V6UNAAZX.js";
import {
  x
} from "./chunk.Z3O73C4R.js";
import {
  __decorateClass
} from "./chunk.W27M6RDR.js";

// src/components/copy-button/copy-button.component.ts
var LynkCopyButton = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.localize = new LocalizeController(this);
    this.isCopying = false;
    this.status = "rest";
    this.value = "";
    this.from = "";
    this.disabled = false;
    this.copyLabel = "";
    this.successLabel = "";
    this.errorLabel = "";
    this.feedbackDuration = 1500;
    this.tooltipPlacement = "top";
    this.hoist = false;
  }
  async handleCopy() {
    if (this.disabled || this.isCopying) {
      return;
    }
    this.isCopying = true;
    let valueToCopy = this.value;
    if (this.from) {
      const root = this.getRootNode();
      const isProperty = this.from.includes(".");
      const isAttribute = this.from.includes("[") && this.from.includes("]");
      let id = this.from;
      let field = "";
      if (isProperty) {
        [id, field] = this.from.trim().split(".");
      } else if (isAttribute) {
        [id, field] = this.from.trim().replace(/\]$/, "").split("[");
      }
      const target = "getElementById" in root ? root.getElementById(id) : null;
      if (target) {
        if (isAttribute) {
          valueToCopy = target.getAttribute(field) || "";
        } else if (isProperty) {
          valueToCopy = target[field] || "";
        } else {
          valueToCopy = target.textContent || "";
        }
      } else {
        this.showStatus("error");
        this.emit("ev-error");
      }
    }
    if (!valueToCopy) {
      this.showStatus("error");
      this.emit("ev-error");
    } else {
      try {
        await navigator.clipboard.writeText(valueToCopy);
        this.showStatus("success");
        this.emit("ev-copy", {
          detail: {
            value: valueToCopy
          }
        });
      } catch (error) {
        this.showStatus("error");
        this.emit("ev-error");
      }
    }
  }
  async showStatus(status) {
    const copyLabel = this.copyLabel || this.localize.term("copy");
    const successLabel = this.successLabel || this.localize.term("copied");
    const errorLabel = this.errorLabel || this.localize.term("error");
    const iconToShow = status === "success" ? this.successIcon : this.errorIcon;
    const showAnimation = getAnimation(this, "copy.in", { dir: "ltr" });
    const hideAnimation = getAnimation(this, "copy.out", { dir: "ltr" });
    this.tooltip.content = status === "success" ? successLabel : errorLabel;
    await this.copyIcon.animate(hideAnimation.keyframes, hideAnimation.options).finished;
    this.copyIcon.hidden = true;
    this.status = status;
    iconToShow.hidden = false;
    await iconToShow.animate(showAnimation.keyframes, showAnimation.options).finished;
    setTimeout(async () => {
      await iconToShow.animate(hideAnimation.keyframes, hideAnimation.options).finished;
      iconToShow.hidden = true;
      this.status = "rest";
      this.copyIcon.hidden = false;
      await this.copyIcon.animate(showAnimation.keyframes, showAnimation.options).finished;
      this.tooltip.content = copyLabel;
      this.isCopying = false;
    }, this.feedbackDuration);
  }
  render() {
    const copyLabel = this.copyLabel || this.localize.term("copy");
    return x`
      <lynk-tooltip
        class=${e({
      "copy-button": true,
      "copy-button--success": this.status === "success",
      "copy-button--error": this.status === "error"
    })}
        content=${copyLabel}
        placement=${this.tooltipPlacement}
        ?disabled=${this.disabled}
        ?hoist=${this.hoist}
        exportparts="
          base:tooltip__base,
          base__popup:tooltip__base__popup,
          base__arrow:tooltip__base__arrow,
          body:tooltip__body
        "
      >
        <button
          class="copy-button__button"
          part="button"
          type="button"
          ?disabled=${this.disabled}
          @click=${this.handleCopy}
        >
          <slot part="copy-icon" name="copy-icon">
            <lynk-icon library="system" name="copy"></lynk-icon>
          </slot>
          <slot part="success-icon" name="success-icon" hidden>
            <lynk-icon library="system" name="check"></lynk-icon>
          </slot>
          <slot part="error-icon" name="error-icon" hidden>
            <lynk-icon library="system" name="x-lg"></lynk-icon>
          </slot>
        </button>
      </lynk-tooltip>
    `;
  }
};
LynkCopyButton.styles = [component_styles_default, copy_button_styles_default];
LynkCopyButton.dependencies = {
  "lynk-icon": LynkIcon,
  "lynk-tooltip": LynkTooltip
};
__decorateClass([
  e2('slot[name="copy-icon"]')
], LynkCopyButton.prototype, "copyIcon", 2);
__decorateClass([
  e2('slot[name="success-icon"]')
], LynkCopyButton.prototype, "successIcon", 2);
__decorateClass([
  e2('slot[name="error-icon"]')
], LynkCopyButton.prototype, "errorIcon", 2);
__decorateClass([
  e2("lynk-tooltip")
], LynkCopyButton.prototype, "tooltip", 2);
__decorateClass([
  r()
], LynkCopyButton.prototype, "isCopying", 2);
__decorateClass([
  r()
], LynkCopyButton.prototype, "status", 2);
__decorateClass([
  n()
], LynkCopyButton.prototype, "value", 2);
__decorateClass([
  n()
], LynkCopyButton.prototype, "from", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkCopyButton.prototype, "disabled", 2);
__decorateClass([
  n({ attribute: "copy-label" })
], LynkCopyButton.prototype, "copyLabel", 2);
__decorateClass([
  n({ attribute: "success-label" })
], LynkCopyButton.prototype, "successLabel", 2);
__decorateClass([
  n({ attribute: "error-label" })
], LynkCopyButton.prototype, "errorLabel", 2);
__decorateClass([
  n({ attribute: "feedback-duration", type: Number })
], LynkCopyButton.prototype, "feedbackDuration", 2);
__decorateClass([
  n({ attribute: "tooltip-placement" })
], LynkCopyButton.prototype, "tooltipPlacement", 2);
__decorateClass([
  n({ type: Boolean })
], LynkCopyButton.prototype, "hoist", 2);
setDefaultAnimation("copy.in", {
  keyframes: [
    { scale: ".25", opacity: ".25" },
    { scale: "1", opacity: "1" }
  ],
  options: { duration: 100 }
});
setDefaultAnimation("copy.out", {
  keyframes: [
    { scale: "1", opacity: "1" },
    { scale: ".25", opacity: "0" }
  ],
  options: { duration: 100 }
});

export {
  LynkCopyButton
};
