import {
  i
} from "./chunk.Z3O73C4R.js";

// src/components/card/card.styles.ts
var card_styles_default = i`
  :host {
    --border-color: var(--lynk-color-neutral-200);
    --border-radius: var(--lynk-border-radius-large);
    --border-width: 1px;
    --padding: var(--lynk-spacing-base);
    --pulse-speed: 1.5s;
    --state-color: var(--lynk-color-primary);

    display: inline-block;
  }

  .card {
    display: flex;
    flex-direction: column;
    font-size: inherit;
    line-height: var(--lynk-line-height-dense);
    background-color: transparent;
    box-shadow: var(--lynk-shadow-x-small);
    border: solid var(--border-width) var(--border-color);
    border-radius: var(--border-radius);
    line-height: var(--lynk-line-height-dense);
    transition:
      var(--lynk-transition-fast) border,
      var(--lynk-transition-fast) box-shadow,
      var(--lynk-transition-fast) transform,
      var(--lynk-transition-fast) background;
  }

  .card--stealth {
    --border-color: transparent;
  }

  .card--small {
    --padding: var(--lynk-spacing-x-small);
    font-size: var(--lynk-font-size-small);
  }

  .card--medium {
    font-size: var(--lynk-font-size-medium);
  }

  .card--large {
    --padding: var(--lynk-spacing-large);
    font-size: var(--lynk-font-size-large);
  }

  /* Primary State */
  .card--primary {
    --state-color: var(--lynk-color-primary);
    border: solid var(--border-width) var(--state-color);
  }

  /* Accent State */
  .card--accent {
    --state-color: var(--lynk-color-accent);
    border: solid var(--border-width) var(--state-color);
  }

  /* Danger State */
  .card--danger {
    --state-color: var(--lynk-color-danger);
    border: solid var(--border-width) var(--state-color);
  }

  /* Warning State */
  .card--warning {
    --state-color: var(--lynk-color-warning);
    border: solid var(--border-width) var(--state-color);
  }

  /* Success State */
  .card--success {
    --state-color: var(--lynk-color-success);
    border: solid var(--border-width) var(--state-color);
  }

  /* Info State */
  .card--info {
    --state-color: var(--lynk-color-info);
    border: solid var(--border-width) var(--state-color);
  }

  /* Neutral State */
  .card--neutral {
    --state-color: var(--lynk-color-neutral);
    border: solid var(--border-width) var(--state-color);
  }

  .card--pulse {
    animation: pulse var(--pulse-speed) infinite;
  }

  .card--pulse.card--interactive:hover {
    animation: none;
  }

  .card--interactive:hover {
    cursor: pointer;
    border: solid var(--border-width) var(--state-color);
    box-shadow: var(--lynk-shadow-medium);
  }
  .card--interactive:active {
    transform: translateY(-4px);
    box-shadow: var(--lynk-shadow-large);
  }

  .card--active {
    border: solid var(--border-width) var(--state-color);
    box-shadow: var(--lynk-shadow-large);
  }

  .card__image-block {
    position: relative;
    border: 1px solid transparent;
  }

  .card__image {
    display: flex;
    border-top-left-radius: var(--border-radius);
    border-top-right-radius: var(--border-radius);
    margin: calc(-1 * var(--border-width));
    background-color: var(--lynk-color-black);
    overflow: hidden;
  }

  .card__image-block.aspect--1-1 .card__image {
    aspect-ratio: 1 / 1;
  }

  .card__image-block.aspect--16-9 .card__image {
    aspect-ratio: 16 / 9;
  }

  .card__image-block.aspect--4-3 .card__image {
    aspect-ratio: 4 / 3;
  }

  .card__image-block.aspect--3-4 .card__image {
    aspect-ratio: 3 / 4;
  }

  .card__image-block.aspect--9-16 .card__image {
    aspect-ratio: 9 / 16;
  }

  .card__image ::slotted(img) {
    display: block;
    object-fit: cover;
    width: 100%;
  }

  .card:not(.card--has-image) .card__image {
    display: none;
  }

  .card__image-top-start,
  .card__image-top-end,
  .card__image-bottom-start,
  .card__image-bottom-end {
    position: absolute;
    display: inline-flex;
  }

  .card__image-top-start {
    top: var(--padding);
    left: var(--padding);
  }

  .card__image-top-end {
    top: var(--padding);
    right: var(--padding);
  }

  .card__image-bottom-start {
    bottom: var(--padding);
    left: var(--padding);
  }

  .card__image-bottom-end {
    bottom: var(--padding);
    right: var(--padding);
  }

  .card__header {
    display: block;
    border-bottom: solid var(--border-width) var(--border-color);
    padding: calc(var(--padding) / 2) var(--padding);
  }

  .card:not(.card--has-header) .card__header {
    display: none;
  }

  .card:not(.card--has-image) .card__header {
    border-top-left-radius: var(--border-radius);
    border-top-right-radius: var(--border-radius);
  }

  .card__body {
    display: block;
    padding: var(--padding);
  }

  .card--has-footer .card__footer {
    display: block;
    border-top: solid var(--border-width) var(--border-color);
    padding: var(--padding);
  }

  .card:not(.card--has-footer) .card__footer {
    display: none;
  }

  .card--stealth {
    background-color: transparent;
    border-color: transparent;
    gap: var(--padding);
  }

  .card--stealth.card--interactive {
    padding: var(--padding);
  }

  .card--stealth .card__image {
    border-radius: var(--border-radius);
  }

  .card--stealth .card__footer,
  .card--stealth .card__header,
  .card--stealth .card__body {
    padding: 0;
  }

  .card--stealth.card--interactive:hover {
    background-color: var(--lynk-panel-background-color);
    border-color: var(--border-color);
  }

  .card--stealth.card--active,
  .card--stealth.card--active:hover {
    border-color: var(--state-color);
  }

  @keyframes pulse {
    0% {
      box-shadow: 0 0 0 0 var(--state-color);
    }
    70% {
      box-shadow: 0 0 0 0.5rem transparent;
    }
    100% {
      box-shadow: 0 0 0 0 transparent;
    }
  }
`;

export {
  card_styles_default
};
