import {
  menu_item_styles_default
} from "./chunk.TPZAA2J3.js";
import {
  getTextContent
} from "./chunk.OW5NIGGX.js";
import {
  LynkIcon
} from "./chunk.4HTNL6JH.js";
import {
  watch
} from "./chunk.JMZM2TDT.js";
import {
  e
} from "./chunk.4VMW2AZ2.js";
import {
  LynkElement,
  e as e2,
  n
} from "./chunk.2EAGJTRH.js";
import {
  component_styles_default
} from "./chunk.V6UNAAZX.js";
import {
  x
} from "./chunk.Z3O73C4R.js";
import {
  __decorateClass
} from "./chunk.W27M6RDR.js";

// src/components/menu-item/menu-item.component.ts
var LynkMenuItem = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.type = "normal";
    this.checked = false;
    this.value = "";
    this.disabled = false;
  }
  connectedCallback() {
    super.connectedCallback();
    this.handleHostClick = this.handleHostClick.bind(this);
    this.addEventListener("click", this.handleHostClick);
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.removeEventListener("click", this.handleHostClick);
  }
  handleDefaultSlotChange() {
    const textLabel = this.getTextLabel();
    if (typeof this.cachedTextLabel === "undefined") {
      this.cachedTextLabel = textLabel;
      return;
    }
    if (textLabel !== this.cachedTextLabel) {
      this.cachedTextLabel = textLabel;
      this.emit("slotchange", { bubbles: true, composed: false, cancelable: false });
    }
  }
  handleHostClick(event) {
    if (this.disabled) {
      event.preventDefault();
      event.stopImmediatePropagation();
    }
    this.emit("ev-click");
  }
  handleCheckedChange() {
    if (this.checked && this.type !== "checkbox") {
      this.checked = false;
      console.error('The checked attribute can only be used on menu items with type="checkbox"', this);
      return;
    }
    if (this.type === "checkbox") {
      this.setAttribute("aria-checked", this.checked ? "true" : "false");
    } else {
      this.removeAttribute("aria-checked");
    }
  }
  handleDisabledChange() {
    this.setAttribute("aria-disabled", this.disabled ? "true" : "false");
  }
  handleTypeChange() {
    if (this.type === "checkbox") {
      this.setAttribute("role", "menuitemcheckbox");
      this.setAttribute("aria-checked", this.checked ? "true" : "false");
    } else {
      this.setAttribute("role", "menuitem");
      this.removeAttribute("aria-checked");
    }
  }
  /** Returns a text label based on the contents of the menu item's default slot. */
  getTextLabel() {
    return getTextContent(this.defaultSlot);
  }
  render() {
    return x`
      <div
        part="base"
        class=${e({
      "menu-item": true,
      "menu-item--checked": this.checked,
      "menu-item--disabled": this.disabled,
      "menu-item--has-submenu": false
      // reserved for future use
    })}
      >
        <span part="checked-icon" class="menu-item__check">
          <lynk-icon name="check" library="system" aria-hidden="true"></lynk-icon>
        </span>

        <slot name="prefix" part="prefix" class="menu-item__prefix"></slot>

        <slot part="label" class="menu-item__label" @slotchange=${this.handleDefaultSlotChange}></slot>

        <slot name="suffix" part="suffix" class="menu-item__suffix"></slot>

        <span class="menu-item__chevron">
          <lynk-icon name="chevron-right" library="system" aria-hidden="true"></lynk-icon>
        </span>
      </div>
    `;
  }
};
LynkMenuItem.styles = [component_styles_default, menu_item_styles_default];
LynkMenuItem.dependencies = {
  "lynk-icon": LynkIcon
};
__decorateClass([
  e2("slot:not([name])")
], LynkMenuItem.prototype, "defaultSlot", 2);
__decorateClass([
  e2(".menu-item")
], LynkMenuItem.prototype, "menuItem", 2);
__decorateClass([
  n()
], LynkMenuItem.prototype, "type", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkMenuItem.prototype, "checked", 2);
__decorateClass([
  n()
], LynkMenuItem.prototype, "value", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkMenuItem.prototype, "disabled", 2);
__decorateClass([
  watch("checked")
], LynkMenuItem.prototype, "handleCheckedChange", 1);
__decorateClass([
  watch("disabled")
], LynkMenuItem.prototype, "handleDisabledChange", 1);
__decorateClass([
  watch("type")
], LynkMenuItem.prototype, "handleTypeChange", 1);

export {
  LynkMenuItem
};
