import {
  optgroup_styles_default
} from "./chunk.TDRUKRCC.js";
import {
  LynkDivider
} from "./chunk.R2MIDTH2.js";
import {
  u
} from "./chunk.RVFZXBWN.js";
import {
  HasSlotController
} from "./chunk.OW5NIGGX.js";
import {
  watch
} from "./chunk.JMZM2TDT.js";
import {
  e
} from "./chunk.4VMW2AZ2.js";
import {
  LynkElement,
  e as e2,
  n
} from "./chunk.2EAGJTRH.js";
import {
  __decorateClass
} from "./chunk.W27M6RDR.js";

// src/components/optgroup/optgroup.component.ts
var LynkOptgroup = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.hasSlotController = new HasSlotController(this, "[default]", "prefix", "suffix", "label");
    this.disabled = false;
    this.label = "";
  }
  /**
   * Syncs the disabled prop for all slotted lynk-options when it is triggered
   */
  handleDisableOptions() {
    const { disabled } = this;
    this.defaultSlot.assignedElements().filter((opt) => opt.tagName.toLowerCase() === "lynk-option").forEach((opt) => {
      opt.disabled = disabled;
    });
  }
  handleDisabledChange() {
    this.handleDisableOptions();
  }
  render() {
    const { disabled } = this;
    const hasLabelSlot = this.hasSlotController.test("label");
    const hasLabel = this.label ? true : !!hasLabelSlot;
    return u`
      <div
        class=${e({
      optgroup: true,
      "optgroup--has-label": hasLabel,
      "optgroup--has-prefix": this.hasSlotController.test("prefix"),
      "optgroup--has-suffix": this.hasSlotController.test("suffix"),
      "optgroup--is-disabled": this.disabled
    })}
        role="${disabled ? "presentation" : "group"}"
        part="base"
      >
        <lynk-divider class="optgroup__divider" part="divider"></lynk-divider>
        <div class="optgroup__label-container" part="label-container">
          <slot name="prefix" part="prefix" class="optgroup__prefix"></slot>
          <slot name="label" part="label" class="optgroup__label">
            <span class="optgroup__label-content"> ${this.label} </span>
          </slot>
          <slot name="suffix" part="suffix" class="optgroup__suffix"></slot>
        </div>
        <div class="optgroup__options" role="group" part="options">
          <slot @slotchange=${this.handleDisableOptions}></slot>
        </div>
      </div>
    `;
  }
};
LynkOptgroup.styles = optgroup_styles_default;
LynkOptgroup.dependencies = {
  "lynk-divider": LynkDivider
};
__decorateClass([
  e2("slot:not([name])")
], LynkOptgroup.prototype, "defaultSlot", 2);
__decorateClass([
  n({ reflect: true, type: Boolean })
], LynkOptgroup.prototype, "disabled", 2);
__decorateClass([
  n()
], LynkOptgroup.prototype, "label", 2);
__decorateClass([
  watch("disabled", { waitUntilFirstUpdate: true })
], LynkOptgroup.prototype, "handleDisabledChange", 1);

export {
  LynkOptgroup
};
