import {
  page_content_styles_default
} from "./chunk.5A25N7XT.js";
import {
  LynkPage
} from "./chunk.F6A2LG7N.js";
import {
  getScrollParent
} from "./chunk.WSPFGNPB.js";
import {
  e
} from "./chunk.4VMW2AZ2.js";
import {
  LynkElement,
  e as e2,
  n
} from "./chunk.2EAGJTRH.js";
import {
  component_styles_default
} from "./chunk.V6UNAAZX.js";
import {
  x
} from "./chunk.Z3O73C4R.js";
import {
  __decorateClass
} from "./chunk.W27M6RDR.js";

// src/components/page-content/page-content.component.ts
var LynkPageContent = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.width = "fluid";
  }
  /** Scrolls the nearest scrollable parent element to the top. */
  scrollToTop() {
    const parent = this.hasParentLayout() ? this.parentElement.renderRoot.querySelector(".page__main") : getScrollParent(this.pageContent);
    if (parent) {
      parent.scrollTo({ top: 0, behavior: "smooth" });
    }
  }
  // Checks whether the page content is nested into a lynk-page
  hasParentLayout() {
    const parent = this.parentElement;
    return parent instanceof LynkPage;
  }
  render() {
    return x`
      <div
        part="base"
        class=${e({
      "page-content": true,
      "page-content--auto": this.width === "auto",
      "page-content--sm": this.width === "small",
      "page-content--md": this.width === "medium",
      "page-content--lg": this.width === "large",
      "page-content--xl": this.width === "x-large",
      "page-content--xxl": this.width === "2x-large",
      "page-content--fluid": this.width === "fluid"
    })}
      >
        <slot></slot>
      </div>
    `;
  }
};
LynkPageContent.styles = [component_styles_default, page_content_styles_default];
LynkPageContent.dependencies = { "lynk-page": LynkPage };
__decorateClass([
  n({ reflect: true })
], LynkPageContent.prototype, "width", 2);
__decorateClass([
  e2(".page-content")
], LynkPageContent.prototype, "pageContent", 2);

export {
  LynkPageContent
};
