import {
  tab_styles_default
} from "./chunk.YLKGHWBP.js";
import {
  LynkIconButton
} from "./chunk.OI2YJPCU.js";
import {
  i,
  u
} from "./chunk.RVFZXBWN.js";
import {
  o
} from "./chunk.J4J6TZIX.js";
import {
  LocalizeController
} from "./chunk.AFESEORB.js";
import {
  watch
} from "./chunk.JMZM2TDT.js";
import {
  e
} from "./chunk.4VMW2AZ2.js";
import {
  LynkElement,
  e as e2,
  n
} from "./chunk.2EAGJTRH.js";
import {
  component_styles_default
} from "./chunk.V6UNAAZX.js";
import {
  __decorateClass
} from "./chunk.W27M6RDR.js";

// src/components/tab/tab.component.ts
var id = 0;
var LynkTab = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.localize = new LocalizeController(this);
    this.attrId = ++id;
    this.componentId = `lynk-tab-${this.attrId}`;
    this.panel = "";
    this.active = false;
    this.closable = false;
    this.disabled = false;
    this.href = "";
    this.rel = "noreferrer noopener";
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "tab");
  }
  handleCloseClick() {
    this.emit("ev-close");
  }
  isLink() {
    return this.href ? true : false;
  }
  handleActiveChange() {
    this.setAttribute("aria-selected", this.active ? "true" : "false");
  }
  handleDisabledChange() {
    this.setAttribute("aria-disabled", this.disabled ? "true" : "false");
    if (this.disabled && !this.active) {
      this.tabIndex = -1;
    } else {
      this.tabIndex = 0;
    }
  }
  /** Sets focus to the tab. */
  focus(options) {
    this.tab.focus(options);
  }
  /** Removes focus from the tab. */
  blur() {
    this.tab.blur();
  }
  render() {
    const isLink = this.isLink();
    const tag = isLink ? i`a` : i`div`;
    this.id = this.id.length > 0 ? this.id : this.componentId;
    return u`
      <${tag}
        part="base"
        href=${o(isLink ? this.href : void 0)}
        rel=${o(isLink ? this.rel : void 0)}
        class=${e({
      tab: true,
      "tab--active": this.active,
      "tab--closable": this.closable,
      "tab--disabled": this.disabled
    })}
        tabindex=${this.disabled ? "-1" : "0"}
      >
        <slot></slot>
        ${this.closable ? u`
                <lynk-icon-button
                  part="close-button"
                  exportparts="base:close-button__base"
                  name="x-lg"
                  library="system"
                  label=${this.localize.term("close")}
                  class="tab__close-button"
                  @click=${this.handleCloseClick}
                  tabindex="-1"
                ></lynk-icon-button>
              ` : ""}
      </${tag}>
    `;
  }
};
LynkTab.styles = [component_styles_default, tab_styles_default];
LynkTab.dependencies = { "lynk-icon-button": LynkIconButton };
__decorateClass([
  e2(".tab")
], LynkTab.prototype, "tab", 2);
__decorateClass([
  n({ reflect: true })
], LynkTab.prototype, "panel", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkTab.prototype, "active", 2);
__decorateClass([
  n({ type: Boolean })
], LynkTab.prototype, "closable", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], LynkTab.prototype, "disabled", 2);
__decorateClass([
  n()
], LynkTab.prototype, "href", 2);
__decorateClass([
  n()
], LynkTab.prototype, "rel", 2);
__decorateClass([
  watch("active")
], LynkTab.prototype, "handleActiveChange", 1);
__decorateClass([
  watch("disabled")
], LynkTab.prototype, "handleDisabledChange", 1);

export {
  LynkTab
};
