import {
  i
} from "./chunk.Z3O73C4R.js";

// src/components/nav-item/nav-item.styles.ts
var nav_item_styles_default = i`
  :host {
    display: block;
    --hover-bg-color: var(--lynk-color-gray-a25);
    --selected-color: var(--lynk-color-neutral-1000);
    --selected-indicator-color: var(--lynk-color-primary);
    --selected-bg-color: var(--lynk-color-gray-a25);
    --border-radius: var(--lynk-border-radius-medium);
    --padding: var(--lynk-spacing-2x-small) var(--lynk-spacing-small);
  }

  :host([disabled]) {
    pointer-events: none;
  }

  :host(:focus) {
    outline: none;
  }

  .nav-item {
    align-items: stretch;
    justify-content: start;
    color: var(--nav-item-color);
    cursor: pointer;
    border-radius: var(--border-radius);
    display: flex;
    hyphens: auto;
    padding: var(--padding);
    position: relative;
    text-decoration: none;
    border: none;
    background: none;
    font-family: var(--lynk-font-sans);
    font-size: var(--lynk-font-size-medium);
    font-weight: var(--lynk-font-weight-normal);
    text-align: unset;
    width: 100%;
    width: -moz-available;
    width: -webkit-fill-available;
    width: fill-available;
    word-break: break-word;
    line-height: var(--lynk-line-height-dense);
    transition: var(--lynk-transition-fast) fill;
  }

  .nav-item::before {
    position: absolute;
    width: 4px;
    bottom: -2px;
    top: -2px;
    left: -8px;
    content: '';
    pointer-events: none;
    border-radius: var(--border-radius);
  }

  :host(:focus-visible) .nav-item {
    box-shadow: 0 0 0 var(--lynk-focus-ring-width) var(--lynk-input-focus-ring-color);
    background-color: var(--hover-bg-color);
    outline: 1px solid var(--lynk-color-primary);
    z-index: 2;
  }

  .nav-item:hover {
    background-color: var(--hover-bg-color);
  }

  .nav-item.nav-item--disabled {
    outline: none;
    opacity: 0.5;
  }

  .nav-item.nav-item--selected {
    color: var(--selected-color);
    background-color: var(--selected-bg-color);
  }

  .nav-item.nav-item--selected::before {
    background-color: var(--selected-indicator-color);
    display: block;
  }

  .nav-item .nav-item__label {
    flex: 1 1 auto;
    display: inline-block;
  }

  .nav-item .nav-item__prefix,
  .nav-item .nav-item__suffix {
    flex: 0 0 auto;
    display: flex;
    align-items: center;
    font-size: 1.25em;
  }

  .nav-item .nav-item__prefix::slotted(*) {
    margin-inline-end: var(--lynk-spacing-small);
  }

  .nav-item .nav-item__suffix::slotted(*) {
    margin-inline-start: var(--lynk-spacing-small);
  }

  .nav-item__chevron {
    flex: 0 0 auto;
    display: flex;
    align-items: center;
    transition: var(--lynk-transition-fast) all;
  }

  .nav-item--expanded .nav-item__chevron {
    rotate: 90deg;
  }

  .nav-item__children {
    display: flex;
    flex-direction: column;
    gap: var(--lynk-spacing-2x-small);
    margin: var(--lynk-spacing-2x-small) 0;
  }

  :host(:focus) {
    outline: none;
  }

  .nav-item[data-level='1'] {
    margin-inline-start: var(--lynk-spacing-x-large);
  }

  .nav-item[data-level='2'] {
    margin-inline-start: var(--lynk-spacing-2x-large);
  }

  .nav-item.nav-item--rtl[data-level='1'] {
    margin-inline-end: calc(var(--lynk-spacing-x-large) + 2px);
  }

  .nav-item.nav-item--rtl[data-level='2'] {
    margin-inline-end: var(--lynk-spacing-2x-large);
  }

  .nav-item.nav-item--squished {
    text-align: center;
    flex-direction: column;
    align-items: center;
    font-size: var(--lynk-font-size-small);
    line-height: var(--lynk-line-height-dense);
    border-radius: var(--border-radius);
    padding: var(--lynk-spacing-x-small) var(--lynk-spacing-2x-small);
    margin-inline-start: 0;
  }

  .nav-item--squished.nav-item--selected {
    color: var(--selected-color);
    background-color: var(--selected-bg-color);
  }

  .nav-item.nav-item--squished::before {
    display: none;
  }

  .nav-item.nav-item--squished .nav-item__chevron {
    opacity: 0;
    position: absolute;
    bottom: -2px;
    margin-left: -6px;
    left: 50%;
  }

  .nav-item.nav-item--squished:hover .nav-item__chevron,
  .nav-item.nav-item--expanded .nav-item__chevron {
    opacity: 1;
  }

  .nav-item--expanded.nav-item--squished .nav-item__chevron {
    rotate: 180deg;
  }

  .nav-item.nav-item--squished.nav-item--selected::before {
    border-color: var(--selected-color);
  }

  .nav-item.nav-item--squished .nav-item__prefix::slotted(*) {
    margin-inline-end: 0;
    margin-block-end: var(--lynk-spacing-2x-small);
  }

  .nav-item.nav-item--squished .nav-item__suffix::slotted(*) {
    margin-inline-start: 0;
    margin-block-start: var(--lynk-spacing-2x-small);
  }

  .nav-item.nav-item--squished .nav-item__prefix,
  .nav-item.nav-item--squished .nav-item__suffix {
    font-size: 20px;
  }

  .nav-item--squished + .nav-item__children {
    margin: var(--lynk-spacing-2x-small) 0;
    padding: var(--lynk-spacing-2x-small) 0;
    border-top: 1px solid var(--selected-bg-color);
    border-bottom: 1px solid var(--selected-bg-color);
  }

  :host([no-label]) .nav-item__label {
    display: none;
  }

  :host([no-label]) .nav-item .nav-item__prefix::slotted(*) {
    margin-inline-end: 0;
    margin-block-end: 0;
  }

  :host([no-label]) .nav-item .nav-item__suffix::slotted(*) {
    margin-inline-start: 0;
    margin-block-start: 0;
  }

  .nav-item__external {
    opacity: 0;
    position: absolute;
    top: 2px;
    right: 2px;
  }

  .nav-item:hover .nav-item__external {
    opacity: 1;
  }
`;

export {
  nav_item_styles_default
};
