import LynkElement from '../../internal/lynk-element.js';
import type { CSSResultGroup } from 'lit';
/**
 * @summary A vertically stacked set of interactive [Panels](/components/panel) that can expand to reveal an associated section of content.
 * @documentation https://lynk.design/components/accordion
 * @since 1.0.0
 * @status stable
 *
 */
export default class LynkAccordion extends LynkElement {
    static styles: CSSResultGroup;
    /** Allow multiple panels to be open at the same time or automatically collapse other panels */
    multiple: boolean;
    /** Allow multiple panels to be open at the same time or automatically collapse other panels */
    density?: 'flush' | 'compact' | 'comfy';
    /** Allow multiple panels to be open at the same time or automatically collapse other panels */
    shape?: 'rounded' | 'square';
    private getAllPanels;
    private handlePanelToggle;
    /** Expands all panels. */
    expandAll(): void;
    /** Collapses all panels */
    collapseAll(): void;
    render(): import("lit").TemplateResult<1>;
}
