import LynkElement from '../../internal/lynk-element.js';
import type { CSSResultGroup } from 'lit';
/**
 * @summary A simple automatic two-dimensional grid-based layout system based off CSS Grid spec.
 * @documentation https://lynk.design/components/auto-grid
 * @since 1.0.0
 * @status stable
 *
 * @slot - The default slot.
 *
 * @csspart base - The component's internal wrapper.
 *
 * @cssproperty [--gap=var(--lynk-spacing-base)] - Customize the gap of the auto-grid group.
 * @cssproperty [--min-size=20rem] - Customize the allowed min-size of the auto-grid items.
 */
export default class LynkAutoGrid extends LynkElement {
    static styles: CSSResultGroup;
    /** How to justify auto-grid items */
    autoSize: 'fit' | 'fill';
    /** How to align auto-grid items to each-other */
    minSize: string;
    /** The space between auto-grid items. Use spacing tokens or any custom size. */
    gap: string;
    render(): import("lit").TemplateResult<1>;
}
