import LynkElement from '../../internal/lynk-element.js';
import type { CSSResultGroup } from 'lit';
/**
 * @summary Table `<lynk-colgroup>` components will behave like a native `<colgroup>` HTML element within a `<lynk-table>`.
 * @documentation https://lynk.design/components/colgroup
 * @since 1.0.0
 * @status stable
 *
 * @slot - Should contain 1 or more `<lynk-col>` components.
 *
 * @csspart base - The component's internal wrapper.
 */
export default class LynkColGroup extends LynkElement {
    static styles: CSSResultGroup;
    render(): import("lit").TemplateResult<1>;
}
