import { type TemplateResult } from 'lit';
import type LynkOption from '../option/option.component.js';
/**
 * A type definition for a function that renders an option.
 *
 * @param option - The option to be rendered.
 * @param query - The current query string used for filtering options.
 * @returns - The changed option to render
 */
export type OptionRenderer = (option: LynkOption, query?: string) => TemplateResult | string | HTMLElement;
/**
 * The default option renderer, which does not change the option.
 */
export declare const defaultOptionRenderer: OptionRenderer;
/**
 * A function that highlights the query string with a mark element in the option.
 */
export declare const highlightOptionRenderer: OptionRenderer;
