import LynkElement from '../../internal/lynk-element.js';
/**
 * @summary Formats a number using the specified locale and options.
 * @documentation https://lynk.design/components/format-number
 * @since 1.0.0
 * @status stable
 */
export default class LynkFormatNumber extends LynkElement {
    private readonly localize;
    /** The number to format. */
    value: number;
    /** The formatting style to use. */
    type: 'currency' | 'decimal' | 'percent';
    /** Turns off grouping separators. */
    noGrouping: boolean;
    /** The currency to use when formatting. Must be an ISO 4217 currency code such as `USD` or `EUR`. */
    currency: string;
    /** How to display the currency. */
    currencyDisplay: 'symbol' | 'narrowSymbol' | 'code' | 'name';
    /** The minimum number of integer digits to use. Possible values are 1 - 21. */
    minimumIntegerDigits: number;
    /** The minimum number of fraction digits to use. Possible values are 0 - 20. */
    minimumFractionDigits: number;
    /** The maximum number of fraction digits to use. Possible values are 0 - 20. */
    maximumFractionDigits: number;
    /** The minimum number of significant digits to use. Possible values are 1 - 21. */
    minimumSignificantDigits: number;
    /** The maximum number of significant digits to use,. Possible values are 1 - 21. */
    maximumSignificantDigits: number;
    render(): string;
}
