import LynkElement from '../../internal/lynk-element.js';
import LynkPage from '../page/page.component.js';
import type { CSSResultGroup } from 'lit';
/**
 * @summary The page-content component is a fundamental layout building block to standardize how content is contained, padded, and aligned within a given device or viewport.
 * @documentation https://lynk.design/components/page-content
 * @since 1.0.0
 * @status stable
 *
 */
export default class LynkPageContent extends LynkElement {
    static styles: CSSResultGroup;
    static dependencies: {
        'lynk-page': typeof LynkPage;
    };
    /** Set an optional maximum width for page content  */
    width: 'auto' | 'small' | 'medium' | 'large' | 'x-large' | '2x-large' | 'fluid';
    pageContent: HTMLElement;
    /** Scrolls the nearest scrollable parent element to the top. */
    scrollToTop(): void;
    private hasParentLayout;
    render(): import("lit").TemplateResult<1>;
}
