import LynkElement from '../../internal/lynk-element.js';
import type { CSSResultGroup } from 'lit';
/**
 * @summary Table `<lynk-tr>` components will behave like a native `<tr>` HTML elements within a `<lynk-table>`.
 * @documentation https://lynk.design/components/tr
 * @since 1.0.0
 * @status stable
 *
 * @slot - Should contain 1 or more `<lynk-td>` or `<lynk-th>` components.
 *
 * @csspart base - The component's internal wrapper.
 */
export default class LynkTr extends LynkElement {
    static styles: CSSResultGroup;
    /** Draws the table row using status colors */
    state: 'primary' | 'accent' | 'danger' | 'success' | 'warning' | 'neutral' | 'info' | 'custom';
    /** Determines whether to highlight the table row on hover or touch interactions */
    interactive: boolean;
    /** Draws the table row in a highlighted state  */
    active: boolean;
    /** Pulse the status colors for increased visibility */
    pulse: boolean;
    render(): import("lit").TemplateResult<1>;
}
