import LynkElement from '../../internal/lynk-element.js';
import type { CSSResultGroup } from 'lit';
/**
 * @summary Wisps are used to provide a visual representation of where content will eventually be drawn.
 * @documentation https://lynk.design/components/wisp
 * @status stable
 * @since 1.0
 *
 * @csspart base - The component's base wrapper.
 * @csspart indicator - The wisp's indicator which is responsible for its color and animation.
 *
 * @cssproperty --border-radius - The wisp's border radius.
 * @cssproperty --color - The color of the wisp.
 * @cssproperty --sheen-color - The sheen color when the wisp is in its loading state.
 */
export default class LynkWisp extends LynkElement {
    static styles: CSSResultGroup;
    /** Determines which effect the wisp will use. */
    effect: 'pulse' | 'sheen' | 'none';
    render(): import("lit").TemplateResult<1>;
}
