import Component from '../../components/badge/badge.component.js';
/**
 * @summary Badges are used to draw attention and display statuses or counts.
 * @documentation https://lynk.design/components/badge
 * @since 1.0.0
 * @status stable
 *
 * @slot - The badge's content.
 *
 * @csspart base - The component's internal wrapper.
 *
 * @cssproperty --background-color - The badges background and pulse color.
 * @cssproperty --color - The badges text color.
 * @cssproperty --pulse-speed - The badges pulse speed in seconds or ms. Default is 1.5s.
 *
 */
declare const reactWrapper: import("@lit/react").ReactWebComponent<Component, {}>;
export default reactWrapper;
