import Component from '../../components/include/include.component.js';
import { type EventName } from '@lit/react';
import type { LynkLoadEvent } from '../../events/events.js';
import type { LynkErrorEvent } from '../../events/events.js';
export type { LynkLoadEvent } from '../../events/events.js';
export type { LynkErrorEvent } from '../../events/events.js';
/**
 * @summary Includes give you the power to embed external HTML files into the page.
 * @documentation https://lynk.design/components/include
 * @status stable
 * @since 1.0.0
 *
 * @event ev-load - Emitted when the included file is loaded.
 * @event {{ status: number }} ev-error - Emitted when the included file fails to load due to an error.
 */
declare const reactWrapper: import("@lit/react").ReactWebComponent<Component, {
    EvLoad: EventName<LynkLoadEvent>;
    EvError: EventName<LynkErrorEvent>;
}>;
export default reactWrapper;
