import Component from '../../components/menu/menu.component.js';
import { type EventName } from '@lit/react';
import type { LynkSelectEvent } from '../../events/events.js';
export type { LynkSelectEvent } from '../../events/events.js';
/**
 * @summary Menus provide a list of options for the user to choose from.
 * @documentation https://lynk.design/components/menu
 * @since 1.0.0
 * @status stable
 *
 * @slot - The menu's content, including menu items, menu labels, and dividers.
 *
 * @event {{ item: LynkMenuItem }} ev-select - Emitted when a menu item is selected.
 */
declare const reactWrapper: import("@lit/react").ReactWebComponent<Component, {
    EvSelect: EventName<LynkSelectEvent>;
}>;
export default reactWrapper;
