import Component from '../../components/mutation-observer/mutation-observer.component.js';
import { type EventName } from '@lit/react';
import type { LynkMutationEvent } from '../../events/events.js';
export type { LynkMutationEvent } from '../../events/events.js';
/**
 * @summary The Mutation Observer component offers a thin, declarative interface to the [`MutationObserver API`](https://developer.mozilla.org/en-US/docs/Web/API/MutationObserver).
 * @documentation https://lynk.design/components/mutation-observer
 * @status stable
 * @since 1.0.0
 *
 * @event {{ mutationList: MutationRecord[] }} ev-mutation - Emitted when a mutation occurs.
 *
 * @slot - The content to watch for mutations.
 */
declare const reactWrapper: import("@lit/react").ReactWebComponent<Component, {
    EvMutation: EventName<LynkMutationEvent>;
}>;
export default reactWrapper;
