import Component from '../../components/optgroup/optgroup.component.js';
/**
 * @summary Creates a grouping for [options](/components/option) within a [select](/components/select) or [combobox](/components/combobox).
 * @documentation https://lynk.design/components/optgroup
 * @status experimental
 * @since 1.0.0
 *
 * @dependency lynk-divider
 *
 * @slot - The given options. Must be `lynk-option` elements.
 * @slot prefix - A presentational prefix icon or similar element.
 * @slot label - The label for the optgroup
 * @slot suffix - A presentational suffix icon or similar element.
 *
 * @csspart base - The component's base wrapper.
 * @csspart label-container - The container that wraps prefix, label and base
 * @csspart divider - The divider that is displayed above the content
 * @csspart prefix - The container that wraps the prefix.
 * @csspart suffix - The container that wraps the suffix.
 * @csspart options - The container that wraps the option elements.
 *
 * @cssproperty --display-divider - Display property of the divider. Defaults to "block"
 */
declare const reactWrapper: import("@lit/react").ReactWebComponent<Component, {}>;
export default reactWrapper;
