import Component from '../../components/stack/stack.component.js';
/**
 * @summary Stacks are a fundamental building block for laying out and aligning small bits of content or simple components in a vertical or horizontal space.
 * @documentation https://lynk.design/components/stack
 * @since 1.0.0
 * @status stable
 *
 * @slot - The default slot.
 *
 * @csspart base - The component's internal wrapper.
 *
 * @cssproperty [--width=100%] - Customize the width of the stack group.
 * @cssproperty [--height=auto] - Customize the width of the stack group.
 * @cssproperty [--gap=var(--lynk-spacing-small)] - Customize the gap of the stack group.
 * @cssproperty [--margin=0] - Customize the margin of the stack group.
 */
declare const reactWrapper: import("@lit/react").ReactWebComponent<Component, {}>;
export default reactWrapper;
