import Component from '../../components/tag/tag.component.js';
import { type EventName } from '@lit/react';
import type { LynkRemoveEvent } from '../../events/events.js';
export type { LynkRemoveEvent } from '../../events/events.js';
/**
 * @summary Tags are used as labels to organize things or to indicate a selection.
 * @documentation https://lynk.design/components/tag
 * @since 1.0.0
 * @status stable
 *
 * @dependency lynk-icon-button
 *
 * @slot - The tag's content.
 *
 * @event ev-remove - Emitted when the remove button is activated.
 *
 * @csspart base - The component's internal wrapper.
 * @csspart content - The tag content.
 * @csspart remove-button - The remove button.
 * @csspart remove-button__base - The remove button's `base` part.
 */
declare const reactWrapper: import("@lit/react").ReactWebComponent<Component, {
    EvRemove: EventName<LynkRemoveEvent>;
}>;
export default reactWrapper;
