import Component from '../../components/th/th.component.js';
import { type EventName } from '@lit/react';
import type { LynkTableSortEvent } from '../../events/events.js';
export type { LynkTableSortEvent } from '../../events/events.js';
/**
 * @summary Table `<lynk-th>` components will behave like a native `<th>` HTML element within a `<lynk-table>`.
 * @documentation https://lynk.design/components/th
 * @since 1.0.0
 * @status stable
 *
 * @slot - The table column header label
 *
 * @event ev-table-sort - Emitted when a sortable table header is clicked on.
 */
declare const reactWrapper: import("@lit/react").ReactWebComponent<Component, {
    EvTableSort: EventName<LynkTableSortEvent>;
}>;
export default reactWrapper;
