import Component from '../../components/wisp/wisp.component.js';
/**
 * @summary Wisps are used to provide a visual representation of where content will eventually be drawn.
 * @documentation https://lynk.design/components/wisp
 * @status stable
 * @since 1.0
 *
 * @csspart base - The component's base wrapper.
 * @csspart indicator - The wisp's indicator which is responsible for its color and animation.
 *
 * @cssproperty --border-radius - The wisp's border radius.
 * @cssproperty --color - The color of the wisp.
 * @cssproperty --sheen-color - The sheen color when the wisp is in its loading state.
 */
declare const reactWrapper: import("@lit/react").ReactWebComponent<Component, {}>;
export default reactWrapper;
