import type { DefineComponent } from "vue";

import type { LynkAccordion } from "../../components/accordion/accordion.component.js";
import type { LynkAlert } from "../../components/alert/alert.component.js";
import type { LynkAnimation } from "../../components/animation/animation.component.js";
import type { LynkAutoGrid } from "../../components/auto-grid/auto-grid.component.js";
import type { LynkBadge } from "../../components/badge/badge.component.js";
import type { LynkBox } from "../../components/box/box.component.js";
import type { LynkBreadcrumb } from "../../components/breadcrumb/breadcrumb.component.js";
import type { LynkBreadcrumbItem } from "../../components/breadcrumb-item/breadcrumb-item.component.js";
import type { LynkButton } from "../../components/button/button.component.js";
import type { LynkButtonGroup } from "../../components/button-group/button-group.component.js";
import type { LynkCard } from "../../components/card/card.component.js";
import type { LynkCheckbox } from "../../components/checkbox/checkbox.component.js";
import type { LynkCol } from "../../components/col/col.component.js";
import type { LynkColGroup } from "../../components/colgroup/colgroup.component.js";
import type { LynkCombobox } from "../../components/combobox/combobox.component.js";
import type { LynkCopyButton } from "../../components/copy-button/copy-button.component.js";
import type { LynkDialog } from "../../components/dialog/dialog.component.js";
import type { LynkDivider } from "../../components/divider/divider.component.js";
import type { LynkDrawer } from "../../components/drawer/drawer.component.js";
import type { LynkDropdown } from "../../components/dropdown/dropdown.component.js";
import type { LynkFormField } from "../../components/form-field/form-field.component.js";
import type { LynkFormatBytes } from "../../components/format-bytes/format-bytes.component.js";
import type { LynkFormatDate } from "../../components/format-date/format-date.component.js";
import type { LynkGrid } from "../../components/grid/grid.component.js";
import type { LynkFormatNumber } from "../../components/format-number/format-number.component.js";
import type { LynkIcon } from "../../components/icon/icon.component.js";
import type { LynkIconButton } from "../../components/icon-button/icon-button.component.js";
import type { LynkInclude } from "../../components/include/include.component.js";
import type { LynkInput } from "../../components/input/input.component.js";
import type { LynkIntersectionObserver } from "../../components/intersection-observer/intersection-observer.component.js";
import type { LynkMenu } from "../../components/menu/menu.component.js";
import type { LynkMenuItem } from "../../components/menu-item/menu-item.component.js";
import type { LynkMenuLabel } from "../../components/menu-label/menu-label.component.js";
import type { LynkMutationObserver } from "../../components/mutation-observer/mutation-observer.component.js";
import type { LynkNav } from "../../components/nav/nav.component.js";
import type { LynkNavGroup } from "../../components/nav-group/nav-group.component.js";
import type { LynkNavItem } from "../../components/nav-item/nav-item.component.js";
import type { LynkOptgroup } from "../../components/optgroup/optgroup.component.js";
import type { LynkOption } from "../../components/option/option.component.js";
import type { LynkPage } from "../../components/page/page.component.js";
import type { LynkPageContent } from "../../components/page-content/page-content.component.js";
import type { LynkPageFooter } from "../../components/page-footer/page-footer.component.js";
import type { LynkPageHeader } from "../../components/page-header/page-header.component.js";
import type { LynkPageSidebar } from "../../components/page-sidebar/page-sidebar.component.js";
import type { LynkPanel } from "../../components/panel/panel.component.js";
import type { LynkPopover } from "../../components/popover/popover.component.js";
import type { LynkPopup } from "../../components/popup/popup.component.js";
import type { LynkProgressBar } from "../../components/progress-bar/progress-bar.component.js";
import type { LynkProgressRing } from "../../components/progress-ring/progress-ring.component.js";
import type { LynkRadio } from "../../components/radio/radio.component.js";
import type { LynkRadioButton } from "../../components/radio-button/radio-button.component.js";
import type { LynkRadioGroup } from "../../components/radio-group/radio-group.component.js";
import type { LynkRange } from "../../components/range/range.component.js";
import type { LynkRelativeTime } from "../../components/relative-time/relative-time.component.js";
import type { LynkResizeObserver } from "../../components/resize-observer/resize-observer.component.js";
import type { LynkResponsiveMedia } from "../../components/responsive-media/responsive-media.component.js";
import type { LynkSelect } from "../../components/select/select.component.js";
import type { LynkSpinner } from "../../components/spinner/spinner.component.js";
import type { LynkSplitPanel } from "../../components/split-panel/split-panel.component.js";
import type { LynkStack } from "../../components/stack/stack.component.js";
import type { LynkSwitch } from "../../components/switch/switch.component.js";
import type { LynkTab } from "../../components/tab/tab.component.js";
import type { LynkTabGroup } from "../../components/tab-group/tab-group.component.js";
import type { LynkTabPanel } from "../../components/tab-panel/tab-panel.component.js";
import type { LynkTable } from "../../components/table/table.component.js";
import type { LynkTag } from "../../components/tag/tag.component.js";
import type { LynkTbody } from "../../components/tbody/tbody.component.js";
import type { LynkTd } from "../../components/td/td.component.js";
import type { LynkTextarea } from "../../components/textarea/textarea.component.js";
import type { LynkTh } from "../../components/th/th.component.js";
import type { LynkThead } from "../../components/thead/thead.component.js";
import type { LynkTooltip } from "../../components/tooltip/tooltip.component.js";
import type { LynkTr } from "../../components/tr/tr.component.js";
import type { LynkTruncate } from "../../components/truncate/truncate.component.js";
import type { LynkVisuallyHidden } from "../../components/visually-hidden/visually-hidden.component.js";
import type { LynkWisp } from "../../components/wisp/wisp.component.js";

type LynkAccordionProps = {
  /** Allow multiple panels to be open at the same time or automatically collapse other panels */
  multiple?: LynkAccordion["multiple"];
  /** Allow multiple panels to be open at the same time or automatically collapse other panels */
  density?: LynkAccordion["density"];
  /** Allow multiple panels to be open at the same time or automatically collapse other panels */
  shape?: LynkAccordion["shape"];
};

type LynkAlertProps = {
  /** Indicates whether or not the alert is open. You can use this in lieu of the show/hide methods. */
  open?: LynkAlert["open"];
  /** Makes the alert closable. */
  closable?: LynkAlert["closable"];
  /** The alert's type (color). */
  type?: LynkAlert["type"];
  /** The length of time, in milliseconds, the alert will show before closing itself. If the user interacts with
the alert before it closes (e.g. moves the mouse over it), the timer will restart. Defaults to `Infinity`. */
  duration?: LynkAlert["duration"];
  /** Enables a countdown that indicates the remaining time the alert will be displayed.
Typically used to indicate the remaining time before a whole app refresh. */
  countdown?: LynkAlert["countdown"];
  /**  */
  base?: LynkAlert["base"];
  /**  */
  countdownElement?: LynkAlert["countdownElement"];
  /** Emitted when the alert opens. */
  "onev-show"?: (e: CustomEvent<never>) => void;
  /** Emitted after the alert opens and all animations are complete. */
  "onev-after-show"?: (e: CustomEvent<never>) => void;
  /** Emitted when the alert closes. */
  "onev-hide"?: (e: CustomEvent<never>) => void;
  /** Emitted after the alert closes and all animations are complete. */
  "onev-after-hide"?: (e: CustomEvent<never>) => void;
};

type LynkAnimationProps = {
  /** The name of the built-in animation to use. For custom animations, use the `keyframes` prop. */
  name?: LynkAnimation["name"];
  /** Plays the animation. When omitted, the animation will be paused. This attribute will be automatically removed when
the animation finishes or gets canceled. */
  play?: LynkAnimation["play"];
  /** The number of milliseconds to delay the start of the animation. */
  delay?: LynkAnimation["delay"];
  /** Determines the direction of playback as well as the behavior when reaching the end of an iteration. */
  direction?: LynkAnimation["direction"];
  /** The number of milliseconds each iteration of the animation takes to complete. */
  duration?: LynkAnimation["duration"];
  /** The easing function to use for the animation. This can be a Lynk's easing function or a custom easing function
such as `cubic-bezier(0, 1, .76, 1.14)`. */
  easing?: LynkAnimation["easing"];
  /** The number of milliseconds to delay after the active period of an animation sequence. */
  "end-delay"?: LynkAnimation["endDelay"];
  /** Sets how the animation applies styles to its target before and after its execution. */
  fill?: LynkAnimation["fill"];
  /** The number of iterations to run before the animation completes. Defaults to `Infinity`, which loops. */
  iterations?: LynkAnimation["iterations"];
  /** The offset at which to start the animation, usually between 0 (start) and 1 (end). */
  "iteration-start"?: LynkAnimation["iterationStart"];
  /** Sets the animation's playback rate. The default is `1`, which plays the animation at a normal speed. Setting this
to `2`, for example, will double the animation's speed. A negative value can be used to reverse the animation. This
value can be changed without causing the animation to restart. */
  "playback-rate"?: LynkAnimation["playbackRate"];
  /**  */
  defaultSlot?: LynkAnimation["defaultSlot"];
  /** The keyframes to use for the animation. If this is set, `name` will be ignored. */
  keyframes?: LynkAnimation["keyframes"];
  /** Gets and sets the current animation time. */
  currentTime?: LynkAnimation["currentTime"];
  /** Emitted when the animation is canceled. */
  "onev-cancel"?: (e: CustomEvent<never>) => void;
  /** Emitted when the animation finishes. */
  "onev-finish"?: (e: CustomEvent<never>) => void;
  /** Emitted when the animation starts or restarts. */
  "onev-start"?: (e: CustomEvent<never>) => void;
};

type LynkAutoGridProps = {
  /** How to justify auto-grid items */
  "auto-size"?: LynkAutoGrid["autoSize"];
  /** How to align auto-grid items to each-other */
  "min-size"?: LynkAutoGrid["minSize"];
  /** The space between auto-grid items. Use spacing tokens or any custom size. */
  gap?: LynkAutoGrid["gap"];
};

type LynkBadgeProps = {
  /** The badge's variant. */
  type?: LynkBadge["type"];
  /** Draws a pill-style badge with rounded edges. */
  pill?: LynkBadge["pill"];
  /** Makes the badge pulsate to draw attention. */
  pulse?: LynkBadge["pulse"];
};

type LynkBoxProps = {};

type LynkBreadcrumbProps = {
  /** The label to use for the breadcrumb control. This will not be shown on the screen, but it will be announced by
screen readers and other assistive devices to provide more context for users. */
  label?: LynkBreadcrumb["label"];
  /**  */
  defaultSlot?: LynkBreadcrumb["defaultSlot"];
  /**  */
  separatorSlot?: LynkBreadcrumb["separatorSlot"];
};

type LynkBreadcrumbItemProps = {
  /** Optional URL to direct the user to when the breadcrumb item is activated. When set, a link will be rendered
internally. When unset, a button will be rendered instead. */
  href?: LynkBreadcrumbItem["href"];
  /** Tells the browser where to open the link. Only used when `href` is set. */
  target?: LynkBreadcrumbItem["target"];
  /** The `rel` attribute to use on the link. Only used when `href` is set. */
  rel?: LynkBreadcrumbItem["rel"];
  /**  */
  defaultSlot?: LynkBreadcrumbItem["defaultSlot"];
};

type LynkButtonProps = {
  /**  */
  title?: LynkButton["title"];
  /** The button's color. */
  color?: LynkButton["color"];
  /** The button's size. */
  size?: LynkButton["size"];
  /** Display the button component as a block instead of inline-block. */
  block?: LynkButton["block"];
  /** Draws the button with a caret for use with dropdowns, popovers, etc. */
  caret?: LynkButton["caret"];
  /** Disables the button. */
  disabled?: LynkButton["disabled"];
  /** Draws the button in a thinking state. */
  thinking?: LynkButton["thinking"];
  /** Draws an outlined button. */
  outline?: LynkButton["outline"];
  /** Draws an button without borders and background. */
  stealth?: LynkButton["stealth"];
  /** Draws a pill-style button with rounded edges. */
  pill?: LynkButton["pill"];
  /** Draws a circular icon button. When this attribute is present, the button expects a single `<lynk-icon>` in the
default slot. */
  circle?: LynkButton["circle"];
  /** Draws a square icon button. When this attribute is present, the button expects a single `<lynk-icon>` in the
default slot. */
  square?: LynkButton["square"];
  /** The type of button. When the type is `submit`, the button will submit the surrounding form. Note that the default
value is `button` instead of `submit`, which is opposite of how native `<button>` elements behave. */
  type?: LynkButton["type"];
  /** The name of the button, submitted as a name/value pair with form data, but only when this button is the submitter.
This attribute is ignored when `href` is present. */
  name?: LynkButton["name"];
  /** The value of the button, submitted as a pair with the button's name as part of the form data, but only when this
button is the submitter. This attribute is ignored when `href` is present. */
  value?: LynkButton["value"];
  /** When set, the underlying button will be rendered as an `<a>` with this `href` instead of a `<button>`. */
  href?: LynkButton["href"];
  /** Tells the browser where to open the link. Only used when `href` is set. */
  target?: LynkButton["target"];
  /** When using `href`, this attribute will map to the underlying link's `rel` attribute. Unlike regular links, the
default is `noreferrer noopener` to prevent security exploits. However, if you're using `target` to point to a
specific tab/window, this will prevent that from working correctly. You can remove or change the default value by
setting the attribute to an empty string or a value of your choice, respectively. */
  rel?: LynkButton["rel"];
  /** Tells the browser to download the linked file as this filename. Only used when `href` is set. */
  download?: LynkButton["download"];
  /** The "form owner" to associate the button with. If omitted, the closest containing form will be used instead. The
value of this attribute must be an id of a form in the same document or shadow root as the button. */
  form?: LynkButton["form"];
  /** Used to override the form owner's `action` attribute. */
  formaction?: LynkButton["formAction"];
  /** Used to override the form owner's `enctype` attribute. */
  formenctype?: LynkButton["formEnctype"];
  /** Used to override the form owner's `method` attribute. */
  formmethod?: LynkButton["formMethod"];
  /** Used to override the form owner's `novalidate` attribute. */
  formnovalidate?: LynkButton["formNoValidate"];
  /** Used to override the form owner's `target` attribute. */
  formtarget?: LynkButton["formTarget"];
  /** Used to override the default event bubbling. */
  "no-bubble"?: LynkButton["noBubble"];
  /**  */
  button?: LynkButton["button"];
  /**  */
  invalid?: LynkButton["invalid"];
  /** Gets the validity state object */
  validity?: LynkButton["validity"];
  /** Gets the validation message */
  validationMessage?: LynkButton["validationMessage"];
  /** Emitted when the button loses focus. */
  "onev-blur"?: (e: CustomEvent<never>) => void;
  /** Emitted when the button is clicked. */
  "onev-click"?: (e: CustomEvent<never>) => void;
  /** Emitted when the button gains focus. */
  "onev-focus"?: (e: CustomEvent<never>) => void;
  /** Emitted when the form control has been checked for validity and its constraints aren't satisfied.. */
  "onev-invalid"?: (e: CustomEvent<never>) => void;
};

type LynkButtonGroupProps = {
  /** A label to use for the button group. This won't be displayed on the screen, but it will be announced by assistive
devices when interacting with the control and is strongly recommended. */
  label?: LynkButtonGroup["label"];
  /**  */
  defaultSlot?: LynkButtonGroup["defaultSlot"];
  /**  */
  disableRole?: LynkButtonGroup["disableRole"];
};

type LynkCardProps = {
  /** Draws the card without outlines or background except when being interacted with */
  stealth?: LynkCard["stealth"];
  /** The component's size. Will be inherited by any descendants with a size attribute. */
  size?: LynkCard["size"];
  /** Draws the card using status colors */
  state?: LynkCard["state"];
  /** Determines whether to style the card on hover */
  interactive?: LynkCard["interactive"];
  /** Draws the card in a highlighted state */
  active?: LynkCard["active"];
  /** Pulse the status colors for increased visibility */
  pulse?: LynkCard["pulse"];
  /** The image block aspect ratio. */
  "aspect-ratio"?: LynkCard["aspectRatio"];
};

type LynkCheckboxProps = {
  /**  */
  title?: LynkCheckbox["title"];
  /** Name of the HTML form control. Submitted with the form as part of a name/value pair. */
  name?: LynkCheckbox["name"];
  /** The current value of the checkbox, submitted as a name/value pair with form data. */
  value?: LynkCheckbox["value"];
  /** The checkbox's size. */
  size?: LynkCheckbox["size"];
  /** Disables the checkbox. */
  disabled?: LynkCheckbox["disabled"];
  /** Draws the checkbox in a checked state. */
  checked?: LynkCheckbox["checked"];
  /** Draws the checkbox in an indeterminate state. This is usually applied to checkboxes that represents a "select
all/none" behavior when associated checkboxes have a mix of checked and unchecked states. */
  indeterminate?: LynkCheckbox["indeterminate"];
  /** By default, form controls are associated with the nearest containing `<form>` element. This attribute allows you
to place the form control outside of a form and associate it with the form that has this `id`. The form must be in
the same document or shadow root for this to work. */
  form?: LynkCheckbox["form"];
  /** Makes the checkbox a required field. */
  required?: LynkCheckbox["required"];
  /** Used to override the default event bubbling. */
  "no-bubble"?: LynkCheckbox["noBubble"];
  /** The input's validity state when using manual validation or set automatically to `error` or `success` when field uses Constraint Validation */
  state?: LynkCheckbox["state"];
  /** The checkbox's help text. If you need to display HTML, use the `help-text` slot instead. */
  "help-text"?: LynkCheckbox["helpText"];
  /**  */
  defaultSlot?: LynkCheckbox["defaultSlot"];
  /**  */
  input?: LynkCheckbox["input"];
  /** The default value of the form control. Primarily used for resetting the form control. */
  defaultChecked?: LynkCheckbox["defaultChecked"];
  /** Gets the validity state object */
  validity?: LynkCheckbox["validity"];
  /** Gets the validation message */
  validationMessage?: LynkCheckbox["validationMessage"];
  /** Emitted when the control loses focus. */
  "onev-blur"?: (e: CustomEvent<never>) => void;
  /** Emitted when the control's checked state changes. */
  "onev-change"?: (e: CustomEvent<never>) => void;
  /** Emitted when the control gains focus. */
  "onev-focus"?: (e: CustomEvent<never>) => void;
  /** Emitted when the checkbox receives input. */
  "onev-input"?: (e: CustomEvent<never>) => void;
  /** Emitted when the form control has been checked for validity and its constraints aren't satisfied. */
  "onev-invalid"?: (e: CustomEvent<never>) => void;
};

type LynkColProps = {};

type LynkColGroupProps = {};

type LynkComboboxProps = {
  /** The name of the combobox, submitted as a name/value pair with form data. */
  name?: LynkCombobox["name"];
  /** The current value of the combobox, submitted as a name/value pair with form data. */
  value?: LynkCombobox["value"];
  /** The input's validity state when using manual validation or set automatically to `error` or `success` when field uses Constraint Validation */
  state?: LynkCombobox["state"];
  /** The combobox's size. */
  size?: LynkCombobox["size"];
  /** Placeholder text to show as a hint when the combobox is empty. */
  placeholder?: LynkCombobox["placeholder"];
  /** Disables the combobox control. */
  disabled?: LynkCombobox["disabled"];
  /** Adds a clear button when the combobox is not empty. */
  clearable?: LynkCombobox["clearable"];
  /** Indicates whether or not the combobox is open.
You can toggle this attribute to show and hide the listbox, or you can use the `show()`
and `hide()` methods and this attribute will reflect the combobox's open state. */
  open?: LynkCombobox["open"];
  /** Enable this option to prevent the listbox from being clipped,
when the component is placed inside a container with `overflow: auto|scroll`.
Hoisting uses a fixed positioning strategy that works in many, but not all, scenarios. */
  hoist?: LynkCombobox["hoist"];
  /** The combobox's label. If you need to display HTML, use the `label` slot instead. */
  label?: LynkCombobox["label"];
  /** The preferred placement of the combobox's menu.
Note that the actual placement may vary as needed to keep the listbox inside of the viewport. */
  placement?: LynkCombobox["placement"];
  /** The help tooltip appended to the label. Alternatively, you can use the help-tip slot. */
  "help-tip"?: LynkCombobox["helpTip"];
  /** The combobox's help text. If you need to display HTML, use the `help-text` slot instead. */
  "help-text"?: LynkCombobox["helpText"];
  /** By default, form controls are associated with the nearest containing `<form>` element.
This attribute allows you to place the form control outside of a form and associate it
with the form that has this `id`.
The form must be in the same document or shadow root for this to work. */
  form?: LynkCombobox["form"];
  /** The combobox's required attribute. */
  required?: LynkCombobox["required"];
  /** A function that customizes the rendered option. The first argument is the option, the second
is the query string, which is typed into the combobox.
The function should return either a Lit TemplateResult or a string containing trusted HTML
to render in the shown list of filtered options.
If the query string should be highlighted use the `highlightOptionRenderer` function. */
  getOption?: LynkCombobox["getOption"];
  /** A function used to filter options in the combobox component.
The default filter method is a case- and diacritic-insensitive string comparison. */
  filter?: LynkCombobox["filter"];
  /**  */
  popup?: LynkCombobox["popup"];
  /**  */
  combobox?: LynkCombobox["combobox"];
  /**  */
  displayInput?: LynkCombobox["displayInput"];
  /**  */
  valueInput?: LynkCombobox["valueInput"];
  /**  */
  listbox?: LynkCombobox["listbox"];
  /**  */
  displayLabel?: LynkCombobox["displayLabel"];
  /**  */
  selectedOption?: LynkCombobox["selectedOption"];
  /**  */
  numberFilteredOptions?: LynkCombobox["numberFilteredOptions"];
  /**  */
  cachedOptions?: LynkCombobox["cachedOptions"];
  /** The default value of the form control. Primarily used for resetting the form control. */
  defaultValue?: LynkCombobox["defaultValue"];
  /** Gets the validity state object */
  validity?: LynkCombobox["validity"];
  /** Gets the validation message */
  validationMessage?: LynkCombobox["validationMessage"];
  /** Emitted when the control's value changes. */
  "onev-change"?: (e: CustomEvent<never>) => void;
  /** Emitted when the control's value is cleared. */
  "onev-clear"?: (e: CustomEvent<never>) => void;
  /** Emitted when the control receives input. */
  "onev-input"?: (e: CustomEvent<never>) => void;
  /** Emitted when the control gains focus. */
  "onev-focus"?: (e: CustomEvent<never>) => void;
  /** Emitted when the control loses focus. */
  "onev-blur"?: (e: CustomEvent<never>) => void;
  /** Emitted when the combobox's menu opens. */
  "onev-show"?: (e: CustomEvent<never>) => void;
  /** Emitted after the combobox's menu opens and all animations are complete. */
  "onev-after-show"?: (e: CustomEvent<never>) => void;
  /** Emitted when the combobox's menu closes. */
  "onev-hide"?: (e: CustomEvent<never>) => void;
  /** Emitted after the combobox's menu closes and all animations are complete. */
  "onev-after-hide"?: (e: CustomEvent<never>) => void;
  /** Emitted when the form control has been checked for validity and its constraints aren't satisfied. */
  "onev-invalid"?: (e: CustomEvent<never>) => void;
  /** Emitted when the combobox menu fails to open. */
  "onev-error"?: (e: CustomEvent<never>) => void;
};

type LynkCopyButtonProps = {
  /** The text value to copy. */
  value?: LynkCopyButton["value"];
  /** An id that references an element in the same document from which data will be copied. If both this and `value` are
present, this value will take precedence. By default, the target element's `textContent` will be copied. To copy an
attribute, append the attribute name wrapped in square brackets, e.g. `from="el[value]"`. To copy a property,
append a dot and the property name, e.g. `from="el.value"`. */
  from?: LynkCopyButton["from"];
  /** Disables the copy button. */
  disabled?: LynkCopyButton["disabled"];
  /** A custom label to show in the tooltip. */
  "copy-label"?: LynkCopyButton["copyLabel"];
  /** A custom label to show in the tooltip after copying. */
  "success-label"?: LynkCopyButton["successLabel"];
  /** A custom label to show in the tooltip when a copy error occurs. */
  "error-label"?: LynkCopyButton["errorLabel"];
  /** The length of time to show feedback before restoring the default trigger. */
  "feedback-duration"?: LynkCopyButton["feedbackDuration"];
  /** The preferred placement of the tooltip. */
  "tooltip-placement"?: LynkCopyButton["tooltipPlacement"];
  /** Enable this option to prevent the tooltip from being clipped when the component is placed inside a container with
`overflow: auto|hidden|scroll`. Hoisting uses a fixed positioning strategy that works in many, but not all,
scenarios. */
  hoist?: LynkCopyButton["hoist"];
  /**  */
  copyIcon?: LynkCopyButton["copyIcon"];
  /**  */
  successIcon?: LynkCopyButton["successIcon"];
  /**  */
  errorIcon?: LynkCopyButton["errorIcon"];
  /**  */
  tooltip?: LynkCopyButton["tooltip"];
  /**  */
  isCopying?: LynkCopyButton["isCopying"];
  /**  */
  status?: LynkCopyButton["status"];
  /** Emitted when the data has been copied. */
  "onev-copy"?: (e: CustomEvent<never>) => void;
  /** Emitted when the data could not be copied. */
  "onev-error"?: (e: CustomEvent<never>) => void;
};

type LynkDialogProps = {
  /** Indicates whether or not the dialog is open. You can toggle this attribute to show and hide the dialog, or you can
use the `show()` and `hide()` methods and this attribute will reflect the dialog's open state. */
  open?: LynkDialog["open"];
  /** The dialog's label as displayed in the header. You should always include a relevant label even when using
`no-header`, as it is required for proper accessibility. If you need to display HTML, use the `label` slot instead. */
  label?: LynkDialog["label"];
  /** Disables the header. This will also remove the default close button, so please ensure you provide an easy,
accessible way for users to dismiss the dialog. */
  "no-header"?: LynkDialog["noHeader"];
  /** The dialog's size. */
  size?: LynkDialog["size"];
  /** Exposes the internal modal utility that controls focus trapping. To temporarily disable focus trapping and allow third-party modals spawned from an active Lynk modal, call `modal.activateExternal()` when the third-party modal opens. Upon closing, call `modal.deactivateExternal()` to restore Lynk's focus trapping. */
  modal?: LynkDialog["modal"];
  /**  */
  dialog?: LynkDialog["dialog"];
  /**  */
  panel?: LynkDialog["panel"];
  /**  */
  overlay?: LynkDialog["overlay"];
  /** Emitted when the dialog opens. */
  "onev-show"?: (e: CustomEvent<never>) => void;
  /** Emitted after the dialog opens and all animations are complete. */
  "onev-after-show"?: (e: CustomEvent<never>) => void;
  /** Emitted when the dialog closes. */
  "onev-hide"?: (e: CustomEvent<never>) => void;
  /** Emitted after the dialog closes and all animations are complete. */
  "onev-after-hide"?: (e: CustomEvent<never>) => void;
  /** Emitted when the dialog opens and is ready to receive focus. Calling `event.preventDefault()` will prevent focusing and allow you to set it on a different element, such as an input. */
  "onev-initial-focus"?: (e: CustomEvent<never>) => void;
  /** Emitted when the user attempts to close the dialog by clicking the close button, clicking the overlay, or pressing escape. Calling `event.preventDefault()` will keep the dialog open. Avoid using this unless closing the dialog will result in destructive behavior such as data loss. */
  "onev-request-close"?: (e: CustomEvent<{ source: "close-button" | "keyboard" | "overlay" }>) => void;
};

type LynkDividerProps = {
  /** Draws the divider in a vertical orientation. */
  vertical?: LynkDivider["vertical"];
};

type LynkDrawerProps = {
  /** Indicates whether or not the drawer is open. You can toggle this attribute to show and hide the drawer, or you can
use the `show()` and `hide()` methods and this attribute will reflect the drawer's open state. */
  open?: LynkDrawer["open"];
  /** The drawer's label as displayed in the header. You should always include a relevant label even when using
`no-header`, as it is required for proper accessibility. If you need to display HTML, you can use the `label` slot
instead. */
  label?: LynkDrawer["label"];
  /** The direction from which the drawer will open. */
  placement?: LynkDrawer["placement"];
  /** By default, the drawer slides out of its containing block (usually the viewport). To make the drawer slide out of
its parent element, set this prop and add `position: relative` to the parent. */
  contained?: LynkDrawer["contained"];
  /** Removes the header. This will also remove the default close button, so please ensure you provide an easy,
accessible way for users to dismiss the drawer. */
  "no-header"?: LynkDrawer["noHeader"];
  /** Exposes the internal modal utility that controls focus trapping. To temporarily disable focus trapping and allow third-party modals spawned from an active Lynk modal, call `modal.activateExternal()` when the third-party modal opens. Upon closing, call `modal.deactivateExternal()` to restore Lynk's focus trapping. */
  modal?: LynkDrawer["modal"];
  /**  */
  drawer?: LynkDrawer["drawer"];
  /**  */
  panel?: LynkDrawer["panel"];
  /**  */
  overlay?: LynkDrawer["overlay"];
  /** Emitted when the drawer opens. */
  "onev-show"?: (e: CustomEvent<never>) => void;
  /** Emitted after the drawer opens and all animations are complete. */
  "onev-after-show"?: (e: CustomEvent<never>) => void;
  /** Emitted when the drawer closes. */
  "onev-hide"?: (e: CustomEvent<never>) => void;
  /** Emitted after the drawer closes and all animations are complete. */
  "onev-after-hide"?: (e: CustomEvent<never>) => void;
  /** Emitted when the drawer opens and is ready to receive focus. Calling `event.preventDefault()` will prevent focusing and allow you to set it on a different element, such as an input. */
  "onev-initial-focus"?: (e: CustomEvent<never>) => void;
  /** Emitted when the user attempts to close the drawer by clicking the close button, clicking the overlay, or pressing escape. Calling `event.preventDefault()` will keep the drawer open. Avoid using this unless closing the drawer will result in destructive behavior such as data loss. */
  "onev-request-close"?: (e: CustomEvent<{ source: "close-button" | "keyboard" | "overlay" }>) => void;
};

type LynkDropdownProps = {
  /** Indicates whether or not the dropdown is open. You can toggle this attribute to show and hide the dropdown, or you
can use the `show()` and `hide()` methods and this attribute will reflect the dropdown's open state. */
  open?: LynkDropdown["open"];
  /** The preferred placement of the dropdown panel. Note that the actual placement may vary as needed to keep the panel
inside of the viewport. */
  placement?: LynkDropdown["placement"];
  /** Disables the dropdown so the panel will not open. */
  disabled?: LynkDropdown["disabled"];
  /** By default, the dropdown is closed when an item is selected. This attribute will keep it open instead. Useful for
controls that allow multiple selections. */
  "stay-open-on-select"?: LynkDropdown["stayOpenOnSelect"];
  /** The distance in pixels from which to offset the panel away from its trigger. */
  distance?: LynkDropdown["distance"];
  /** The distance in pixels from which to offset the panel along its trigger. */
  skidding?: LynkDropdown["skidding"];
  /** Display the dropdown component as a block instead of inline-block. */
  block?: LynkDropdown["block"];
  /** Enable this option to prevent the panel from being clipped when the component is placed inside a container with
`overflow: auto|scroll`. Hoisting uses a fixed positioning strategy that works in many, but not all, scenarios. */
  hoist?: LynkDropdown["hoist"];
  /** Syncs the popup width or height to that of the trigger element. */
  sync?: LynkDropdown["sync"];
  /**  */
  popup?: LynkDropdown["popup"];
  /**  */
  trigger?: LynkDropdown["trigger"];
  /**  */
  panel?: LynkDropdown["panel"];
  /** The dropdown will close when the user interacts outside of this element (e.g. clicking). Useful for composing other
components that use a dropdown internally. */
  containingElement?: LynkDropdown["containingElement"];
  /** Emitted when the dropdown opens. */
  "onev-show"?: (e: CustomEvent<never>) => void;
  /** Emitted after the dropdown opens and all animations are complete. */
  "onev-after-show"?: (e: CustomEvent<never>) => void;
  /** Emitted when the dropdown closes. */
  "onev-hide"?: (e: CustomEvent<never>) => void;
  /** Emitted after the dropdown closes and all animations are complete. */
  "onev-after-hide"?: (e: CustomEvent<never>) => void;
};

type LynkFormFieldProps = {
  /** The fields's styled validity state */
  state?: LynkFormField["state"];
  /** The input's size. */
  size?: LynkFormField["size"];
  /** The input's label. Alternatively, you can use the label slot. */
  label?: LynkFormField["label"];
  /**  */
  id?: LynkFormField["id"];
  /** The help text below the input. Alternatively, you can use the help-text slot. */
  "help-text"?: LynkFormField["helpText"];
  /** The help tooltip appended to the label. Alternatively, you can use the help-tip slot. */
  "help-tip"?: LynkFormField["helpTip"];
  /** Adds the required mark. */
  required?: LynkFormField["required"];
  /**  */
  defaultSlot?: LynkFormField["defaultSlot"];
  /** The field will lose focus when the user interacts outside of this element (e.g. clicking). */
  containingElement?: LynkFormField["containingElement"];
  /** Emitted when field or slotted element gains focus. */
  "onev-focus"?: (e: CustomEvent<never>) => void;
  /** Emitted when field or slotted element loses focus. */
  "onev-blur"?: (e: CustomEvent<never>) => void;
};

type LynkFormatBytesProps = {
  /** The number to format in bytes. */
  value?: LynkFormatBytes["value"];
  /** The type of unit to display. */
  unit?: LynkFormatBytes["unit"];
  /** Determines how to display the result, e.g. "100 bytes", "100 b", or "100b". */
  display?: LynkFormatBytes["display"];
};

type LynkFormatDateProps = {
  /** The date/time to format. If not set, the current date and time will be used. When passing a string, it's strongly
recommended to use the ISO 8601 format to ensure timezones are handled correctly. To convert a date to this format
in JavaScript, use [`date.toISOString()`](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date/toISOString). */
  date?: LynkFormatDate["date"];
  /** The format for displaying the weekday. */
  weekday?: LynkFormatDate["weekday"];
  /** The format for displaying the era. */
  era?: LynkFormatDate["era"];
  /** The format for displaying the year. */
  year?: LynkFormatDate["year"];
  /** The format for displaying the month. */
  month?: LynkFormatDate["month"];
  /** The format for displaying the day. */
  day?: LynkFormatDate["day"];
  /** The format for displaying the hour. */
  hour?: LynkFormatDate["hour"];
  /** The format for displaying the minute. */
  minute?: LynkFormatDate["minute"];
  /** The format for displaying the second. */
  second?: LynkFormatDate["second"];
  /** The format for displaying the time. */
  "time-zone-name"?: LynkFormatDate["timeZoneName"];
  /** The time zone to express the time in. */
  "time-zone"?: LynkFormatDate["timeZone"];
  /** When set, 24 hour time will always be used. */
  "hour-format"?: LynkFormatDate["hourFormat"];
};

type LynkGridProps = {
  /** A container of grid items */
  container?: LynkGrid["container"];
  /** A singular grid item */
  item?: LynkGrid["item"];
  /** The flow direction of grid items, requires container property being set */
  direction?: LynkGrid["direction"];
  /** How to justify grid items, requires container property */
  justify?: LynkGrid["justify"];
  /** Hot to align grid items to each-other, requires container property */
  align?: LynkGrid["align"];
  /** The width of a grid item. Requires item property  being set. This can be a single string or an array. */
  span?: LynkGrid["span"];
  /** The space between grid items. Uses spacing token sizes. */
  gap?: LynkGrid["gap"];
};

type LynkFormatNumberProps = {
  /** The number to format. */
  value?: LynkFormatNumber["value"];
  /** The formatting style to use. */
  type?: LynkFormatNumber["type"];
  /** Turns off grouping separators. */
  "no-grouping"?: LynkFormatNumber["noGrouping"];
  /** The currency to use when formatting. Must be an ISO 4217 currency code such as `USD` or `EUR`. */
  currency?: LynkFormatNumber["currency"];
  /** How to display the currency. */
  "currency-display"?: LynkFormatNumber["currencyDisplay"];
  /** The minimum number of integer digits to use. Possible values are 1 - 21. */
  "minimum-integer-digits"?: LynkFormatNumber["minimumIntegerDigits"];
  /** The minimum number of fraction digits to use. Possible values are 0 - 20. */
  "minimum-fraction-digits"?: LynkFormatNumber["minimumFractionDigits"];
  /** The maximum number of fraction digits to use. Possible values are 0 - 20. */
  "maximum-fraction-digits"?: LynkFormatNumber["maximumFractionDigits"];
  /** The minimum number of significant digits to use. Possible values are 1 - 21. */
  "minimum-significant-digits"?: LynkFormatNumber["minimumSignificantDigits"];
  /** The maximum number of significant digits to use,. Possible values are 1 - 21. */
  "maximum-significant-digits"?: LynkFormatNumber["maximumSignificantDigits"];
};

type LynkIconProps = {
  /** The name of the icon to draw. Available names depend on the icon library being used. */
  name?: LynkIcon["name"];
  /** An external URL of an SVG file. Be sure you trust the content you are including, as it will be executed as code and
can result in XSS attacks. */
  src?: LynkIcon["src"];
  /** An alternate description to use for assistive devices. If omitted, the icon will be considered presentational and
ignored by assistive devices. */
  label?: LynkIcon["label"];
  /** The name of a registered custom icon library. */
  library?: LynkIcon["library"];

  /** Emitted when the icon has loaded. When using `spriteSheet: true` this will not emit. */
  "onev-load"?: (e: CustomEvent<never>) => void;
  /** Emitted when the icon fails to load due to an error. When using `spriteSheet: true` this will not emit. */
  "onev-error"?: (e: CustomEvent<never>) => void;
};

type LynkIconButtonProps = {
  /** The button's color. */
  color?: LynkIconButton["color"];
  /** The name of the icon to draw. */
  name?: LynkIconButton["name"];
  /** The name of a registered custom icon library. */
  library?: LynkIconButton["library"];
  /** An external URL of an SVG file. */
  src?: LynkIconButton["src"];
  /** When set, the underlying button will be rendered as an `<a>` with this `href` instead of a `<button>`. */
  href?: LynkIconButton["href"];
  /** Tells the browser where to open the link. Only used when `href` is set. */
  target?: LynkIconButton["target"];
  /** Tells the browser to download the linked file as this filename. Only used when `href` is set. */
  download?: LynkIconButton["download"];
  /** A description that gets read by screen readers and other assistive devices. For optimal accessibility, you should
always include a label that describes what the icon button does. */
  label?: LynkIconButton["label"];
  /** Disables the button. */
  disabled?: LynkIconButton["disabled"];
  /**  */
  button?: LynkIconButton["button"];
  /** Emitted when the icon button loses focus. */
  "onev-blur"?: (e: CustomEvent<never>) => void;
  /** Emitted when the button is clicked. */
  "onev-click"?: (e: CustomEvent<never>) => void;
  /** Emitted when the icon button gains focus. */
  "onev-focus"?: (e: CustomEvent<never>) => void;
};

type LynkIncludeProps = {
  /** The location of the HTML file to include. Be sure you trust the content you are including as it will be executed as
code and can result in XSS attacks. */
  src?: LynkInclude["src"];
  /** The fetch mode to use. */
  mode?: LynkInclude["mode"];
  /** Allows included scripts to be executed. Be sure you trust the content you are including as it will be executed as
code and can result in XSS attacks. */
  "allow-scripts"?: LynkInclude["allowScripts"];

  /** Emitted when the included file is loaded. */
  "onev-load"?: (e: CustomEvent<never>) => void;
  /** Emitted when the included file fails to load due to an error. */
  "onev-error"?: (e: CustomEvent<{ status: number }>) => void;
};

type LynkInputProps = {
  /**  */
  title?: LynkInput["title"];
  /** The type of input. Works the same as a native `<input>` element, but only a subset of types are supported. Defaults
to `text`. */
  type?: LynkInput["type"];
  /** The input's name attribute. */
  name?: LynkInput["name"];
  /** The input's value attribute. */
  value?: LynkInput["value"];
  /** The input's validity state when using manual validation or set automatically to `error` or `success` when field uses Constraint Validation */
  state?: LynkInput["state"];
  /** The input's size. */
  size?: LynkInput["size"];
  /** Draws a filled input. */
  filled?: LynkInput["filled"];
  /** Draws a pill-style input with rounded edges. */
  pill?: LynkInput["pill"];
  /** The input's label. Alternatively, you can use the label slot. */
  label?: LynkInput["label"];
  /** The help text below the input. Alternatively, you can use the help-text slot. */
  "help-text"?: LynkInput["helpText"];
  /** The help tooltip appended to the label. Alternatively, you can use the help-tip slot. */
  "help-tip"?: LynkInput["helpTip"];
  /** Adds a clear button when the input is populated. */
  clearable?: LynkInput["clearable"];
  /** Disables the input. */
  disabled?: LynkInput["disabled"];
  /** Placeholder text to show as a hint when the input is empty. */
  placeholder?: LynkInput["placeholder"];
  /** Makes the input readonly. */
  readonly?: LynkInput["readonly"];
  /** Replaces the input with a plain text string. */
  restricted?: LynkInput["restricted"];
  /** Adds a button to toggle the password's visibility. Only applies to password types. */
  "password-toggle"?: LynkInput["passwordToggle"];
  /** Determines whether or not the password is currently visible. Only applies to password input types. */
  "password-visible"?: LynkInput["passwordVisible"];
  /** Hides the browser's built-in increment/decrement spin buttons for number inputs. */
  "no-spin-buttons"?: LynkInput["noSpinButtons"];
  /** Will automatically display a picker if available when input receives focus */
  "auto-picker"?: LynkInput["autoPicker"];
  /** By default, form controls are associated with the nearest containing `<form>` element. This attribute allows you
to place the form control outside of a form and associate it with the form that has this `id`. The form must be in
the same document or shadow root for this to work. */
  form?: LynkInput["form"];
  /** Makes the input a required field. */
  required?: LynkInput["required"];
  /** A regular expression pattern to validate input against. */
  pattern?: LynkInput["pattern"];
  /** The minimum length of input that will be considered valid. */
  minlength?: LynkInput["minlength"];
  /** The maximum length of input that will be considered valid. */
  maxlength?: LynkInput["maxlength"];
  /** The input's minimum value. Only applies to date and number input types. */
  min?: LynkInput["min"];
  /** The input's maximum value. Only applies to date and number input types. */
  max?: LynkInput["max"];
  /** Specifies the granularity that the value must adhere to, or the special value `any` which means no stepping is
implied, allowing any numeric value. */
  step?: LynkInput["step"];
  /** The input's autocapitalize attribute. */
  autocapitalize?: LynkInput["autocapitalize"];
  /** Indicates whether the browser's autocorrect feature is on or off. */
  autocorrect?: LynkInput["autocorrect"];
  /** Specifies what permission the browser has to provide assistance in filling out form field values. Refer to
[this page on MDN](https://developer.mozilla.org/en-US/docs/Web/HTML/Attributes/autocomplete) for available values. */
  autocomplete?: LynkInput["autocomplete"];
  /** The input's autofocus attribute. */
  autofocus?: LynkInput["autofocus"];
  /** Used to customize the label or icon of the Enter key on virtual keyboards. */
  enterkeyhint?: LynkInput["enterkeyhint"];
  /** Enables spell checking on the input. */
  spellcheck?: LynkInput["spellcheck"];
  /** Tells the browser what type of data will be entered by the user, allowing it to display the appropriate virtual
keyboard on supportive devices. */
  inputmode?: LynkInput["inputmode"];
  /**  */
  input?: LynkInput["input"];
  /** Gets or sets the default value used to reset this element. The initial value corresponds to the one originally specified in the HTML that created this element. */
  defaultValue?: LynkInput["defaultValue"];
  /** Gets or sets the current value as a `Date` object. Returns `null` if the value can't be converted. This will use the native `<input type="{{type}}">` implementation and may result in an error. */
  valueAsDate?: LynkInput["valueAsDate"];
  /** Gets or sets the current value as a number. Returns `NaN` if the value can't be converted. */
  valueAsNumber?: LynkInput["valueAsNumber"];
  /** Gets the validity state object */
  validity?: LynkInput["validity"];
  /** Gets the validation message */
  validationMessage?: LynkInput["validationMessage"];
  /** Emitted when the control loses focus. */
  "onev-blur"?: (e: CustomEvent<never>) => void;
  /** Emitted when an alteration to the control's value is committed by the user. */
  "onev-change"?: (e: CustomEvent<never>) => void;
  /** Emitted when the clear button is activated. */
  "onev-clear"?: (e: CustomEvent<never>) => void;
  /** Emitted when the return key is pressed while the input has focus. */
  "onev-enter"?: (e: CustomEvent<never>) => void;
  /** Emitted when the control gains focus. */
  "onev-focus"?: (e: CustomEvent<never>) => void;
  /** Emitted when the control receives input. */
  "onev-input"?: (e: CustomEvent<never>) => void;
  /** Emitted when the form control has been checked for validity and its constraints aren't satisfied. */
  "onev-invalid"?: (e: CustomEvent<never>) => void;
};

type LynkIntersectionObserverProps = {
  /** Disables the observer. */
  disabled?: LynkIntersectionObserver["disabled"];

  /** Emitted when a slotted element enters the view. */
  "onev-enter-view"?: (e: CustomEvent<{ entry: IntersectionObserverEntry[] }>) => void;
  /** Emitted when a slotted element exits the view. */
  "onev-exit-view"?: (e: CustomEvent<{ entry: IntersectionObserverEntry[] }>) => void;
};

type LynkMenuProps = {
  /**  */
  defaultSlot?: LynkMenu["defaultSlot"];
  /** Emitted when a menu item is selected. */
  "onev-select"?: (e: CustomEvent<{ item: LynkMenuItem }>) => void;
};

type LynkMenuItemProps = {
  /** The type of menu item to render. To use `checked`, this value must be set to `checkbox`. */
  type?: LynkMenuItem["type"];
  /** Draws the item in a checked state. */
  checked?: LynkMenuItem["checked"];
  /** A unique value to store in the menu item. This can be used as a way to identify menu items when selected. */
  value?: LynkMenuItem["value"];
  /** Draws the menu item in a disabled state. */
  disabled?: LynkMenuItem["disabled"];
  /**  */
  defaultSlot?: LynkMenuItem["defaultSlot"];
  /**  */
  menuItem?: LynkMenuItem["menuItem"];
  /** Emitted when a menu item is clicked */
  "onev-click"?: (e: CustomEvent<never>) => void;
};

type LynkMenuLabelProps = {};

type LynkMutationObserverProps = {
  /** Watches for changes to attributes. To watch only specific attributes, separate them by a space, e.g.
`attr="class id title"`. To watch all attributes, use `*`. */
  attr?: LynkMutationObserver["attr"];
  /** Indicates whether or not the attribute's previous value should be recorded when monitoring changes. */
  "attr-old-value"?: LynkMutationObserver["attrOldValue"];
  /** Watches for changes to the character data contained within the node. */
  "char-data"?: LynkMutationObserver["charData"];
  /** Indicates whether or not the previous value of the node's text should be recorded. */
  "char-data-old-value"?: LynkMutationObserver["charDataOldValue"];
  /** Watches for the addition or removal of new child nodes. */
  "child-list"?: LynkMutationObserver["childList"];
  /** Disables the observer. */
  disabled?: LynkMutationObserver["disabled"];

  /** Emitted when a mutation occurs. */
  "onev-mutation"?: (e: CustomEvent<{ mutationList: MutationRecord[] }>) => void;
};

type LynkNavProps = {
  /**  */
  value?: LynkNav["value"];
  /** Simplifies the nav and draws the nav items in a slim style. */
  squished?: LynkNav["squished"];
  /**  */
  defaultSlot?: LynkNav["defaultSlot"];
  /** Emitted when a nav item is selected. */
  "onev-select"?: (e: CustomEvent<{ selection: LynkNavItem }>) => void;
};

type LynkNavGroupProps = {
  /** The nav groups heading label. Alternatively, you can use the label slot. */
  heading?: LynkNavGroup["heading"];
  /**  */
  squished?: LynkNavGroup["squished"];
};

type LynkNavItemProps = {
  /**  */
  squished?: LynkNavItem["squished"];
  /**  */
  title?: LynkNavItem["title"];
  /** An optional name for the button. Ignored when `href` is set. */
  name?: LynkNavItem["name"];
  /** A unique value to store in the nav item. This can be used as a way to identify nav items when selected. */
  value?: LynkNavItem["value"];
  /** When set, the underlying button will be rendered as an `<a>` with this `href` instead of a `<button>`. */
  href?: LynkNavItem["href"];
  /** Tells the browser where to open the link. Only used when `href` is set. */
  target?: LynkNavItem["target"];
  /** Tells the browser to download the linked file as this filename. Only used when `href` is set. */
  download?: LynkNavItem["download"];
  /** Draws the nav item in a highlighted or active state. */
  selected?: LynkNavItem["selected"];
  /** Displays nested child nav-items if slotted */
  expanded?: LynkNavItem["expanded"];
  /** Draws the nav item in a disabled state. */
  disabled?: LynkNavItem["disabled"];
  /** Disables the label and replaces with a tooltip. */
  "no-label"?: LynkNavItem["noLabel"];
  /**  */
  isParent?: LynkNavItem["isParent"];
  /**  */
  isChild?: LynkNavItem["isChild"];
  /**  */
  loading?: LynkNavItem["loading"];
  /**  */
  depth?: LynkNavItem["depth"];
  /**  */
  defaultSlot?: LynkNavItem["defaultSlot"];
  /**  */
  childrenSlot?: LynkNavItem["childrenSlot"];
  /**  */
  navItem?: LynkNavItem["navItem"];
  /**  */
  childrenContainer?: LynkNavItem["childrenContainer"];
  /** Emitted when the nav item expands. */
  "onev-expand"?: (e: CustomEvent<never>) => void;
  /** Emitted after the nav item expands and all animations are complete. */
  "onev-after-expand"?: (e: CustomEvent<never>) => void;
  /** Emitted when the nav item collapses. */
  "onev-collapse"?: (e: CustomEvent<never>) => void;
  /** Emitted after the nav item collapses and all animations are complete. */
  "onev-after-collapse"?: (e: CustomEvent<never>) => void;
};

type LynkOptgroupProps = {
  /** Disables all options in the optgroup. */
  disabled?: LynkOptgroup["disabled"];
  /** The optgroups label. If you need to display HTML, use the `label` slot instead. */
  label?: LynkOptgroup["label"];
  /**  */
  defaultSlot?: LynkOptgroup["defaultSlot"];
};

type LynkOptionProps = {
  /** The option's value. When selected, the containing form control will receive this value. The value must be unique
from other options in the same group. Values may not contain spaces, as spaces are used as delimiters when listing
multiple values. */
  value?: LynkOption["value"];
  /** Draws the option in a disabled state, preventing selection. */
  disabled?: LynkOption["disabled"];
  /**  */
  defaultSlot?: LynkOption["defaultSlot"];
  /**  */
  current?: LynkOption["current"];
  /**  */
  selected?: LynkOption["selected"];
  /**  */
  hasHover?: LynkOption["hasHover"];
};

type LynkPageProps = {};

type LynkPageContentProps = {
  /** Set an optional maximum width for page content */
  width?: LynkPageContent["width"];
  /**  */
  pageContent?: LynkPageContent["pageContent"];
};

type LynkPageFooterProps = {
  /** Set an optional maximum width for page header */
  width?: LynkPageFooter["width"];
};

type LynkPageHeaderProps = {
  /** Set an optional maximum width for page header */
  width?: LynkPageHeader["width"];
};

type LynkPageSidebarProps = {
  /** Indicates whether or not the sidebar is open. You can use this in lieu of the show/hide methods. */
  open?: LynkPageSidebar["open"];
  /** The sidebar optional heading as displayed in the header. If you need to display HTML, you can use the `header` slot instead. */
  heading?: LynkPageSidebar["heading"];
  /** The placement of the sidebar in the page layout */
  placement?: LynkPageSidebar["placement"];
  /** Choose if the toggle functionality collapses the contents, hides the sidebar entirely, or is disabled */
  toggle?: LynkPageSidebar["toggle"];
  /** Choose placement of toggle button when toggling contents */
  "toggle-placement"?: LynkPageSidebar["togglePlacement"];
  /** Customize toggle contents tooltip text */
  "toggle-tip-hide-text"?: LynkPageSidebar["toggleTipHideText"];
  /**  */
  "toggle-tip-show-text"?: LynkPageSidebar["toggleTipShowText"];
  /**  */
  sidebar?: LynkPageSidebar["sidebar"];
  /**  */
  container?: LynkPageSidebar["container"];
  /**  */
  body?: LynkPageSidebar["body"];
  /**  */
  header?: LynkPageSidebar["header"];
  /**  */
  footer?: LynkPageSidebar["footer"];
  /**  */
  tooltip?: LynkPageSidebar["tooltip"];
  /** Emitted when the sidebar opens. */
  "onev-show"?: (e: CustomEvent<never>) => void;
  /** Emitted after the sidebar opens and all animations are complete. */
  "onev-after-show"?: (e: CustomEvent<never>) => void;
  /** Emitted when the sidebar closes. */
  "onev-hide"?: (e: CustomEvent<never>) => void;
  /** Emitted after the sidebar closes and all animations are complete. */
  "onev-after-hide"?: (e: CustomEvent<never>) => void;
};

type LynkPanelProps = {
  /** Indicates whether or not the panel contents are visible. You can use this in lieu of the expand/collapse methods. */
  expanded?: LynkPanel["expanded"];
  /** Allow the panel contents to be toggled and enable supporting toggle controls */
  accordion?: LynkPanel["accordion"];
  /** Disables an accordion panel so it can't be toggled. */
  disabled?: LynkPanel["disabled"];
  /** The heading to show in the panel header. If you need to display HTML, use the `heading` slot instead. */
  heading?: LynkPanel["heading"];
  /** The trigger that will expand/collapse an accordion panel. */
  "toggle-trigger"?: LynkPanel["toggleTrigger"];
  /** Hide suffix when accordion is collapsed. */
  "toggle-suffix"?: LynkPanel["toggleSuffix"];
  /** The placement of the toggle icon in the header. */
  "toggle-icon-placement"?: LynkPanel["toggleIconPlacement"];
  /** Disables the header. This will also remove the default toggle-icon, so please ensure you provide an easy,
accessible way for users to toggle the panel if using as part of an accordion. */
  "no-header"?: LynkPanel["noHeader"];
  /**  */
  panel?: LynkPanel["panel"];
  /**  */
  header?: LynkPanel["header"];
  /**  */
  body?: LynkPanel["body"];
  /**  */
  toggleIconSlot?: LynkPanel["toggleIconSlot"];
  /** Emitted when the panel expands. */
  "onev-expand"?: (e: CustomEvent<never>) => void;
  /** Emitted after the panel expands and all animations are complete. */
  "onev-after-expand"?: (e: CustomEvent<never>) => void;
  /** Emitted when the panel closes. */
  "onev-collapse"?: (e: CustomEvent<never>) => void;
  /** Emitted after the panel closes and all animations are complete. */
  "onev-after-collapse"?: (e: CustomEvent<never>) => void;
};

type LynkPopoverProps = {
  /** Indicates whether or not the popover is open. You can use this in lieu of the show/hide methods. */
  open?: LynkPopover["open"];
  /** The popover's label as displayed in the header. You should always include a relevant label even when using
`no-header`, as it is required for proper accessibility. */
  label?: LynkPopover["label"];
  /** Disables the header. This will also remove the default close button, so please ensure you provide an easy,
accessible way for users to dismiss the popover. */
  "no-header"?: LynkPopover["noHeader"];
  /** Hides the arrow. */
  "no-arrow"?: LynkPopover["noArrow"];
  /** Hide the popover by clicking outside the panel. */
  "click-to-hide"?: LynkPopover["clickToHide"];
  /** The preferred placement of the popover panel. Note that the actual placement may vary as needed to keep the panel
inside of the viewport. */
  placement?: LynkPopover["placement"];
  /** Disables the popover so the panel will not open. */
  disabled?: LynkPopover["disabled"];
  /** The distance in pixels from which to offset the panel away from its trigger. */
  distance?: LynkPopover["distance"];
  /** The distance in pixels from which to offset the panel along its trigger. */
  skidding?: LynkPopover["skidding"];
  /** Display the popover component as a block instead of inline-block. */
  block?: LynkPopover["block"];
  /** Enable this option to prevent the panel from being clipped when the component is placed inside a container with
`overflow: auto|scroll`. */
  hoist?: LynkPopover["hoist"];
  /**  */
  popup?: LynkPopover["popup"];
  /**  */
  trigger?: LynkPopover["trigger"];
  /**  */
  panel?: LynkPopover["panel"];
  /** The popover will close when the user interacts outside of this element (e.g. clicking). */
  containingElement?: LynkPopover["containingElement"];
  /** Emitted when the popover opens. */
  "onev-show"?: (e: CustomEvent<never>) => void;
  /** Emitted after the popover opens and all animations are complete. */
  "onev-after-show"?: (e: CustomEvent<never>) => void;
  /** Emitted when the popover closes. */
  "onev-hide"?: (e: CustomEvent<never>) => void;
  /** Emitted after the popover closes and all animations are complete. */
  "onev-after-hide"?: (e: CustomEvent<never>) => void;
};

type LynkPopupProps = {
  /** The element the popup will be anchored to. If the anchor lives outside of the popup, you can provide the anchor
element `id`, a DOM element reference, or a `VirtualElement`. If the anchor lives inside the popup, use the
`anchor` slot instead. */
  anchor?: LynkPopup["anchor"];
  /** Activates the positioning logic and shows the popup. When this attribute is removed, the positioning logic is torn
down and the popup will be hidden. */
  active?: LynkPopup["active"];
  /** The preferred placement of the popup. Note that the actual placement will vary as configured to keep the
panel inside of the viewport. */
  placement?: LynkPopup["placement"];
  /** Determines how the popup is positioned. The `absolute` strategy works well in most cases, but if overflow is
clipped, using a `fixed` position strategy can often workaround it. */
  strategy?: LynkPopup["strategy"];
  /** The distance in pixels from which to offset the panel away from its anchor. */
  distance?: LynkPopup["distance"];
  /** The distance in pixels from which to offset the panel along its anchor. */
  skidding?: LynkPopup["skidding"];
  /** Attaches an arrow to the popup. The arrow's size and color can be customized using the `--arrow-size` and
`--arrow-color` custom properties. For additional customizations, you can also target the arrow using
`::part(arrow)` in your stylesheet. */
  arrow?: LynkPopup["arrow"];
  /** The placement of the arrow. The default is `anchor`, which will align the arrow as close to the center of the
anchor as possible, considering available space and `arrow-padding`. A value of `start`, `end`, or `center` will
align the arrow to the start, end, or center of the popover instead. */
  "arrow-placement"?: LynkPopup["arrowPlacement"];
  /** The amount of padding between the arrow and the edges of the popup. If the popup has a border-radius, for example,
this will prevent it from overflowing the corners. */
  "arrow-padding"?: LynkPopup["arrowPadding"];
  /** When set, placement of the popup will flip to the opposite site to keep it in view. You can use
`flipFallbackPlacements` to further configure how the fallback placement is determined. */
  flip?: LynkPopup["flip"];
  /** If the preferred placement doesn't fit, popup will be tested in these fallback placements until one fits. Must be a
string of any number of placements separated by a space, e.g. "top bottom left". If no placement fits, the flip
fallback strategy will be used instead. */
  "flip-fallback-placements"?: LynkPopup["flipFallbackPlacements"];
  /** When neither the preferred placement nor the fallback placements fit, this value will be used to determine whether
the popup should be positioned using the best available fit based on available space or as it was initially
preferred. */
  "flip-fallback-strategy"?: LynkPopup["flipFallbackStrategy"];
  /** The flip boundary describes clipping element(s) that overflow will be checked relative to when flipping. By
default, the boundary includes overflow ancestors that will cause the element to be clipped. If needed, you can
change the boundary by passing a reference to one or more elements to this property. */
  flipBoundary?: LynkPopup["flipBoundary"];
  /** The amount of padding, in pixels, to exceed before the flip behavior will occur. */
  "flip-padding"?: LynkPopup["flipPadding"];
  /** Moves the popup along the axis to keep it in view when clipped. */
  shift?: LynkPopup["shift"];
  /** The shift boundary describes clipping element(s) that overflow will be checked relative to when shifting. By
default, the boundary includes overflow ancestors that will cause the element to be clipped. If needed, you can
change the boundary by passing a reference to one or more elements to this property. */
  shiftBoundary?: LynkPopup["shiftBoundary"];
  /** The amount of padding, in pixels, to exceed before the shift behavior will occur. */
  "shift-padding"?: LynkPopup["shiftPadding"];
  /** When set, this will cause the popup to automatically resize itself to prevent it from overflowing. */
  "auto-size"?: LynkPopup["autoSize"];
  /** Syncs the popup's width or height to that of the anchor element. */
  sync?: LynkPopup["sync"];
  /** The auto-size boundary describes clipping element(s) that overflow will be checked relative to when resizing. By
default, the boundary includes overflow ancestors that will cause the element to be clipped. If needed, you can
change the boundary by passing a reference to one or more elements to this property. */
  autoSizeBoundary?: LynkPopup["autoSizeBoundary"];
  /** The amount of padding, in pixels, to exceed before the auto-size behavior will occur. */
  "auto-size-padding"?: LynkPopup["autoSizePadding"];
  /** When a gap exists between the anchor and the popup element, this option will add a "hover bridge" that fills the
gap using an invisible element. This makes listening for events such as `mouseenter` and `mouseleave` more sane
because the pointer never technically leaves the element. The hover bridge will only be drawn when the popover is
active. */
  "hover-bridge"?: LynkPopup["hoverBridge"];
  /** A reference to the internal popup container. Useful for animating and styling the popup with JavaScript. */
  popup?: LynkPopup["popup"];
  /** Emitted when the popup is repositioned. This event can fire a lot, so avoid putting expensive operations in your listener or consider debouncing it. */
  "onev-reposition"?: (e: CustomEvent<never>) => void;
};

type LynkProgressBarProps = {
  /** The current progress as a percentage, 0 to 100. */
  value?: LynkProgressBar["value"];
  /** When true, percentage is ignored, the label is hidden, and the progress bar is drawn in an indeterminate state. */
  indeterminate?: LynkProgressBar["indeterminate"];
  /** A custom label for assistive devices. */
  label?: LynkProgressBar["label"];
};

type LynkProgressRingProps = {
  /** The current progress as a percentage, 0 to 100. */
  value?: LynkProgressRing["value"];
  /** A custom label for assistive devices. */
  label?: LynkProgressRing["label"];
  /**  */
  indicator?: LynkProgressRing["indicator"];
  /**  */
  indicatorOffset?: LynkProgressRing["indicatorOffset"];
};

type LynkRadioProps = {
  /** The radio's value. When selected, the radio group will receive this value. */
  value?: LynkRadio["value"];
  /** The radio's size. */
  size?: LynkRadio["size"];
  /** Disables the radio. */
  disabled?: LynkRadio["disabled"];
  /**  */
  checked?: LynkRadio["checked"];
  /** Emitted when the control loses focus. */
  "onev-blur"?: (e: CustomEvent<never>) => void;
  /** Emitted when the control gains focus. */
  "onev-focus"?: (e: CustomEvent<never>) => void;
};

type LynkRadioButtonProps = {
  /** The radio's value. When selected, the radio group will receive this value. */
  value?: LynkRadioButton["value"];
  /** Disables the radio. */
  disabled?: LynkRadioButton["disabled"];
  /** The button's size. */
  size?: LynkRadioButton["size"];
  /** Draws a pill-style button with rounded edges. */
  pill?: LynkRadioButton["pill"];
  /**  */
  input?: LynkRadioButton["input"];
  /**  */
  hiddenInput?: LynkRadioButton["hiddenInput"];
  /** Emitted when the button loses focus. */
  "onev-blur"?: (e: CustomEvent<never>) => void;
  /** Emitted when the button gains focus. */
  "onev-focus"?: (e: CustomEvent<never>) => void;
};

type LynkRadioGroupProps = {
  /** The radio group's label. Required for proper accessibility. If you need to display HTML, use the `label` slot
instead. */
  label?: LynkRadioGroup["label"];
  /** The input's help text. If you need to display HTML, you can use the `help-text` slot instead. */
  "help-text"?: LynkRadioGroup["helpText"];
  /** The help tooltip appended to the label. Alternatively, you can use the help-tip slot. */
  "help-tip"?: LynkRadioGroup["helpTip"];
  /** The name of the radio group, submitted as a name/value pair with form data. */
  name?: LynkRadioGroup["name"];
  /** The current value of the radio group, submitted as a name/value pair with form data. */
  value?: LynkRadioGroup["value"];
  /** The radio group's size. This size will be applied to all child radios and radio buttons. */
  size?: LynkRadioGroup["size"];
  /** By default, form controls are associated with the nearest containing `<form>` element. This attribute allows you
to place the form control outside of a form and associate it with the form that has this `id`. The form must be in
the same document or shadow root for this to work. */
  form?: LynkRadioGroup["form"];
  /** Ensures a child radio is checked before allowing the containing form to submit. */
  required?: LynkRadioGroup["required"];
  /** The input's feedback status using manual validation. Alternatively, you can use the invalid attribute */
  state?: LynkRadioGroup["state"];
  /**  */
  defaultSlot?: LynkRadioGroup["defaultSlot"];
  /**  */
  validationInput?: LynkRadioGroup["validationInput"];
  /**  */
  defaultValue?: LynkRadioGroup["defaultValue"];
  /** Gets the validity state object */
  validity?: LynkRadioGroup["validity"];
  /** Gets the validation message */
  validationMessage?: LynkRadioGroup["validationMessage"];
  /** Emitted when the radio group's selected value changes. */
  "onev-change"?: (e: CustomEvent<never>) => void;
  /** Emitted when the radio group receives user input. */
  "onev-input"?: (e: CustomEvent<never>) => void;
  /** Emitted when the form control has been checked for validity and its constraints aren't satisfied. */
  "onev-invalid"?: (e: CustomEvent<never>) => void;
};

type LynkRangeProps = {
  /**  */
  title?: LynkRange["title"];
  /** The name of the range, submitted as a name/value pair with form data. */
  name?: LynkRange["name"];
  /** The current value of the range, submitted as a name/value pair with form data. */
  value?: LynkRange["value"];
  /** The range's label. If you need to display HTML, use the `label` slot instead. */
  label?: LynkRange["label"];
  /** The range's help text. If you need to display HTML, use the help-text slot instead. */
  "help-text"?: LynkRange["helpText"];
  /** Disables the range. */
  disabled?: LynkRange["disabled"];
  /** The minimum acceptable value of the range. */
  min?: LynkRange["min"];
  /** The maximum acceptable value of the range. */
  max?: LynkRange["max"];
  /** The interval at which the range will increase and decrease. */
  step?: LynkRange["step"];
  /** Custom tick ticks */
  ticks?: LynkRange["ticks"];
  /** The preferred placement of the range's tooltip. */
  tooltip?: LynkRange["tooltip"];
  /** By default, form controls are associated with the nearest containing `<form>` element. This attribute allows you
to place the form control outside of a form and associate it with the form that has this `id`. The form must be in
the same document or shadow root for this to work. */
  form?: LynkRange["form"];
  /**  */
  input?: LynkRange["input"];
  /**  */
  output?: LynkRange["output"];
  /** A function used to format the tooltip's value. The range's value is passed as the first and only argument. The
function should return a string to display in the tooltip. */
  tooltipFormatter?: LynkRange["tooltipFormatter"];
  /** The default value of the form control. Primarily used for resetting the form control. */
  defaultValue?: LynkRange["defaultValue"];
  /** Gets the validity state object */
  validity?: LynkRange["validity"];
  /** Gets the validation message */
  validationMessage?: LynkRange["validationMessage"];
  /** Emitted when the control loses focus. */
  "onev-blur"?: (e: CustomEvent<never>) => void;
  /** Emitted when an alteration to the control's value is committed by the user. */
  "onev-change"?: (e: CustomEvent<never>) => void;
  /** Emitted when the control gains focus. */
  "onev-focus"?: (e: CustomEvent<never>) => void;
  /** Emitted when the control receives input. */
  "onev-input"?: (e: CustomEvent<never>) => void;
  /** Emitted when the form control has been checked for validity and its constraints aren't satisfied. */
  "onev-invalid"?: (e: CustomEvent<never>) => void;
};

type LynkRelativeTimeProps = {
  /** The date from which to calculate time from. If not set, the current date and time will be used. When passing a
string, it's strongly recommended to use the ISO 8601 format to ensure timezones are handled correctly. To convert
a date to this format in JavaScript, use [`date.toISOString()`](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date/toISOString). */
  date?: LynkRelativeTime["date"];
  /** The formatting style to use. */
  format?: LynkRelativeTime["format"];
  /** When `auto`, values such as "yesterday" and "tomorrow" will be shown when possible. When `always`, values such as
"1 day ago" and "in 1 day" will be shown. */
  numeric?: LynkRelativeTime["numeric"];
  /** Keep the displayed value up to date as time passes. */
  sync?: LynkRelativeTime["sync"];
};

type LynkResizeObserverProps = {
  /** Disables the observer. */
  disabled?: LynkResizeObserver["disabled"];

  /** Emitted when the element is resized. */
  "onev-resize"?: (e: CustomEvent<{ entries: ResizeObserverEntry[] }>) => void;
};

type LynkResponsiveMediaProps = {
  /** The aspect ratio of the embedded media in the format of `width:height`, e.g. `16:9`, `4:3`, or `1:1`. Ratios not in
this format will be ignored. */
  "aspect-ratio"?: LynkResponsiveMedia["aspectRatio"];
  /** Determines how content will be resized to fit its container. */
  fit?: LynkResponsiveMedia["fit"];
};

type LynkSelectProps = {
  /** The name of the select, submitted as a name/value pair with form data. */
  name?: LynkSelect["name"];
  /** The default value of the form control. Primarily used for resetting the form control. */
  value?: LynkSelect["defaultValue"];
  /** The select's size. */
  size?: LynkSelect["size"];
  /** Placeholder text to show as a hint when the select is empty. */
  placeholder?: LynkSelect["placeholder"];
  /** Allows more than one option to be selected. */
  multiple?: LynkSelect["multiple"];
  /** The maximum number of selected options to show when `multiple` is true. After the maximum, "+n" will be shown to
indicate the number of additional items that are selected. Set to 0 to remove the limit. */
  "max-options-visible"?: LynkSelect["maxOptionsVisible"];
  /** Disables the select control. */
  disabled?: LynkSelect["disabled"];
  /** Adds a clear button when the select is not empty. */
  clearable?: LynkSelect["clearable"];
  /** Indicates whether or not the select is open. You can toggle this attribute to show and hide the menu, or you can
use the `show()` and `hide()` methods and this attribute will reflect the select's open state. */
  open?: LynkSelect["open"];
  /** Enable this option to prevent the listbox from being clipped when the component is placed inside a container with
`overflow: auto|scroll`. Hoisting uses a fixed positioning strategy that works in many, but not all, scenarios. */
  hoist?: LynkSelect["hoist"];
  /** Draws a filled select. */
  filled?: LynkSelect["filled"];
  /** Draws a pill-style select with rounded edges. */
  pill?: LynkSelect["pill"];
  /** The select's label. If you need to display HTML, use the `label` slot instead. */
  label?: LynkSelect["label"];
  /** The preferred placement of the select's menu. Note that the actual placement may vary as needed to keep the listbox
inside of the viewport. */
  placement?: LynkSelect["placement"];
  /** The select's help text. If you need to display HTML, use the `help-text` slot instead. */
  "help-text"?: LynkSelect["helpText"];
  /** The select's help tooltip appended to the label. Alternatively, you can use the help-tip slot. */
  "help-tip"?: LynkSelect["helpTip"];
  /** By default, form controls are associated with the nearest containing `<form>` element. This attribute allows you
to place the form control outside of a form and associate it with the form that has this `id`. The form must be in
the same document or shadow root for this to work. */
  form?: LynkSelect["form"];
  /** The select's required attribute. */
  required?: LynkSelect["required"];
  /** Replaces the select with a plain text string of the selected value. */
  restricted?: LynkSelect["restricted"];
  /** The select's feedback status using manual validation. Alternatively, you can use the invalid attribute */
  state?: LynkSelect["state"];
  /** A function that customizes the tags to be rendered when multiple=true. The first argument is the option, the second
is the current tag's index.  The function should return either a Lit TemplateResult or a string containing trusted HTML of the symbol to render at
the specified value. */
  getTag?: LynkSelect["getTag"];
  /**  */
  popup?: LynkSelect["popup"];
  /**  */
  combobox?: LynkSelect["combobox"];
  /**  */
  displayInput?: LynkSelect["displayInput"];
  /**  */
  valueInput?: LynkSelect["valueInput"];
  /**  */
  listbox?: LynkSelect["listbox"];
  /**  */
  displayLabel?: LynkSelect["displayLabel"];
  /**  */
  currentOption?: LynkSelect["currentOption"];
  /**  */
  selectedOptions?: LynkSelect["selectedOptions"];
  /** The current value of the select, submitted as a name/value pair with form data. When `multiple` is enabled, the
value attribute will be a space-delimited list of values based on the options selected, and the value property will
be an array. **For this reason, values must not contain spaces.** */
  value?: LynkSelect["value"];
  /** Gets the validity state object */
  validity?: LynkSelect["validity"];
  /** Gets the validation message */
  validationMessage?: LynkSelect["validationMessage"];
  /** Emitted when the control's value changes. */
  "onev-change"?: (e: CustomEvent<never>) => void;
  /** Emitted when the control's value is cleared. */
  "onev-clear"?: (e: CustomEvent<never>) => void;
  /** Emitted when the control receives input. */
  "onev-input"?: (e: CustomEvent<never>) => void;
  /** Emitted when the control gains focus. */
  "onev-focus"?: (e: CustomEvent<never>) => void;
  /** Emitted when the control loses focus. */
  "onev-blur"?: (e: CustomEvent<never>) => void;
  /** Emitted when the select's menu opens. */
  "onev-show"?: (e: CustomEvent<never>) => void;
  /** Emitted after the select's menu opens and all animations are complete. */
  "onev-after-show"?: (e: CustomEvent<never>) => void;
  /** Emitted when the select's menu closes. */
  "onev-hide"?: (e: CustomEvent<never>) => void;
  /** Emitted after the select's menu closes and all animations are complete. */
  "onev-after-hide"?: (e: CustomEvent<never>) => void;
  /** Emitted when the form control has been checked for validity and its constraints aren't satisfied. */
  "onev-invalid"?: (e: CustomEvent<never>) => void;
};

type LynkSpinnerProps = {};

type LynkSplitPanelProps = {
  /** The current position of the divider from the primary panel's edge as a percentage 0-100. Defaults to 50% of the
container's initial size. */
  position?: LynkSplitPanel["position"];
  /** The current position of the divider from the primary panel's edge in pixels. */
  "position-in-pixels"?: LynkSplitPanel["positionInPixels"];
  /** Draws the split panel in a vertical orientation with the start and end panels stacked. */
  vertical?: LynkSplitPanel["vertical"];
  /** Disables resizing. Note that the position may still change as a result of resizing the host element. */
  disabled?: LynkSplitPanel["disabled"];
  /** If no primary panel is designated, both panels will resize proportionally when the host element is resized. If a
primary panel is designated, it will maintain its size and the other panel will grow or shrink as needed when the
host element is resized. */
  primary?: LynkSplitPanel["primary"];
  /** Either one or more space-separated values at which the divider should snap, in pixels, percentages, or repeat expressions e.g. `'100px 50% 500px' or `repeat(50%) 10px`,
or a function which takes in a `SnapFunctionParams`, and returns a position to snap to, e.g. `({ pos }) => Math.round(pos / 8) * 8`. */
  snap?: LynkSplitPanel["snap"];
  /** How close the divider must be to a snap point until snapping occurs. */
  "snap-threshold"?: LynkSplitPanel["snapThreshold"];
  /**  */
  divider?: LynkSplitPanel["divider"];
  /** Emitted when the divider's position changes. */
  "onev-reposition"?: (e: CustomEvent<never>) => void;
};

type LynkStackProps = {
  /** Stack items horizontally */
  horizontal?: LynkStack["horizontal"];
  /** Reverse the order of stack items */
  reverse?: LynkStack["reverse"];
  /** How to justify stack items */
  justify?: LynkStack["justify"];
  /** How to align stack items to each-other */
  align?: LynkStack["align"];
  /** How to wrap the stack */
  wrap?: LynkStack["wrap"];
  /** The space between stack items. Use spacing tokens or any custom size. */
  gap?: LynkStack["gap"];
};

type LynkSwitchProps = {
  /**  */
  title?: LynkSwitch["title"];
  /** The switch's name attribute. */
  name?: LynkSwitch["name"];
  /** The switch's value attribute. */
  value?: LynkSwitch["value"];
  /** The switch's size. */
  size?: LynkSwitch["size"];
  /** The switch's color */
  color?: LynkSwitch["color"];
  /** Disables the switch. */
  disabled?: LynkSwitch["disabled"];
  /** Draws the switch in a checked state. */
  checked?: LynkSwitch["checked"];
  /** By default, form controls are associated with the nearest containing `<form>` element. This attribute allows you
to place the form control outside of a form and associate it with the form that has this `id`. The form must be in
the same document or shadow root for this to work. */
  form?: LynkSwitch["form"];
  /** Makes the switch a required field. */
  required?: LynkSwitch["required"];
  /**  */
  input?: LynkSwitch["input"];
  /** The default value of the form control. Primarily used for resetting the form control. */
  defaultChecked?: LynkSwitch["defaultChecked"];
  /** Gets the validity state object */
  validity?: LynkSwitch["validity"];
  /** Gets the validation message */
  validationMessage?: LynkSwitch["validationMessage"];
  /** Emitted when the control loses focus. */
  "onev-blur"?: (e: CustomEvent<never>) => void;
  /** Emitted when the control's checked state changes. */
  "onev-change"?: (e: CustomEvent<never>) => void;
  /** Emitted when the control receives input. */
  "onev-input"?: (e: CustomEvent<never>) => void;
  /** Emitted when the control gains focus. */
  "onev-focus"?: (e: CustomEvent<never>) => void;
  /** Emitted when the form control has been checked for validity and its constraints aren't satisfied. */
  "onev-invalid"?: (e: CustomEvent<never>) => void;
};

type LynkTabProps = {
  /** The name of the tab panel this tab is associated with. The panel must be located in the same tab group. */
  panel?: LynkTab["panel"];
  /** Draws the tab in an active state. */
  active?: LynkTab["active"];
  /** Makes the tab closable and shows a close button. */
  closable?: LynkTab["closable"];
  /** Disables the tab and prevents selection. */
  disabled?: LynkTab["disabled"];
  /** When set, the underlying button will be rendered as an `<a>` with this `href` instead of a `<button>`. */
  href?: LynkTab["href"];
  /** When using `href`, this attribute will map to the underlying link's `rel` attribute. Unlike regular links, the
default is `noreferrer noopener` to prevent security exploits. However, if you're using `target` to point to a
specific tab/window, this will prevent that from working correctly. You can remove or change the default value by
setting the attribute to an empty string or a value of your choice, respectively. */
  rel?: LynkTab["rel"];
  /**  */
  tab?: LynkTab["tab"];
  /** Emitted when the tab is closable and the close button is activated. */
  "onev-close"?: (e: CustomEvent<never>) => void;
};

type LynkTabGroupProps = {
  /** The placement of the tabs. */
  placement?: LynkTabGroup["placement"];
  /** When set to auto, navigating tabs with the arrow keys will instantly show the corresponding tab panel. When set to
manual, the tab will receive focus but will not show until the user presses spacebar or enter. */
  activation?: LynkTabGroup["activation"];
  /** Disables the scroll arrows that appear when tabs overflow. */
  "no-scroll-controls"?: LynkTabGroup["noScrollControls"];
  /** Prevent scroll buttons from being hidden when inactive. */
  "fixed-scroll-controls"?: LynkTabGroup["fixedScrollControls"];
  /**  */
  tabGroup?: LynkTabGroup["tabGroup"];
  /**  */
  body?: LynkTabGroup["body"];
  /**  */
  nav?: LynkTabGroup["nav"];
  /**  */
  indicator?: LynkTabGroup["indicator"];
  /** Emitted when a tab is shown. */
  "onev-tab-show"?: (e: CustomEvent<{ name: String }>) => void;
  /** Emitted when a tab is hidden. */
  "onev-tab-hide"?: (e: CustomEvent<{ name: String }>) => void;
};

type LynkTabPanelProps = {
  /** The tab panel's name. */
  name?: LynkTabPanel["name"];
  /** When true, the tab panel will be shown. */
  active?: LynkTabPanel["active"];
};

type LynkTableProps = {
  /** Objects used for mapping column data, ths, and sorting.
Required for data-driven tables.
Optional for custom tables, except if you want to use the built-in sorting.
Each object is expected to have a "key" corresponding a property in each row object. */
  cols?: LynkTable["cols"];
  /** Objects used for mapping row data.
Required for data-driven tables.
Optional for custom tables, except if you want to use the built-in sorting.
Each object is expected to have a string property corresponding to a "key" in one of the cols. */
  rows?: LynkTable["rows"];
  /** Enables slotted children, and disables automatic table element construction */
  custom?: LynkTable["custom"];
  /**  */
  assignedHead?: LynkTable["assignedHead"];
  /**  */
  assignedBody?: LynkTable["assignedBody"];
};

type LynkTagProps = {
  /** The tag's variant. */
  type?: LynkTag["type"];
  /** The tag's size. */
  size?: LynkTag["size"];
  /** Draws a pill-style tag with rounded edges. */
  pill?: LynkTag["pill"];
  /** Makes the tag removable. */
  removable?: LynkTag["removable"];
  /** Makes the tag pulsate to draw attention. */
  pulse?: LynkTag["pulse"];
  /** Draws a solid filled badge-styled tag . */
  badge?: LynkTag["badge"];

  /** Emitted when the remove button is activated. */
  "onev-remove"?: (e: CustomEvent<never>) => void;
};

type LynkTbodyProps = {};

type LynkTdProps = {
  /** A visual state for this row of data to indicate */
  state?: LynkTd["state"];
  /** Animates the state background in a barberpole style loop */
  barberpole?: LynkTd["barberpole"];
};

type LynkTextareaProps = {
  /**  */
  title?: LynkTextarea["title"];
  /** The textarea's name attribute. */
  name?: LynkTextarea["name"];
  /** The textarea's value attribute. */
  value?: LynkTextarea["value"];
  /** The textareas feedback status using manual validation. Alternatively, you can use the invalid attribute */
  state?: LynkTextarea["state"];
  /** The textarea's size. */
  size?: LynkTextarea["size"];
  /** Draws a filled textarea. */
  filled?: LynkTextarea["filled"];
  /** The textarea's label. Alternatively, you can use the label slot. */
  label?: LynkTextarea["label"];
  /** The textarea's help text. Alternatively, you can use the help-text slot. */
  "help-text"?: LynkTextarea["helpText"];
  /** The help tip accompanying the label. Alternatively, you can use the help-tip slot. */
  "help-tip"?: LynkTextarea["helpTip"];
  /** Placeholder text to show as a hint when the input is empty. */
  placeholder?: LynkTextarea["placeholder"];
  /** The number of rows to display by default. */
  rows?: LynkTextarea["rows"];
  /** Controls how the textarea can be resized. */
  resize?: LynkTextarea["resize"];
  /** Disables the textarea. */
  disabled?: LynkTextarea["disabled"];
  /** Makes the textarea readonly. */
  readonly?: LynkTextarea["readonly"];
  /** Replaces the textarea with a plain text string. */
  restricted?: LynkTextarea["restricted"];
  /** By default, form controls are associated with the nearest containing `<form>` element. This attribute allows you
to place the form control outside of a form and associate it with the form that has this `id`. The form must be in
the same document or shadow root for this to work. */
  form?: LynkTextarea["form"];
  /** Makes the textarea a required field. */
  required?: LynkTextarea["required"];
  /** The minimum length of input that will be considered valid. */
  minlength?: LynkTextarea["minlength"];
  /** The maximum length of input that will be considered valid. */
  maxlength?: LynkTextarea["maxlength"];
  /** The textarea's autocapitalize attribute. */
  autocapitalize?: LynkTextarea["autocapitalize"];
  /** The textarea's autocorrect attribute. */
  autocorrect?: LynkTextarea["autocorrect"];
  /** Specifies what permission the browser has to provide assistance in filling out form field values. Refer to
[this page on MDN](https://developer.mozilla.org/en-US/docs/Web/HTML/Attributes/autocomplete) for available values. */
  autocomplete?: LynkTextarea["autocomplete"];
  /** Indicates that the input should receive focus on page load. */
  autofocus?: LynkTextarea["autofocus"];
  /** Used to customize the label or icon of the Enter key on virtual keyboards. */
  enterkeyhint?: LynkTextarea["enterkeyhint"];
  /** Enables spell checking on the textarea. */
  spellcheck?: LynkTextarea["spellcheck"];
  /** Tells the browser what type of data will be entered by the user, allowing it to display the appropriate virtual
keyboard on supportive devices. */
  inputmode?: LynkTextarea["inputmode"];
  /**  */
  input?: LynkTextarea["input"];
  /**  */
  sizeAdjuster?: LynkTextarea["sizeAdjuster"];
  /** Gets or sets the default value used to reset this element. The initial value corresponds to the one originally specified in the HTML that created this element. */
  defaultValue?: LynkTextarea["defaultValue"];
  /** Gets the validity state object */
  validity?: LynkTextarea["validity"];
  /** Gets the validation message */
  validationMessage?: LynkTextarea["validationMessage"];
  /** Emitted when an alteration to the control's value is committed by the user. */
  "onev-change"?: (e: CustomEvent<never>) => void;
  /** Emitted when the control receives input. */
  "onev-input"?: (e: CustomEvent<never>) => void;
  /** Emitted when the control gains focus. */
  "onev-focus"?: (e: CustomEvent<never>) => void;
  /** Emitted when the control loses focus. */
  "onev-blur"?: (e: CustomEvent<never>) => void;
  /** Emitted when the form control has been checked for validity and its constraints aren't satisfied. */
  "onev-invalid"?: (e: CustomEvent<never>) => void;
};

type LynkThProps = {
  /** The column key associated with this table header */
  key?: LynkTh["key"];
  /** The sorting direction currently applied to the rows with the corresponding column key */
  "sort-direction"?: LynkTh["sortDirection"];
  /** Toggles sort events and the display of sorting related icons with the corresponding column key */
  sortable?: LynkTh["sortable"];

  /** Emitted when a sortable table header is clicked on. */
  "onev-table-sort"?: (e: CustomEvent<never>) => void;
};

type LynkTheadProps = {
  /** Makes the header stick to the top of the table while its overflow is scrolling vertically */
  sticky?: LynkThead["sticky"];
};

type LynkTooltipProps = {
  /** The tooltip's content. If you need to display HTML, you can use the `content` slot instead. */
  content?: LynkTooltip["content"];
  /** The preferred placement of the tooltip. Note that the actual placement may vary as needed to keep the tooltip
inside of the viewport. */
  placement?: LynkTooltip["placement"];
  /** Disables the tooltip so it won't show when triggered. */
  disabled?: LynkTooltip["disabled"];
  /** The distance in pixels from which to offset the tooltip away from its target. */
  distance?: LynkTooltip["distance"];
  /** Indicates whether or not the tooltip is open. You can use this in lieu of the show/hide methods. */
  open?: LynkTooltip["open"];
  /** The distance in pixels from which to offset the tooltip along its target. */
  skidding?: LynkTooltip["skidding"];
  /** Hides the arrow. */
  "no-arrow"?: LynkTooltip["noArrow"];
  /** Controls how the tooltip is activated. Possible options include `click`, `hover`, `focus`, and `manual`. Multiple
options can be passed by separating them with a space. When manual is used, the tooltip must be activated
programmatically. */
  trigger?: LynkTooltip["trigger"];
  /** Enable this option to prevent the tooltip from being clipped when the component is placed inside a container with
`overflow: auto|hidden|scroll`. */
  hoist?: LynkTooltip["hoist"];
  /**  */
  defaultSlot?: LynkTooltip["defaultSlot"];
  /**  */
  body?: LynkTooltip["body"];
  /**  */
  popup?: LynkTooltip["popup"];
  /** Emitted when the tooltip begins to show. */
  "onev-show"?: (e: CustomEvent<never>) => void;
  /** Emitted after the tooltip has shown and all animations are complete. */
  "onev-after-show"?: (e: CustomEvent<never>) => void;
  /** Emitted when the tooltip begins to hide. */
  "onev-hide"?: (e: CustomEvent<never>) => void;
  /** Emitted after the tooltip has hidden and all animations are complete. */
  "onev-after-hide"?: (e: CustomEvent<never>) => void;
};

type LynkTrProps = {
  /** Draws the table row using status colors */
  state?: LynkTr["state"];
  /** Determines whether to highlight the table row on hover or touch interactions */
  interactive?: LynkTr["interactive"];
  /** Draws the table row in a highlighted state */
  active?: LynkTr["active"];
  /** Pulse the status colors for increased visibility */
  pulse?: LynkTr["pulse"];
};

type LynkTruncateProps = {
  /**  */
  title?: LynkTruncate["title"];
  /** Optionally clamp string at specified number of lines. */
  clamp?: LynkTruncate["clamp"];
  /**  */
  defaultSlot?: LynkTruncate["defaultSlot"];
  /**  */
  endSlot?: LynkTruncate["endSlot"];
};

type LynkVisuallyHiddenProps = {};

type LynkWispProps = {
  /** Determines which effect the wisp will use. */
  effect?: LynkWisp["effect"];
};

export type CustomElements = {
  /**
   * A vertically stacked set of interactive [Panels](/components/panel) that can expand to reveal an associated section of content.
   * ---
   *
   *
   * ### **Methods:**
   *  - **expandAll()** - Expands all panels.
   * - **collapseAll()** - Collapses all panels
   */
  "lynk-accordion": DefineComponent<LynkAccordionProps>;

  /**
   * Alerts are used to display important messages inline or as toast notifications.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-show** - Emitted when the alert opens.
   * - **ev-after-show** - Emitted after the alert opens and all animations are complete.
   * - **ev-hide** - Emitted when the alert closes.
   * - **ev-after-hide** - Emitted after the alert closes and all animations are complete.
   *
   * ### **Methods:**
   *  - **show()** - Shows the alert.
   * - **hide()** - Hides the alert
   * - **toast()** - Displays the alert as a toast notification. This will move the alert out of its position in the DOM and, when
   * dismissed, it will be removed from the DOM completely. By storing a reference to the alert, you can reuse it by
   * calling this method again. The returned promise will resolve after the alert is hidden.
   *
   * ### **Slots:**
   *  - _default_ - The alert's content.
   * - **icon** - An icon to show in the alert.
   * - **action** - Append custom actions to alert.
   *
   * ### **CSS Properties:**
   *  - **--box-shadow** - The alert's box shadow. _(default: undefined)_
   * - **--padding** - The top and bottom padding of the message. Use any spacing token (--lynk-spacing-large) or a custom value. _(default: undefined)_
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal block wrapper.
   * - **icon** - The container that wraps the alert icon.
   * - **message** - The alert message.
   * - **close-button** - The close button.
   * - **close-button__base** - The close button's `base` part.
   */
  "lynk-alert": DefineComponent<LynkAlertProps>;

  /**
   * Animate elements declaratively with nearly 100 baked-in presets, or roll your own with custom keyframes. Powered by the [Web Animations API](https://developer.mozilla.org/en-US/docs/Web/API/Web_Animations_API).
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-cancel** - Emitted when the animation is canceled.
   * - **ev-finish** - Emitted when the animation finishes.
   * - **ev-start** - Emitted when the animation starts or restarts.
   *
   * ### **Methods:**
   *  - **cancel()** - Clears all KeyframeEffects caused by this animation and aborts its playback.
   * - **finish()** - Sets the playback time to the end of the animation corresponding to the current playback direction.
   *
   * ### **Slots:**
   *  - _default_ - The element to animate. Avoid slotting in more than one element, as subsequent ones will be ignored. To animate multiple elements, either wrap them in a single container or use multiple `<lynk-animation>` elements.
   */
  "lynk-animation": DefineComponent<LynkAnimationProps>;

  /**
   * A simple automatic two-dimensional grid-based layout system based off CSS Grid spec.
   * ---
   *
   *
   * ### **Slots:**
   *  - _default_ - The default slot.
   *
   * ### **CSS Properties:**
   *  - **--gap** - Customize the gap of the auto-grid group. _(default: var(--lynk-spacing-base))_
   * - **--min-size** - Customize the allowed min-size of the auto-grid items. _(default: 20rem)_
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   */
  "lynk-auto-grid": DefineComponent<LynkAutoGridProps>;

  /**
   * Badges are used to draw attention and display statuses or counts.
   * ---
   *
   *
   * ### **Slots:**
   *  - _default_ - The badge's content.
   *
   * ### **CSS Properties:**
   *  - **--background-color** - The badges background and pulse color. _(default: undefined)_
   * - **--color** - The badges text color. _(default: undefined)_
   * - **--pulse-speed** - The badges pulse speed in seconds or ms. Default is 1.5s. _(default: undefined)_
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   */
  "lynk-badge": DefineComponent<LynkBadgeProps>;

  /**
   *
   * ---
   *
   *
   * ### **Slots:**
   *  - _default_ - The default slot.
   *
   * ### **CSS Properties:**
   *  - **--align** - Custom text align (left, center, right). _(default: left)_
   * - **--background** - Any color token (--lynk-color-neutral-100) or a custom value. _(default: transparent)_
   * - **--border** - <border-style> <border-width> <border-color>. _(default: undefined)_
   * - **--border-radius** - Any Border Radius token (--lynk-border-radius-medium) or a custom value. _(default: undefined)_
   * - **--color** - Any color token (--lynk-color-neutral-100) or a custom value. _(default: inherit)_
   * - **--height** - Any custom px, rem, %, or vh value. _(default: auto)_
   * - **--width** - Any custom px, rem, %, or vh value. _(default: auto)_
   * - **--margin** - Any spacing token (--lynk-spacing-large) or a custom value. _(default: 0)_
   * - **--padding** - Any spacing token (--lynk-spacing-large) or a custom value. _(default: 0)_
   * - **--shadow** - Any elevation shadow token (--lynk-shadow-large); _(default: undefined)_
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   */
  "lynk-box": DefineComponent<LynkBoxProps>;

  /**
   * Breadcrumbs provide a group of links so users can easily navigate a website's hierarchy.
   * ---
   *
   *
   * ### **Slots:**
   *  - _default_ - One or more breadcrumb items to display.
   * - **separator** - The separator to use between breadcrumb items. Works best with `<lynk-icon>`.
   *
   * ### **CSS Parts:**
   *  - **base** - The component's base wrapper.
   */
  "lynk-breadcrumb": DefineComponent<LynkBreadcrumbProps>;

  /**
   * Breadcrumb Items are used inside [breadcrumbs](/components/breadcrumb) to represent different links.
   * ---
   *
   *
   * ### **Slots:**
   *  - _default_ - The breadcrumb item's label.
   * - **prefix** - An optional prefix, usually an icon or icon button.
   * - **suffix** - An optional suffix, usually an icon or icon button.
   * - **separator** - The separator to use for the breadcrumb item. This will only change the separator for this item. If you want to change it for all items in the group, set the separator on `<lynk-breadcrumb>` instead.
   *
   * ### **CSS Parts:**
   *  - **base** - The component's base wrapper.
   * - **label** - The breadcrumb item's label.
   * - **prefix** - The container that wraps the prefix.
   * - **suffix** - The container that wraps the suffix.
   * - **separator** - The container that wraps the separator.
   */
  "lynk-breadcrumb-item": DefineComponent<LynkBreadcrumbItemProps>;

  /**
   * Buttons represent actions that are available to the user.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-blur** - Emitted when the button loses focus.
   * - **ev-click** - Emitted when the button is clicked.
   * - **ev-focus** - Emitted when the button gains focus.
   * - **ev-invalid** - Emitted when the form control has been checked for validity and its constraints aren't satisfied..
   *
   * ### **Methods:**
   *  - **click()** - Simulates a click on the button.
   * - **focus(options: _FocusOptions_)** - Sets focus on the button.
   * - **blur()** - Removes focus from the button.
   * - **checkValidity()** - Checks for validity but does not show the browser's validation message.
   * - **getForm(): _HTMLFormElement | null_** - Gets the associated form, if one exists.
   * - **reportValidity()** - Checks for validity and shows the browser's validation message if the control is invalid.
   * - **setCustomValidity(message: _string_)** - Sets a custom validation message. Pass an empty string to restore validity.
   *
   * ### **Slots:**
   *  - _default_ - The button's label.
   * - **prefix** - Used to prepend an icon or similar element to the button.
   * - **suffix** - Used to append an icon or similar element to the button.
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   * - **prefix** - The prefix slot's container.
   * - **label** - The button's label.
   * - **suffix** - The suffix slot's container.
   * - **caret** - The button's caret.
   */
  "lynk-button": DefineComponent<LynkButtonProps>;

  /**
   * Button groups can be used to group related buttons into sections.
   * ---
   *
   *
   * ### **Slots:**
   *  - _default_ - One or more `<lynk-button>` elements to display in the button group.
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   */
  "lynk-button-group": DefineComponent<LynkButtonGroupProps>;

  /**
   * Cards can be used to group media with related subjects into a container.
   * ---
   *
   *
   * ### **Slots:**
   *  - _default_ - The card's main content.
   * - **header** - An optional header for the card.
   * - **footer** - An optional footer for the card.
   * - **image** - An optional image to render at the start of the card.
   *
   * ### **CSS Properties:**
   *  - **--border-color** - The card's border color, including borders that occur inside the card. _(default: undefined)_
   * - **--border-radius** - The border radius for the card's edges. _(default: undefined)_
   * - **--border-width** - The width of the card's borders. _(default: undefined)_
   * - **--state-color** - A custom color for the interactive state. _(default: undefined)_
   * - **--pulse-speed** - A custom speed for the pulse animation. _(default: undefined)_
   * - **--padding** - The padding to use for the card's sections. _(default: undefined)_
   *
   * ### **CSS Parts:**
   *  - **base** - The component's base wrapper.
   * - **image** - The container that wraps the card's image.
   * - **header** - The container that wraps the card's header.
   * - **body** - The container that wraps the card's main content.
   * - **footer** - The container that wraps the card's footer.
   */
  "lynk-card": DefineComponent<LynkCardProps>;

  /**
   * Checkboxes allow the user to toggle an option on or off.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-blur** - Emitted when the control loses focus.
   * - **ev-change** - Emitted when the control's checked state changes.
   * - **ev-focus** - Emitted when the control gains focus.
   * - **ev-input** - Emitted when the checkbox receives input.
   * - **ev-invalid** - Emitted when the form control has been checked for validity and its constraints aren't satisfied.
   *
   * ### **Methods:**
   *  - **click()** - Simulates a click on the checkbox.
   * - **focus(options: _FocusOptions_)** - Sets focus on the checkbox.
   * - **blur()** - Removes focus from the checkbox.
   * - **checkValidity()** - Checks for validity but does not show a validation message. Returns true when valid and false when invalid.
   * - **getForm(): _HTMLFormElement | null_** - Gets the associated form, if one exists.
   * - **reportValidity()** - Checks for validity and shows a validation message if the control is invalid.
   * - **setCustomValidity(message: _string_)** - Sets a custom validation message. The value provided will be shown to the user when the form is submitted. To clear
   * the custom validation message, call this method with an empty string.
   *
   * ### **Slots:**
   *  - _default_ - The checkbox's label.
   * - **help-text** - Text that describes how to use the checkbox. Alternatively, you can use the `help-text` attribute.
   *
   * ### **CSS Parts:**
   *  - **base** - The component's base wrapper.
   * - **control** - The square container that wraps the checkbox's checked state.
   * - **control--checked** - Matches the control part when the checkbox is checked.
   * - **control--indeterminate** - Matches the control part when the checkbox is indeterminate.
   * - **checked-icon** - The checked icon, an `<lynk-icon>` element.
   * - **indeterminate-icon** - The indeterminate icon, an `<lynk-icon>` element.
   * - **label** - The container that wraps the checkbox's label.
   * - **form-control-help-text** - The help text's wrapper.
   */
  "lynk-checkbox": DefineComponent<LynkCheckboxProps>;

  /**
   * Table `<lynk-col>` components will behave like a native `<col>` HTML element within a `<lynk-table>`.
   * ---
   *
   */
  "lynk-col": DefineComponent<LynkColProps>;

  /**
   * Table `<lynk-colgroup>` components will behave like a native `<colgroup>` HTML element within a `<lynk-table>`.
   * ---
   *
   *
   * ### **Slots:**
   *  - _default_ - Should contain 1 or more `<lynk-col>` components.
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   */
  "lynk-colgroup": DefineComponent<LynkColGroupProps>;

  /**
   * Comboboxes allow you to choose items from a menu of predefined options.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-change** - Emitted when the control's value changes.
   * - **ev-clear** - Emitted when the control's value is cleared.
   * - **ev-input** - Emitted when the control receives input.
   * - **ev-focus** - Emitted when the control gains focus.
   * - **ev-blur** - Emitted when the control loses focus.
   * - **ev-show** - Emitted when the combobox's menu opens.
   * - **ev-after-show** - Emitted after the combobox's menu opens and all animations are complete.
   * - **ev-hide** - Emitted when the combobox's menu closes.
   * - **ev-after-hide** - Emitted after the combobox's menu closes and all animations are complete.
   * - **ev-invalid** - Emitted when the form control has been checked for validity and its constraints aren't satisfied.
   * - **ev-error** - Emitted when the combobox menu fails to open.
   *
   * ### **Methods:**
   *  - **show()** - Shows the listbox. If it is not possible to open the listbox, because there are no
   * appropriate filtered options, a ev-error is emitted and the listbox stays closed.
   * - **hide()** - Hides the listbox.
   * - **checkValidity()** - Checks for validity but does not show a validation message.
   * Returns `true` when valid and `false` when invalid.
   * - **getForm(): _HTMLFormElement | null_** - Gets the associated form, if one exists.
   * - **reportValidity()** - Checks for validity and shows the browser's validation message if the control is invalid.
   * - **setCustomValidity(message: _string_)** - Sets a custom validation message. Pass an empty string to restore validity.
   * - **focus(options: _FocusOptions_)** - Sets focus on the control.
   * - **blur()** - Removes focus from the control.
   *
   * ### **Slots:**
   *  - _default_ - The listbox options. Must be `<lynk-option>` elements. You can use `<lynk-optgroup>`'s to group items visually.
   * - **label** - The combobox's label. Alternatively, you can use the `label` attribute.
   * - **prefix** - Used to prepend a presentational icon or similar element to the combobox.
   * - **suffix** - Used to append a presentational icon or similar element to the combobox.
   * - **clear-icon** - An icon to use in lieu of the default clear icon.
   * - **expand-icon** - The icon to show when the control is expanded and collapsed. Rotates on open and close.
   * - **help-text** - Text that describes how to use the combobox. Alternatively, you can use the `help-text` attribute.
   *
   * ### **CSS Parts:**
   *  - **form-control** - The form control that wraps the label, combobox, and help text.
   * - **form-control-label** - The label's wrapper.
   * - **form-control-input** - The combobox's wrapper.
   * - **form-control-help-text** - The help text's wrapper.
   * - **combobox** - The container the wraps the prefix, combobox, clear icon, and expand button.
   * - **prefix** - The container that wraps the prefix slot.
   * - **suffix** - The container that wraps the suffix slot.
   * - **display-input** - The element that displays the selected option's label, an `<input>` element.
   * - **listbox** - The listbox container where the options are slotted and the filtered options list exists.
   * - **filtered-listbox** - The container that wraps the filtered options.
   * - **clear-button** - The clear button.
   * - **expand-icon** - The container that wraps the expand icon.
   */
  "lynk-combobox": DefineComponent<LynkComboboxProps>;

  /**
   * Copies text data to the clipboard when the user clicks the trigger.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-copy** - Emitted when the data has been copied.
   * - **ev-error** - Emitted when the data could not be copied.
   *
   * ### **Slots:**
   *  - **copy-icon** - The icon to show in the default copy state. Works best with `<lynk-icon>`.
   * - **success-icon** - The icon to show when the content is copied. Works best with `<lynk-icon>`.
   * - **error-icon** - The icon to show when a copy error occurs. Works best with `<lynk-icon>`.
   *
   * ### **CSS Properties:**
   *  - **--success-color** - The color to use for success feedback. _(default: undefined)_
   * - **--error-color** - The color to use for error feedback. _(default: undefined)_
   *
   * ### **CSS Parts:**
   *  - **button** - The internal `<button>` element.
   * - **copy-icon** - The container that holds the copy icon.
   * - **success-icon** - The container that holds the success icon.
   * - **error-icon** - The container that holds the error icon.
   * - **tooltip__base** - The tooltip's exported `base` part.
   * - **tooltip__base__popup** - The tooltip's exported `popup` part.
   * - **tooltip__base__arrow** - The tooltip's exported `arrow` part.
   * - **tooltip__body** - The tooltip's exported `body` part.
   */
  "lynk-copy-button": DefineComponent<LynkCopyButtonProps>;

  /**
   * Dialogs, sometimes called "modals", appear above the page and require the user's immediate attention.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-show** - Emitted when the dialog opens.
   * - **ev-after-show** - Emitted after the dialog opens and all animations are complete.
   * - **ev-hide** - Emitted when the dialog closes.
   * - **ev-after-hide** - Emitted after the dialog closes and all animations are complete.
   * - **ev-initial-focus** - Emitted when the dialog opens and is ready to receive focus. Calling `event.preventDefault()` will prevent focusing and allow you to set it on a different element, such as an input.
   * - **ev-request-close** - Emitted when the user attempts to close the dialog by clicking the close button, clicking the overlay, or pressing escape. Calling `event.preventDefault()` will keep the dialog open. Avoid using this unless closing the dialog will result in destructive behavior such as data loss.
   *
   * ### **Methods:**
   *  - **show()** - Shows the dialog.
   * - **hide()** - Hides the dialog
   *
   * ### **Slots:**
   *  - _default_ - The dialog's main content.
   * - **label** - The dialog's label. Alternatively, you can use the label prop.
   * - **header-actions** - Optional actions to add to the header. Works best with `<lynk-icon-button>`.
   * - **footer** - The dialog's footer, usually one or more buttons representing various options.
   *
   * ### **CSS Properties:**
   *  - **--width** - The preferred width of the dialog. Note that the dialog will shrink to accommodate smaller screens. _(default: undefined)_
   * - **--header-spacing** - The amount of padding to use for the header. _(default: undefined)_
   * - **--body-spacing** - The amount of padding to use for the body. _(default: undefined)_
   * - **--footer-spacing** - The amount of padding to use for the footer. _(default: undefined)_
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   * - **overlay** - The overlay.
   * - **panel** - The dialog panel (where the dialog and its content is rendered).
   * - **header** - The dialog header.
   * - **header-actions** - Optional actions to add to the header. Works best with `<lynk-icon-button>`.
   * - **title** - The dialog title.
   * - **close-button** - The close button.
   * - **close-button__base** - The close button's `base` part.
   * - **body** - The dialog body.
   * - **footer** - The dialog footer.
   */
  "lynk-dialog": DefineComponent<LynkDialogProps>;

  /**
   * Dividers are used to visually separate or group elements.
   * ---
   *
   *
   * ### **CSS Properties:**
   *  - **--color** - The color of the divider. _(default: undefined)_
   * - **--width** - The width of the divider. _(default: undefined)_
   * - **--spacing** - The spacing of the divider. _(default: undefined)_
   */
  "lynk-divider": DefineComponent<LynkDividerProps>;

  /**
   * Drawers slide in from a container to expose additional options and information.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-show** - Emitted when the drawer opens.
   * - **ev-after-show** - Emitted after the drawer opens and all animations are complete.
   * - **ev-hide** - Emitted when the drawer closes.
   * - **ev-after-hide** - Emitted after the drawer closes and all animations are complete.
   * - **ev-initial-focus** - Emitted when the drawer opens and is ready to receive focus. Calling `event.preventDefault()` will prevent focusing and allow you to set it on a different element, such as an input.
   * - **ev-request-close** - Emitted when the user attempts to close the drawer by clicking the close button, clicking the overlay, or pressing escape. Calling `event.preventDefault()` will keep the drawer open. Avoid using this unless closing the drawer will result in destructive behavior such as data loss.
   *
   * ### **Methods:**
   *  - **show()** - Shows the drawer.
   * - **hide()** - Hides the drawer
   *
   * ### **Slots:**
   *  - _default_ - The drawer's content.
   * - **label** - The drawer's label. Alternatively, you can use the label prop.
   * - **footer** - The drawer's footer, usually one or more buttons representing various options.
   *
   * ### **CSS Properties:**
   *  - **--size** - The preferred size of the drawer. This will be applied to the drawer's width or height depending on its `placement`. Note that the drawer will shrink to accommodate smaller screens. _(default: undefined)_
   * - **--header-spacing** - The amount of padding to use for the header. _(default: undefined)_
   * - **--body-spacing** - The amount of padding to use for the body. _(default: undefined)_
   * - **--footer-spacing** - The amount of padding to use for the footer. _(default: undefined)_
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   * - **overlay** - The overlay.
   * - **panel** - The drawer panel (where the drawer and its content is rendered).
   * - **header** - The drawer header.
   * - **header-actions** - Optional actions to add to the header. Works best with `<lynk-icon-button>`.
   * - **title** - The drawer title.
   * - **close-button** - The close button.
   * - **close-button__base** - The close button's `base` part.
   * - **body** - The drawer body.
   * - **footer** - The drawer footer.
   */
  "lynk-drawer": DefineComponent<LynkDrawerProps>;

  /**
   * Dropdowns expose additional content that "drops down" in a panel.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-show** - Emitted when the dropdown opens.
   * - **ev-after-show** - Emitted after the dropdown opens and all animations are complete.
   * - **ev-hide** - Emitted when the dropdown closes.
   * - **ev-after-hide** - Emitted after the dropdown closes and all animations are complete.
   *
   * ### **Methods:**
   *  - **show()** - Shows the dropdown panel.
   * - **hide()** - Hides the dropdown panel
   * - **reposition()** - Instructs the dropdown menu to reposition. Useful when the position or size of the trigger changes when the menu
   * is activated.
   *
   * ### **Slots:**
   *  - _default_ - The dropdown's content.
   * - **trigger** - The dropdown's trigger, usually a `<lynk-button>` element.
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   * - **trigger** - The container that wraps the trigger.
   * - **panel** - The panel that gets shown when the dropdown is open.
   */
  "lynk-dropdown": DefineComponent<LynkDropdownProps>;

  /**
   * A container for customized or non-standard form inputs.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-focus** - Emitted when field or slotted element gains focus.
   * - **ev-blur** - Emitted when field or slotted element loses focus.
   *
   * ### **Methods:**
   *  - **focus(options: _FocusOptions_)** - Sets focus on the control.
   * - **blur()** - Removes focus from the control.
   *
   * ### **Slots:**
   *  - _default_ - The default slot.
   * - **help-tip** - Custom help-tip content.
   * - **help-text** - Custom help-text content.
   * - **label** - Custom label content.
   *
   * ### **CSS Parts:**
   *  - **base** - The component's base wrapper.
   * - **label** - The component's label wrapper.
   * - **control** - The component's slotted control wrapper.
   * - **help-text** - The component's help-text wrapper.
   */
  "lynk-form-field": DefineComponent<LynkFormFieldProps>;

  /**
   * Formats a number as a human readable bytes value.
   * ---
   *
   */
  "lynk-format-bytes": DefineComponent<LynkFormatBytesProps>;

  /**
   * Formats a date/time using the specified locale and options.
   * ---
   *
   */
  "lynk-format-date": DefineComponent<LynkFormatDateProps>;

  /**
   * The Grid component helps create visual consistency and structure between layouts while allowing flexibility across a wide variety of designs. It uses [CSS's Flexible Box module](https://www.w3.org/TR/css-flexbox-1/) for high flexibility.
   * ---
   *
   *
   * ### **Slots:**
   *  - _default_ - The default slot.
   *
   * ### **CSS Properties:**
   *  - **--width** - Set a custom width for the grid container element. Defaults to 100%. _(default: undefined)_
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   */
  "lynk-grid": DefineComponent<LynkGridProps>;

  /**
   * Formats a number using the specified locale and options.
   * ---
   *
   */
  "lynk-format-number": DefineComponent<LynkFormatNumberProps>;

  /**
   * Icons are symbols that can be used to represent various options within an application.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-load** - Emitted when the icon has loaded. When using `spriteSheet: true` this will not emit.
   * - **ev-error** - Emitted when the icon fails to load due to an error. When using `spriteSheet: true` this will not emit.
   *
   * ### **CSS Parts:**
   *  - **svg** - The internal SVG element.
   * - **use** - The <use> element generated when using `spriteSheet: true`
   */
  "lynk-icon": DefineComponent<LynkIconProps>;

  /**
   * Icons buttons are simple, icon-only buttons that can be used for actions and in toolbars.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-blur** - Emitted when the icon button loses focus.
   * - **ev-click** - Emitted when the button is clicked.
   * - **ev-focus** - Emitted when the icon button gains focus.
   *
   * ### **Methods:**
   *  - **click()** - Simulates a click on the icon button.
   * - **focus(options: _FocusOptions_)** - Sets focus on the icon button.
   * - **blur()** - Removes focus from the icon button.
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   */
  "lynk-icon-button": DefineComponent<LynkIconButtonProps>;

  /**
   * Includes give you the power to embed external HTML files into the page.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-load** - Emitted when the included file is loaded.
   * - **ev-error** - Emitted when the included file fails to load due to an error.
   */
  "lynk-include": DefineComponent<LynkIncludeProps>;

  /**
   * Inputs collect data from the user.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-blur** - Emitted when the control loses focus.
   * - **ev-change** - Emitted when an alteration to the control's value is committed by the user.
   * - **ev-clear** - Emitted when the clear button is activated.
   * - **ev-enter** - Emitted when the return key is pressed while the input has focus.
   * - **ev-focus** - Emitted when the control gains focus.
   * - **ev-input** - Emitted when the control receives input.
   * - **ev-invalid** - Emitted when the form control has been checked for validity and its constraints aren't satisfied.
   *
   * ### **Methods:**
   *  - **focus(options: _FocusOptions_)** - Sets focus on the input.
   * - **blur()** - Removes focus from the input.
   * - **select()** - Selects all the text in the input.
   * - **setSelectionRange(selectionStart: _number_, selectionEnd: _number_, selectionDirection: _'forward' | 'backward' | 'none'_)** - Sets the start and end positions of the text selection (0-based).
   * - **setRangeText(replacement: _string_, start: _number_, end: _number_, selectMode: _'select' | 'start' | 'end' | 'preserve'_)** - Replaces a range of text with a new string.
   * - **showPicker()** - Displays the browser picker for an input element (only works if the browser supports it for the input type).
   * - **stepUp()** - Increments the value of a numeric input type by the value of the step attribute.
   * - **stepDown()** - Decrements the value of a numeric input type by the value of the step attribute.
   * - **checkValidity()** - Checks for validity but does not show a validation message. Returns `true` when valid and `false` when invalid.
   * - **getForm(): _HTMLFormElement | null_** - Gets the associated form, if one exists.
   * - **reportValidity()** - Checks for validity and shows the browser's validation message if the control is invalid.
   * - **setCustomValidity(message: _string_)** - Sets a custom validation message. Pass an empty string to restore validity.
   *
   * ### **Slots:**
   *  - **action** - append a custom button to the input.
   * - **label** - The input's label. Alternatively, you can use the label prop.
   * - **prefix** - Used to prepend an icon or similar element to the input.
   * - **suffix** - Used to append an icon or similar element to the input.
   * - **clear-icon** - An icon to use in lieu of the default clear icon.
   * - **show-password-icon** - An icon to use in lieu of the default show password icon.
   * - **hide-password-icon** - An icon to use in lieu of the default hide password icon.
   * - **help-text** - Help text that describes how to use the input. Alternatively, you can use the help-text prop.
   * - **help-tip** - Help tooltip next to the label that can be used in place of help-text to give additional information about how to use the input. Alternatively, you can use the help-tip prop.
   *
   * ### **CSS Parts:**
   *  - **form-control** - The form control that wraps the label, input, and help-text.
   * - **form-control-label** - The label's wrapper.
   * - **form-control-input** - The input's wrapper.
   * - **form-control-help-text** - The help text's wrapper.
   * - **base** - The component's internal wrapper.
   * - **input** - The input control.
   * - **prefix** - The input prefix container.
   * - **clear-button** - The clear button.
   * - **password-toggle-button** - The password toggle button.
   * - **suffix** - The input suffix container.
   */
  "lynk-input": DefineComponent<LynkInputProps>;

  /**
   * The Intersection Observer component offers a thin, declarative interface to the [`IntersectionObserver API`](https://developer.mozilla.org/en-US/docs/Web/API/IntersectionObserver).
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-enter-view** - Emitted when a slotted element enters the view.
   * - **ev-exit-view** - Emitted when a slotted element exits the view.
   *
   * ### **Slots:**
   *  - _default_ - One or more elements to watch for intersection.
   */
  "lynk-intersection-observer": DefineComponent<LynkIntersectionObserverProps>;

  /**
   * Menus provide a list of options for the user to choose from.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-select** - Emitted when a menu item is selected.
   *
   * ### **Slots:**
   *  - _default_ - The menu's content, including menu items, menu labels, and dividers.
   */
  "lynk-menu": DefineComponent<LynkMenuProps>;

  /**
   * Menu items provide options for the user to pick from in a menu.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-click** - Emitted when a menu item is clicked
   *
   * ### **Methods:**
   *  - **getTextLabel()** - Returns a text label based on the contents of the menu item's default slot.
   *
   * ### **Slots:**
   *  - _default_ - The menu item's label.
   * - **prefix** - Used to prepend an icon or similar element to the menu item.
   * - **suffix** - Used to append an icon or similar element to the menu item.
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   * - **checked-icon** - The checked icon, which is only visible when the menu item is checked.
   * - **prefix** - The prefix container.
   * - **label** - The menu item label.
   * - **suffix** - The suffix container.
   */
  "lynk-menu-item": DefineComponent<LynkMenuItemProps>;

  /**
   * Menu labels are used to describe a group of menu items.
   * ---
   *
   *
   * ### **Slots:**
   *  - _default_ - The menu label's content.
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   */
  "lynk-menu-label": DefineComponent<LynkMenuLabelProps>;

  /**
   * The Mutation Observer component offers a thin, declarative interface to the [`MutationObserver API`](https://developer.mozilla.org/en-US/docs/Web/API/MutationObserver).
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-mutation** - Emitted when a mutation occurs.
   *
   * ### **Slots:**
   *  - _default_ - The content to watch for mutations.
   */
  "lynk-mutation-observer": DefineComponent<LynkMutationObserverProps>;

  /**
   * Navs display a hierarchical menu of [nav items](/components/nav-item) for navigating within an app or page. Items with children can be expanded and collapsed as desired by the user.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-select** - Emitted when a nav item is selected.
   *
   * ### **Slots:**
   *  - _default_ - The nav's content, including nav items, nav groups, and dividers.
   *
   * ### **CSS Properties:**
   *  - **--max-width** - Customize the max nav width. _(default: 100%)_
   * - **--background** - Customize the nav background. _(default: transparent)_
   * - **--padding** - Customize the nav padding. _(default: var(--lynk-spacing-x-small) 0)_
   * - **--border-top** - Customize the top border. _(default: none)_
   * - **--border-right** - Customize the right border. _(default: none)_
   * - **--border-bottom** - Customize the bottom border. _(default: none)_
   * - **--border-left** - Customize the left border. _(default: none)_
   * - **--border-radius** - Customize the border radius. _(default: 0)_
   *
   * ### **CSS Parts:**
   *  - **base** - The component's base wrapper.
   */
  "lynk-nav": DefineComponent<LynkNavProps>;

  /**
   * Group navigation items into categories with a header.
   * ---
   *
   *
   * ### **Slots:**
   *  - _default_ - the Nav Items to display in association with the heading
   * - **heading** - The nav groups heading. Alternatively, you can use the heading prop.
   *
   * ### **CSS Properties:**
   *  - **--color** - Customize the header color. _(default: var(--lynk-color-neutral-600))_
   *
   * ### **CSS Parts:**
   *  - **base** - The nav groups heading wrapper.
   * - **children** - The nav groups children wrapper.
   */
  "lynk-nav-group": DefineComponent<LynkNavGroupProps>;

  /**
   * Nav items allow the user to navigate or trigger actions from within a navigation menu.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-expand** - Emitted when the nav item expands.
   * - **ev-after-expand** - Emitted after the nav item expands and all animations are complete.
   * - **ev-collapse** - Emitted when the nav item collapses.
   * - **ev-after-collapse** - Emitted after the nav item collapses and all animations are complete.
   *
   * ### **Methods:**
   *  - **click()** - Simulates a click on the nav item.
   * - **getTextLabel()** - Returns a text label based on the contents of the menu item's default slot.
   * - **getChildrenItems({ includeDisabled = true }: _{ includeDisabled?: boolean }_): _LynkNavItem[]_** - Gets all the nested tree items in this node.
   *
   * ### **Slots:**
   *  - _default_ - The nav item's label.
   * - **prefix** - Used to prepend an icon or similar element to the nav item.
   * - **suffix** - Used to append an icon or similar element to the nav item.
   * - **children** - Used to nest nav items under a nav item.
   *
   * ### **CSS Properties:**
   *  - **--hover-bg-color** - Customize the hover styles. _(default: var(--lynk-color-gray-a25))_
   * - **--selected-bg-color** - Customize the selected styles. _(default: var(--lynk-color-primary-700))_
   * - **--selected-color** - Customize the selected styles. _(default: var(--lynk-color-gray-a25))_
   * - **--border-radius** - Customize the border radius. _(default: var(--lynk-border-radius-medium))_
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   * - **prefix** - The prefix container.
   * - **label** - The nav item label.
   * - **suffix** - The suffix container.
   */
  "lynk-nav-item": DefineComponent<LynkNavItemProps>;

  /**
   * Creates a grouping for [options](/components/option) within a [select](/components/select) or [combobox](/components/combobox).
   * ---
   *
   *
   * ### **Slots:**
   *  - _default_ - The given options. Must be `lynk-option` elements.
   * - **prefix** - A presentational prefix icon or similar element.
   * - **label** - The label for the optgroup
   * - **suffix** - A presentational suffix icon or similar element.
   *
   * ### **CSS Properties:**
   *  - **--display-divider** - Display property of the divider. Defaults to "block" _(default: undefined)_
   *
   * ### **CSS Parts:**
   *  - **base** - The component's base wrapper.
   * - **label-container** - The container that wraps prefix, label and base
   * - **divider** - The divider that is displayed above the content
   * - **prefix** - The container that wraps the prefix.
   * - **suffix** - The container that wraps the suffix.
   * - **options** - The container that wraps the option elements.
   */
  "lynk-optgroup": DefineComponent<LynkOptgroupProps>;

  /**
   * Options define the selectable items within various form controls such as [select](/components/select).
   * ---
   *
   *
   * ### **Methods:**
   *  - **getTextLabel()** - Returns a plain text label based on the option's content.
   *
   * ### **Slots:**
   *  - _default_ - The option's label.
   * - **prefix** - Used to prepend an icon or similar element to the menu item.
   * - **suffix** - Used to append an icon or similar element to the menu item.
   *
   * ### **CSS Parts:**
   *  - **checked-icon** - The checked icon, an `<lynk-icon>` element.
   * - **base** - The component's base wrapper.
   * - **label** - The option's label.
   * - **prefix** - The container that wraps the prefix.
   * - **suffix** - The container that wraps the suffix.
   */
  "lynk-option": DefineComponent<LynkOptionProps>;

  /**
   * A standardized page layout container using css grid based layout areas.
   * ---
   *
   *
   * ### **Slots:**
   *  - _default_ - The page's main content area. Works best with `<lynk-page-content>`.
   * - **header** - The page's header area. Breadcrumb, title, tabs and other page level controls go in here. Works best with `<lynk-page-header>`
   * - **left-sidebar** - The page's left sidebar with a primary navigation menu. Works best with `<lynk-page-sidebar>`.
   * - **right-sidebar** - The page's right sidebar with a secondary navigation menu. Works best with `<lynk-page-sidebar>`.
   * - **left-inset-sidebar** - A visually nested left sidebar for displaying content specific menus or aside details. Works best with `<lynk-page-sidebar>`
   * - **right-inset-sidebar** - A visually nested right sidebar for displaying content specific menus or aside details. Works best with `<lynk-page-sidebar>`
   * - **footer** - The pages footer, usually one or more buttons representing various primary or secondary options like save or table pagination. Works best with `<lynk-page-footer>`
   *
   * ### **CSS Parts:**
   *  - **base** - The page layout internal wrapper.
   * - **header** - The page header area's internal wrapper.
   * - **left-sidebar** - The page left sidebar area's internal wrapper.
   * - **left-inset-sidebar** - The page left inset sidebar area's internal wrapper.
   * - **main** - The main content area's internal wrapper.
   * - **right-inset-sidebar** - The page right inset sidebar area's internal wrapper.
   * - **right-sidebar** - The page right sidebar area's internal wrapper.
   * - **footer** - The page footer areas internal wrapper.
   */
  "lynk-page": DefineComponent<LynkPageProps>;

  /**
   * The page-content component is a fundamental layout building block to standardize how content is contained, padded, and aligned within a given device or viewport.
   * ---
   *
   *
   * ### **Methods:**
   *  - **scrollToTop()** - Scrolls the nearest scrollable parent element to the top.
   */
  "lynk-page-content": DefineComponent<LynkPageContentProps>;

  /**
   * A Page Footer is used inside a [Page Layout](/components/page) to render a standardized sticky page footer with slots for typical page controls.
   * ---
   *
   *
   * ### **Slots:**
   *  - _default_ - The default start-aligned slot for primary page actions, Typically where `save` and `cancel` of form based pages should go.
   * - **center** - Typically used for pagination info or other non interactive page metadata.
   * - **secondary** - The end-aligned slot for secondary page actions. Typically where `delete` or other secondary destructive actions should go..
   *
   * ### **CSS Parts:**
   *  - **base** - The component's base wrapper.
   * - **primary** - The component's primary slot area.
   * - **center** - The component's center slot area.
   * - **secondary** - The component's secondary slot area.
   */
  "lynk-page-footer": DefineComponent<LynkPageFooterProps>;

  /**
   * The Page Header is used inside a [Page Layout](/components/page) to standardized header content and controls.
   * ---
   *
   *
   * ### **Slots:**
   *  - _default_ - The default slot for the title, description, and other relevant metadata.
   * - **breadcrumb** - Designated top-left area for breadcrumb navigation.
   * - **controls** - Designated area to right of default slot for standard header actions.
   * - **aux** - Designated top-right area for auxiliary header actions.
   * - **tabs** - Designated bottom area for tab navigation.
   *
   * ### **CSS Properties:**
   *  - **--gap** - The gutter spacing between slots. _(default: undefined)_
   *
   * ### **CSS Parts:**
   *  - **base** - The component's base wrapper.
   * - **breadcrumb** - The component's breadcrumb area wrapper.
   * - **controls** - The component's controls area wrapper.
   * - **main** - The component's main area wrapper.
   * - **aux** - The component's auxiliary controls area wrapper.
   * - **tabs** - The component's tab area wrapper.
   */
  "lynk-page-header": DefineComponent<LynkPageHeaderProps>;

  /**
   * The Page Sidebar is used inside a [Page Layout](/components/page) to render navigation and selection menus, or other related content that would normally be placed in a native `<aside>` element.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-show** - Emitted when the sidebar opens.
   * - **ev-after-show** - Emitted after the sidebar opens and all animations are complete.
   * - **ev-hide** - Emitted when the sidebar closes.
   * - **ev-after-hide** - Emitted after the sidebar closes and all animations are complete.
   *
   * ### **Methods:**
   *  - **show()** - Shows the sidebar
   * - **hide()** - Hides the sidebar
   *
   * ### **Slots:**
   *  - _default_ - The sidebar's content.
   * - **label** - The sidebar's label. Alternatively, you can use the label prop.
   * - **footer** - The sidebar's footer, usually one or more buttons representing various options.
   * - **nav** - An optional slot that can be used to display nav controls even when sidebar is collapsed.
   *
   * ### **CSS Properties:**
   *  - **--width** - The preferred width of the sidebar. _(default: undefined)_
   * - **--header-spacing** - The amount of padding to use for the header. _(default: undefined)_
   * - **--body-spacing** - The amount of padding to use for the body. _(default: undefined)_
   * - **--footer-spacing** - The amount of padding to use for the footer. _(default: undefined)_
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   * - **panel** - The sidebar panel (where the sidebar and its content is rendered).
   * - **header** - The sidebar header.
   * - **header-actions** - Optional actions to add to the header. Works best with `<lynk-icon-button>`.
   * - **title** - The sidebar title.
   * - **close-button** - The close button.
   * - **close-button__base** - The close button's `base` part.
   * - **body** - The sidebar body.
   * - **footer** - The sidebar footer.
   * - **nav** - The optional sidebar nav do display controls even when the sidebar is collapsed.
   */
  "lynk-page-sidebar": DefineComponent<LynkPageSidebarProps>;

  /**
   * Panels are lightweight content containers that may either stand alone or be grouped together to form an [Accordion](/components/accordion).
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-expand** - Emitted when the panel expands.
   * - **ev-after-expand** - Emitted after the panel expands and all animations are complete.
   * - **ev-collapse** - Emitted when the panel closes.
   * - **ev-after-collapse** - Emitted after the panel closes and all animations are complete.
   *
   * ### **Methods:**
   *  - **expand()** - Shows the panel.
   * - **collapse()** - Hides the panel
   *
   * ### **Slots:**
   *  - _default_ - The panels' content.
   * - **heading** - The panels' heading. Alternatively, you can use the `heading` attribute.
   * - **prefix** - The panels' summary prefix `<slot>`.
   * - **suffix** - The panels' summary suffix `<slot>`.
   * - **expand-icon** - The expand icon's `<slot>`.
   * - **collapse-icon** - The collapse icon's `<slot>`.
   * - **footer** - The panels' footer `<slot>`.
   *
   * ### **CSS Properties:**
   *  - **--background-color** - The panels background color _(default: undefined)_
   * - **--spacing** - The amount of padding to use for the header, body, and footer. _(default: undefined)_
   * - **--border-color** - Apply a panel border of your choosing. _(default: undefined)_
   * - **--border-radius** - The panels border radius. _(default: undefined)_
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   * - **header** - The panel header area.
   * - **heading** - The panel heading.
   * - **prefix** - The panel header prefix area.
   * - **suffix** - The panel header suffix area.
   * - **toggle-icon** - The expand/collapse toggle icon in the header.
   * - **content** - The panel content.
   * - **footer** - The panel footer.
   */
  "lynk-panel": DefineComponent<LynkPanelProps>;

  /**
   * Popover's display rich content in a "pop over" panel to add additional information or functionality when a user interacts with a triggering element.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-show** - Emitted when the popover opens.
   * - **ev-after-show** - Emitted after the popover opens and all animations are complete.
   * - **ev-hide** - Emitted when the popover closes.
   * - **ev-after-hide** - Emitted after the popover closes and all animations are complete.
   *
   * ### **Methods:**
   *  - **show()** - Shows the popover panel.
   * - **hide()** - Hides the popover panel
   * - **reposition()** - Instructs the popover menu to reposition. Useful when the position or size of the trigger changes when the menu
   * is activated.
   *
   * ### **Slots:**
   *  - _default_ - The popover's content.
   * - **label** - The dialog's label. Alternatively, you can use the label prop.
   * - **trigger** - The popover's trigger, usually a `<lynk-button>` element.
   * - **footer** - The dialog's footer, usually one or more buttons representing various options.
   *
   * ### **CSS Properties:**
   *  - **--width** - The preferred width of the popover. Defaults to 320px or 20rem. _(default: undefined)_
   * - **--max-width** - The max width of the popover as determined by its contents. Defaults to 480px or 30rem. _(default: undefined)_
   * - **--header-spacing** - The amount of padding to use for the header. _(default: undefined)_
   * - **--body-spacing** - The amount of padding to use for the body. _(default: undefined)_
   * - **--footer-spacing** - The amount of padding to use for the footer. _(default: undefined)_
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   * - **trigger** - The container that wraps the trigger.
   * - **panel** - The panel that gets shown when the popover is open.
   */
  "lynk-popover": DefineComponent<LynkPopoverProps>;

  /**
   * Popup is a utility that lets you declaratively anchor "popup" containers to another element.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-reposition** - Emitted when the popup is repositioned. This event can fire a lot, so avoid putting expensive operations in your listener or consider debouncing it.
   *
   * ### **Methods:**
   *  - **reposition()** - Forces the popup to recalculate and reposition itself.
   *
   * ### **Slots:**
   *  - _default_ - The popup's content.
   * - **anchor** - The element the popup will be anchored to. If the anchor lives outside of the popup, you can use the `anchor` attribute or property instead.
   *
   * ### **CSS Properties:**
   *  - **--arrow-size** - The size of the arrow. Note that an arrow won't be shown unless the `arrow` attribute is used. _(default: 6px)_
   * - **--arrow-color** - The color of the arrow. _(default: var(--sl-color-neutral-0))_
   * - **--auto-size-available-width** - A read-only custom property that determines the amount of width the popup can be before overflowing. Useful for positioning child elements that need to overflow. This property is only available when using `auto-size`. _(default: undefined)_
   * - **--auto-size-available-height** - A read-only custom property that determines the amount of height the popup can be before overflowing. Useful for positioning child elements that need to overflow. This property is only available when using `auto-size`. _(default: undefined)_
   *
   * ### **CSS Parts:**
   *  - **arrow** - The arrow's container. Avoid setting `top|bottom|left|right` properties, as these values are assigned dynamically as the popup moves. This is most useful for applying a background color to match the popup, and maybe a border or box shadow.
   * - **popup** - The popup's container. Useful for setting a background color, box shadow, etc.
   * - **hover-bridge** - The hover bridge element. Only available when the `hover-bridge` option is enabled.
   */
  "lynk-popup": DefineComponent<LynkPopupProps>;

  /**
   * Progress bars are used to show the status of an ongoing operation.
   * ---
   *
   *
   * ### **Slots:**
   *  - _default_ - A label to show inside the progress indicator.
   *
   * ### **CSS Properties:**
   *  - **--height** - The progress bar's height. _(default: undefined)_
   * - **--track-color** - The color of the track. _(default: undefined)_
   * - **--indicator-color** - The color of the indicator. _(default: undefined)_
   * - **--label-color** - The color of the label. _(default: undefined)_
   *
   * ### **CSS Parts:**
   *  - **base** - The component's base wrapper.
   * - **indicator** - The progress bar's indicator.
   * - **label** - The progress bar's label.
   */
  "lynk-progress-bar": DefineComponent<LynkProgressBarProps>;

  /**
   * Progress rings are used to show the progress of a determinate operation in a circular fashion.
   * ---
   *
   *
   * ### **Slots:**
   *  - _default_ - A label to show inside the ring.
   *
   * ### **CSS Properties:**
   *  - **--size** - The diameter of the progress ring (cannot be a percentage). _(default: undefined)_
   * - **--track-width** - The width of the track. _(default: undefined)_
   * - **--track-color** - The color of the track. _(default: undefined)_
   * - **--indicator-width** - The width of the indicator. Defaults to the track width. _(default: undefined)_
   * - **--indicator-color** - The color of the indicator. _(default: undefined)_
   * - **--indicator-transition-duration** - The duration of the indicator's transition when the value changes. _(default: undefined)_
   *
   * ### **CSS Parts:**
   *  - **base** - The component's base wrapper.
   * - **label** - The progress ring label.
   */
  "lynk-progress-ring": DefineComponent<LynkProgressRingProps>;

  /**
   * Radios allow the user to select a single option from a group.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-blur** - Emitted when the control loses focus.
   * - **ev-focus** - Emitted when the control gains focus.
   *
   * ### **Slots:**
   *  - _default_ - The radio's label.
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   * - **control** - The circular container that wraps the radio's checked state.
   * - **control--checked** - The radio control when the radio is checked.
   * - **checked-icon** - The checked icon, an `<lynk-icon>` element.
   * - **label** - The container that wraps the radio's label.
   */
  "lynk-radio": DefineComponent<LynkRadioProps>;

  /**
   * Radios buttons allow the user to select a single option from a group using a button-like control.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-blur** - Emitted when the button loses focus.
   * - **ev-focus** - Emitted when the button gains focus.
   *
   * ### **Methods:**
   *  - **focus(options: _FocusOptions_)** - Sets focus on the radio button.
   * - **blur()** - Removes focus from the button.
   *
   * ### **Slots:**
   *  - _default_ - The button's label.
   * - **prefix** - Used to prepend an icon or similar element to the button.
   * - **suffix** - Used to append an icon or similar element to the button.
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   * - **button** - The internal button element.
   * - **button--checked** - The internal button element if checked
   * - **prefix** - The prefix slot's container.
   * - **label** - The button's label.
   * - **suffix** - The suffix slot's container.
   */
  "lynk-radio-button": DefineComponent<LynkRadioButtonProps>;

  /**
   * Radio groups are used to group multiple [radios](/components/radio) or [radio buttons](/components/radio-button) so they function as a single form control.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-change** - Emitted when the radio group's selected value changes.
   * - **ev-input** - Emitted when the radio group receives user input.
   * - **ev-invalid** - Emitted when the form control has been checked for validity and its constraints aren't satisfied.
   *
   * ### **Methods:**
   *  - **checkValidity()** - Checks for validity but does not show a validation message. Returns `true` when valid and `false` when invalid.
   * - **getForm(): _HTMLFormElement | null_** - Gets the associated form, if one exists.
   * - **reportValidity(): _boolean_** - Checks for validity and shows the browser's validation message if the control is invalid.
   * - **setCustomValidity(message)** - Sets a custom validation message. Pass an empty string to restore validity.
   * - **focus(options: _FocusOptions_)** - Sets focus on the radio-group.
   *
   * ### **Slots:**
   *  - _default_ - The default slot where `<lynk-radio>` or `<lynk-radio-button>` elements are placed.
   * - **help-tip** - Custom help-tip content.
   * - **help-text** - Custom help-text content.
   * - **label** - The radio group label. Required for proper accessibility. Alternatively, you can use the label attribute.
   *
   * ### **CSS Parts:**
   *  - **form-control** - The form control that wraps the label, input, and help-text.
   * - **form-control-label** - The label's wrapper.
   * - **form-control-input** - The input's wrapper.
   * - **form-control-help-text** - The help text's wrapper.
   * - **button-group** - The button group that wraps radio buttons.
   * - **button-group__base** - The button group's `base` part.
   */
  "lynk-radio-group": DefineComponent<LynkRadioGroupProps>;

  /**
   * Ranges allow the user to select a single value within a given range using a slider.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-blur** - Emitted when the control loses focus.
   * - **ev-change** - Emitted when an alteration to the control's value is committed by the user.
   * - **ev-focus** - Emitted when the control gains focus.
   * - **ev-input** - Emitted when the control receives input.
   * - **ev-invalid** - Emitted when the form control has been checked for validity and its constraints aren't satisfied.
   *
   * ### **Methods:**
   *  - **focus(options: _FocusOptions_)** - Sets focus on the range.
   * - **blur()** - Removes focus from the range.
   * - **stepUp()** - Increments the value of the range by the value of the step attribute.
   * - **stepDown()** - Decrements the value of the range by the value of the step attribute.
   * - **checkValidity()** - Checks for validity but does not show a validation message. Returns `true` when valid and `false` when invalid.
   * - **getForm(): _HTMLFormElement | null_** - Gets the associated form, if one exists.
   * - **reportValidity()** - Checks for validity and shows the browser's validation message if the control is invalid.
   * - **setCustomValidity(message: _string_)** - Sets a custom validation message. Pass an empty string to restore validity.
   *
   * ### **Slots:**
   *  - **label** - The range's label. Alternatively, you can use the `label` attribute.
   * - **help-text** - Text that describes how to use the input. Alternatively, you can use the `help-text` attribute.
   * - **ticks** - Build your own ticks.
   *
   * ### **CSS Properties:**
   *  - **--thumb-size** - The size of the thumb. _(default: undefined)_
   * - **--tooltip-offset** - The vertical distance the tooltip is offset from the track. _(default: undefined)_
   * - **--track-color-active** - The color of the portion of the track that represents the current value. _(default: undefined)_
   * - **--track-color-inactive** - The of the portion of the track that represents the remaining value. _(default: undefined)_
   * - **--track-height** - The height of the track. _(default: undefined)_
   * - **--track-active-offset** - The point of origin of the active track. _(default: undefined)_
   *
   * ### **CSS Parts:**
   *  - **form-control** - The form control that wraps the label, input, and help text.
   * - **form-control-label** - The label's wrapper.
   * - **form-control-input** - The range's wrapper.
   * - **form-control-help-text** - The help text's wrapper.
   * - **base** - The component's base wrapper.
   * - **input** - The internal `<input>` element.
   * - **tooltip** - The range's tooltip.
   */
  "lynk-range": DefineComponent<LynkRangeProps>;

  /**
   * Outputs a localized time phrase relative to the current date and time.
   * ---
   *
   */
  "lynk-relative-time": DefineComponent<LynkRelativeTimeProps>;

  /**
   * The Resize Observer component offers a thin, declarative interface to the [`ResizeObserver API`](https://developer.mozilla.org/en-US/docs/Web/API/ResizeObserver).
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-resize** - Emitted when the element is resized.
   *
   * ### **Slots:**
   *  - _default_ - One or more elements to watch for resizing.
   */
  "lynk-resize-observer": DefineComponent<LynkResizeObserverProps>;

  /**
   *
   * ---
   *
   *
   * ### **Slots:**
   *  - _default_ - The element to receive the aspect ratio. Should be a replaced element, such as `<img>`, `<iframe>`, or `<video>`.
   */
  "lynk-responsive-media": DefineComponent<LynkResponsiveMediaProps>;

  /**
   * Selects allow you to choose items from a menu of predefined options.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-change** - Emitted when the control's value changes.
   * - **ev-clear** - Emitted when the control's value is cleared.
   * - **ev-input** - Emitted when the control receives input.
   * - **ev-focus** - Emitted when the control gains focus.
   * - **ev-blur** - Emitted when the control loses focus.
   * - **ev-show** - Emitted when the select's menu opens.
   * - **ev-after-show** - Emitted after the select's menu opens and all animations are complete.
   * - **ev-hide** - Emitted when the select's menu closes.
   * - **ev-after-hide** - Emitted after the select's menu closes and all animations are complete.
   * - **ev-invalid** - Emitted when the form control has been checked for validity and its constraints aren't satisfied.
   *
   * ### **Methods:**
   *  - **show()** - Shows the listbox.
   * - **hide()** - Hides the listbox.
   * - **checkValidity()** - Checks for validity but does not show the browser's validation message.
   * - **getForm(): _HTMLFormElement | null_** - Gets the associated form, if one exists.
   * - **reportValidity()** - Checks for validity and shows the browser's validation message if the control is invalid.
   * - **setCustomValidity(message: _string_)** - Sets a custom validation message. If `message` is not empty, the field will be considered invalid.
   * - **focus(options: _FocusOptions_)** - Sets focus on the control.
   * - **blur()** - Removes focus from the control.
   *
   * ### **Slots:**
   *  - _default_ - The listbox options. Must be `<lynk-option>` elements. You can use `<lynk-divider>` to group items visually.
   * - **label** - The input's label. Alternatively, you can use the `label` attribute.
   * - **prefix** - Used to prepend a presentational icon or similar element to the combobox.
   * - **suffix** - Used to append a presentational icon or similar element to the combobox.
   * - **clear-icon** - An icon to use in lieu of the default clear icon.
   * - **expand-icon** - The icon to show when the control is expanded and collapsed. Rotates on open and close.
   * - **help-text** - Text that describes how to use the input. Alternatively, you can use the `help-text` attribute.
   *
   * ### **CSS Parts:**
   *  - **form-control** - The form control that wraps the label, input, and help text.
   * - **form-control-label** - The label's wrapper.
   * - **form-control-input** - The select's wrapper.
   * - **form-control-help-text** - The help text's wrapper.
   * - **combobox** - The container the wraps the prefix, combobox, clear icon, and expand button.
   * - **prefix** - The container that wraps the prefix slot.
   * - **suffix** - The container that wraps the suffix slot.
   * - **display-input** - The element that displays the selected option's label, an `<input>` element.
   * - **listbox** - The listbox container where options are slotted.
   * - **tags** - The container that houses option tags when `multiselect` is used.
   * - **tag** - The individual tags that represent each multiselect option.
   * - **tag__base** - The tag's base part.
   * - **tag__content** - The tag's content part.
   * - **tag__remove-button** - The tag's remove button.
   * - **tag__remove-button__base** - The tag's remove button base part.
   * - **clear-button** - The clear button.
   * - **expand-icon** - The container that wraps the expand icon.
   */
  "lynk-select": DefineComponent<LynkSelectProps>;

  /**
   * Spinners are used to show the progress of an indeterminate operation.
   * ---
   *
   *
   * ### **CSS Properties:**
   *  - **--track-width** - The width of the track. _(default: undefined)_
   * - **--track-color** - The color of the track. _(default: undefined)_
   * - **--indicator-color** - The color of the indicator. _(default: undefined)_
   * - **--speed** - The time it takes for the spinner to complete one animation cycle. _(default: undefined)_
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   */
  "lynk-spinner": DefineComponent<LynkSpinnerProps>;

  /**
   * Split panels display two adjacent panels, allowing the user to reposition them.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-reposition** - Emitted when the divider's position changes.
   *
   * ### **Slots:**
   *  - **start** - Content to place in the start panel.
   * - **end** - Content to place in the end panel.
   * - **divider** - The divider. Useful for slotting in a custom icon that renders as a handle.
   *
   * ### **CSS Properties:**
   *  - **--divider-width** - The width of the visible divider. _(default: 4px)_
   * - **--divider-hit-area** - The invisible region around the divider where dragging can occur. This is usually wider than the divider to facilitate easier dragging. _(default: 12px)_
   * - **--min** - The minimum allowed size of the primary panel. _(default: 0)_
   * - **--max** - The maximum allowed size of the primary panel. _(default: 100%)_
   *
   * ### **CSS Parts:**
   *  - **start** - The start panel.
   * - **end** - The end panel.
   * - **panel** - Targets both the start and end panels.
   * - **divider** - The divider that separates the start and end panels.
   */
  "lynk-split-panel": DefineComponent<LynkSplitPanelProps>;

  /**
   * Stacks are a fundamental building block for laying out and aligning small bits of content or simple components in a vertical or horizontal space.
   * ---
   *
   *
   * ### **Slots:**
   *  - _default_ - The default slot.
   *
   * ### **CSS Properties:**
   *  - **--width** - Customize the width of the stack group. _(default: 100%)_
   * - **--height** - Customize the width of the stack group. _(default: auto)_
   * - **--gap** - Customize the gap of the stack group. _(default: var(--lynk-spacing-small))_
   * - **--margin** - Customize the margin of the stack group. _(default: 0)_
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   */
  "lynk-stack": DefineComponent<LynkStackProps>;

  /**
   * Switches allow the user to toggle an option on or off.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-blur** - Emitted when the control loses focus.
   * - **ev-change** - Emitted when the control's checked state changes.
   * - **ev-input** - Emitted when the control receives input.
   * - **ev-focus** - Emitted when the control gains focus.
   * - **ev-invalid** - Emitted when the form control has been checked for validity and its constraints aren't satisfied.
   *
   * ### **Methods:**
   *  - **click()** - Simulates a click on the switch.
   * - **focus(options: _FocusOptions_)** - Sets focus on the switch.
   * - **blur()** - Removes focus from the switch.
   * - **checkValidity()** - Checks for validity but does not show the browser's validation message.
   * - **getForm(): _HTMLFormElement | null_** - Gets the associated form, if one exists.
   * - **reportValidity()** - Checks for validity and shows the browser's validation message if the control is invalid.
   * - **setCustomValidity(message: _string_)** - Sets a custom validation message. Pass an empty string to restore validity.
   *
   * ### **Slots:**
   *  - _default_ - The switch's label.
   *
   * ### **CSS Properties:**
   *  - **--width** - The width of the switch. _(default: undefined)_
   * - **--height** - The height of the switch. _(default: undefined)_
   * - **--thumb-size** - The size of the thumb. _(default: undefined)_
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   * - **control** - The switch control.
   * - **thumb** - The switch position indicator.
   * - **label** - The switch label.
   */
  "lynk-switch": DefineComponent<LynkSwitchProps>;

  /**
   * Tabs are used inside [tab groups](/components/tab-group) to represent and activate [tab panels](/components/tab-panel).
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-close** - Emitted when the tab is closable and the close button is activated.
   *
   * ### **Methods:**
   *  - **focus(options: _FocusOptions_)** - Sets focus to the tab.
   * - **blur()** - Removes focus from the tab.
   *
   * ### **Slots:**
   *  - _default_ - The tab's label.
   *
   * ### **CSS Parts:**
   *  - **base** - The component's base wrapper.
   * - **close-button** - The close button, an `<lynk-icon-button>`.
   * - **close-button__base** - The close button's exported `base` part.
   */
  "lynk-tab": DefineComponent<LynkTabProps>;

  /**
   * Tab groups organize content into a container that shows one section at a time.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-tab-show** - Emitted when a tab is shown.
   * - **ev-tab-hide** - Emitted when a tab is hidden.
   *
   * ### **Methods:**
   *  - **show(panel: _string_)** - Shows the specified tab panel.
   *
   * ### **Slots:**
   *  - _default_ - Used for grouping tab panels in the tab group. Must be `<lynk-tab-panel>` elements.
   * - **nav** - Used for grouping tabs in the tab group. Must be `<lynk-tab>` elements.
   *
   * ### **CSS Properties:**
   *  - **--indicator-color** - The color of the active tab indicator. _(default: undefined)_
   * - **--track-color** - The color of the indicator's track (the line that separates tabs from panels). _(default: undefined)_
   * - **--track-width** - The width of the indicator's track (the line that separates tabs from panels). _(default: undefined)_
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   * - **nav** - The tab group navigation container.
   * - **tabs** - The container that wraps the slotted tabs.
   * - **active-tab-indicator** - The line that highlights the currently selected tab.
   * - **body** - The tab group body where tab panels are slotted in.
   * - **scroll-button** - The previous/next scroll buttons that show when tabs are scrollable, an `<lynk-icon-button>`.
   * - **scroll-button--start** - Targets the starting scroll button.
   * - **scroll-button--end** - Targets the ending scroll button.
   * - **scroll-button__base** - The scroll button's `base` part.
   */
  "lynk-tab-group": DefineComponent<LynkTabGroupProps>;

  /**
   * Tab panels are used inside [tab groups](/components/tab-group) to display tabbed content.
   * ---
   *
   *
   * ### **Slots:**
   *  - _default_ - The tab panel's content.
   *
   * ### **CSS Properties:**
   *  - **--padding** - The tab panel's padding. _(default: undefined)_
   *
   * ### **CSS Parts:**
   *  - **base** - The component's base wrapper.
   */
  "lynk-tab-panel": DefineComponent<LynkTabPanelProps>;

  /**
   * Tables display tabular data in a basic grid composed of cells, columns, and rows. This format makes it easy for users to scan and compare large amounts of data. Lynk based tables are intended to behave like native html `<table>` elements.
   * ---
   *
   *
   * ### **Slots:**
   *  - _default_ - The tables content. If constructing manually, should contain 1 or more `<lynk-thead>` and `<lynk-tbody>` components. Should be unused for automatically constructed tables that use the `cols` and `rows` properties.
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   */
  "lynk-table": DefineComponent<LynkTableProps>;

  /**
   * Tags are used as labels to organize things or to indicate a selection.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-remove** - Emitted when the remove button is activated.
   *
   * ### **Slots:**
   *  - _default_ - The tag's content.
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   * - **content** - The tag content.
   * - **remove-button** - The remove button.
   * - **remove-button__base** - The remove button's `base` part.
   */
  "lynk-tag": DefineComponent<LynkTagProps>;

  /**
   * Table `<lynk-tbody>` components will behave like a native `<tbody>` HTML element within a `<lynk-table>`.
   * ---
   *
   */
  "lynk-tbody": DefineComponent<LynkTbodyProps>;

  /**
   * Table `<lynk-td>` components will behave like a native `<td>` HTML element within a `<lynk-table>`.
   * ---
   *
   *
   * ### **Slots:**
   *  - _default_ - The contents of the table cell.
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   */
  "lynk-td": DefineComponent<LynkTdProps>;

  /**
   * Textareas collect data from the user and allow multiple lines of text.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-change** - Emitted when an alteration to the control's value is committed by the user.
   * - **ev-input** - Emitted when the control receives input.
   * - **ev-focus** - Emitted when the control gains focus.
   * - **ev-blur** - Emitted when the control loses focus.
   * - **ev-invalid** - Emitted when the form control has been checked for validity and its constraints aren't satisfied.
   *
   * ### **Methods:**
   *  - **focus(options: _FocusOptions_)** - Sets focus on the textarea.
   * - **blur()** - Removes focus from the textarea.
   * - **select()** - Selects all the text in the textarea.
   * - **scrollPosition(position: _{ top?: number; left?: number }_): _{ top: number; left: number } | undefined_** - Gets or sets the textarea's scroll position.
   * - **setSelectionRange(selectionStart: _number_, selectionEnd: _number_, selectionDirection: _'forward' | 'backward' | 'none'_)** - Sets the start and end positions of the text selection (0-based).
   * - **setRangeText(replacement: _string_, start: _number_, end: _number_, selectMode: _'select' | 'start' | 'end' | 'preserve'_)** - Replaces a range of text with a new string.
   * - **checkValidity()** - Checks for validity but does not show the browser's validation message.
   * - **getForm(): _HTMLFormElement | null_** - Gets the associated form, if one exists.
   * - **reportValidity()** - Checks for validity and shows the browser's validation message if the control is invalid.
   * - **setCustomValidity(message: _string_)** - Sets a custom validation message. If `message` is not empty, the field will be considered invalid.
   *
   * ### **Slots:**
   *  - **label** - The textarea's label. Alternatively, you can use the label prop.
   * - **help-text** - Help text that describes how to use the input.
   * - **help-tip** - A help tooltip next to the label that can be used in place of help-text to give additional information about how to use the input. Alternatively, you can use the help-tip prop.
   *
   * ### **CSS Parts:**
   *  - **form-control** - The form control that wraps the label, input, and help-text.
   * - **form-control-label** - The label's wrapper.
   * - **form-control-input** - The input's wrapper.
   * - **form-control-help-text** - The help text's wrapper.
   * - **base** - The component's internal wrapper.
   * - **textarea** - The textarea control.
   */
  "lynk-textarea": DefineComponent<LynkTextareaProps>;

  /**
   * Table `<lynk-th>` components will behave like a native `<th>` HTML element within a `<lynk-table>`.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-table-sort** - Emitted when a sortable table header is clicked on.
   *
   * ### **Slots:**
   *  - _default_ - The table column header label
   */
  "lynk-th": DefineComponent<LynkThProps>;

  /**
   * Table `<lynk-thead>` components will behave like a native `<thead>` HTML elements within a `<lynk-table>`.
   * ---
   *
   */
  "lynk-thead": DefineComponent<LynkTheadProps>;

  /**
   * Tooltips display additional information based on a specific action.
   * ---
   *
   *
   * ### **Events:**
   *  - **ev-show** - Emitted when the tooltip begins to show.
   * - **ev-after-show** - Emitted after the tooltip has shown and all animations are complete.
   * - **ev-hide** - Emitted when the tooltip begins to hide.
   * - **ev-after-hide** - Emitted after the tooltip has hidden and all animations are complete.
   *
   * ### **Methods:**
   *  - **show()** - Shows the tooltip.
   * - **hide()** - Hides the tooltip
   *
   * ### **Slots:**
   *  - _default_ - The tooltip's target element. Only the first element will be used as the target.
   * - **content** - The tooltip's content. Alternatively, you can use the content prop.
   *
   * ### **CSS Properties:**
   *  - **--max-width** - The maximum width of the tooltip. _(default: undefined)_
   * - **--hide-delay** - The amount of time to wait before hiding the tooltip when hovering. _(default: undefined)_
   * - **--show-delay** - The amount of time to wait before showing the tooltip when hovering. _(default: undefined)_
   *
   * ### **CSS Parts:**
   *  - **base** - The component's base wrapper, an `<lynk-popup>` element.
   * - **base__popup** - The popup's `popup` part. Use this to target the tooltip's popup container.
   * - **base__arrow** - The popup's `arrow` part. Use this to target the tooltip's arrow.
   * - **body** - The tooltip's body.
   */
  "lynk-tooltip": DefineComponent<LynkTooltipProps>;

  /**
   * Table `<lynk-tr>` components will behave like a native `<tr>` HTML elements within a `<lynk-table>`.
   * ---
   *
   *
   * ### **Slots:**
   *  - _default_ - Should contain 1 or more `<lynk-td>` or `<lynk-th>` components.
   *
   * ### **CSS Parts:**
   *  - **base** - The component's internal wrapper.
   */
  "lynk-tr": DefineComponent<LynkTrProps>;

  /**
   * Truncate is a tool used to shorten numeric and non-numeric character strings, typically when the string overflows its container.
   * ---
   *
   *
   * ### **Methods:**
   *  - **getTextLabel()** - Returns a plain text label based on the option's content.
   *
   * ### **Slots:**
   *  - _default_ - The default slot.
   * - **end** - Used when adding ellipsis at start or middle of truncated string.
   */
  "lynk-truncate": DefineComponent<LynkTruncateProps>;

  /**
   * The visually hidden utility makes content accessible to assistive devices without displaying it on the screen.
   * ---
   *
   *
   * ### **Slots:**
   *  - _default_ - The content to be visually hidden.
   */
  "lynk-visually-hidden": DefineComponent<LynkVisuallyHiddenProps>;

  /**
   * Wisps are used to provide a visual representation of where content will eventually be drawn.
   * ---
   *
   *
   * ### **CSS Properties:**
   *  - **--border-radius** - The wisp's border radius. _(default: undefined)_
   * - **--color** - The color of the wisp. _(default: undefined)_
   * - **--sheen-color** - The sheen color when the wisp is in its loading state. _(default: undefined)_
   *
   * ### **CSS Parts:**
   *  - **base** - The component's base wrapper.
   * - **indicator** - The wisp's indicator which is responsible for its color and animation.
   */
  "lynk-wisp": DefineComponent<LynkWispProps>;
};

declare module "vue" {
  // eslint-disable-next-line @typescript-eslint/no-empty-interface
  interface GlobalComponents extends CustomElements {}
}

declare global {
  namespace JSX {
    // eslint-disable-next-line @typescript-eslint/no-empty-interface
    interface IntrinsicElements extends CustomElements {}
  }
}
