import {
  icon_button_styles_default
} from "./chunk.AXZVM7JU.js";
import {
  HasSlotController
} from "./chunk.OW5NIGGX.js";
import {
  LynkIcon
} from "./chunk.OTHQ47SZ.js";
import {
  LynkElement
} from "./chunk.7M4AVQ6D.js";
import {
  component_styles_default
} from "./chunk.Y7724W4D.js";
import {
  __decorateClass
} from "./chunk.KAW7D32O.js";

// src/components/icon-button/icon-button.component.ts
import { classMap } from "lit/directives/class-map.js";
import { html, literal } from "lit/static-html.js";
import { ifDefined } from "lit/directives/if-defined.js";
import { property, query, state } from "lit/decorators.js";
var LynkIconButton = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.hasFocus = false;
    this.hasSlotController = new HasSlotController(this, "prefix", "suffix");
    this.color = "default";
    this.label = "";
    this.disabled = false;
  }
  /** Simulates a click on the icon button. */
  click() {
    this.button.click();
  }
  /** Sets focus on the icon button. */
  focus(options) {
    this.button.focus(options);
  }
  /** Removes focus from the icon button. */
  blur() {
    this.button.blur();
  }
  handleBlur() {
    this.hasFocus = false;
    this.emit("ev-blur");
  }
  handleFocus() {
    this.hasFocus = true;
    this.emit("ev-focus");
  }
  handleClick(event) {
    if (this.disabled) {
      event.preventDefault();
      event.stopPropagation();
      return;
    }
    this.emit("ev-click");
  }
  render() {
    const isLink = this.href ? true : false;
    const tag = isLink ? literal`a` : literal`button`;
    return html`
      <${tag}
        part="base"
        class=${classMap({
      "icon-button": true,
      "icon-button--default": this.color === "default",
      "icon-button--primary": this.color === "primary",
      "icon-button--success": this.color === "success",
      "icon-button--neutral": this.color === "neutral",
      "icon-button--warning": this.color === "warning",
      "icon-button--danger": this.color === "danger",
      "icon-button--disabled": !isLink && this.disabled,
      "icon-button--focused": this.hasFocus,
      "icon-button--has-prefix": this.hasSlotController.test("prefix"),
      "icon-button--has-suffix": this.hasSlotController.test("suffix")
    })}
        ?disabled=${ifDefined(isLink ? void 0 : this.disabled)}
        type=${ifDefined(isLink ? void 0 : "button")}
        href=${ifDefined(isLink ? this.href : void 0)}
        target=${ifDefined(isLink ? this.target : void 0)}
        download=${ifDefined(isLink ? this.download : void 0)}
        rel=${ifDefined(isLink && this.target ? "noreferrer noopener" : void 0)}
        role=${ifDefined(isLink ? void 0 : "button")}
        aria-disabled=${this.disabled ? "true" : "false"}
        aria-label="${this.label}"
        tabindex=${this.disabled ? "-1" : "0"}
        @blur=${this.handleBlur}
        @focus=${this.handleFocus}
        @click=${this.handleClick}
      >
        <span part="prefix" class="icon-button__prefix">
          <slot name="prefix"></slot>
        </span>
        <lynk-icon
          class="icon-button__icon"
          name=${ifDefined(this.name)}
          library=${ifDefined(this.library)}
          src=${ifDefined(this.src)}
          aria-hidden="true"
        ></lynk-icon>
        <span part="suffix" class="icon-button__suffix">
          <slot name="suffix"></slot>
        </span>
      </${tag}>
    `;
  }
};
LynkIconButton.styles = [component_styles_default, icon_button_styles_default];
LynkIconButton.dependencies = { "lynk-icon": LynkIcon };
__decorateClass([
  query(".icon-button")
], LynkIconButton.prototype, "button", 2);
__decorateClass([
  state()
], LynkIconButton.prototype, "hasFocus", 2);
__decorateClass([
  property({ reflect: true })
], LynkIconButton.prototype, "color", 2);
__decorateClass([
  property()
], LynkIconButton.prototype, "name", 2);
__decorateClass([
  property()
], LynkIconButton.prototype, "library", 2);
__decorateClass([
  property()
], LynkIconButton.prototype, "src", 2);
__decorateClass([
  property()
], LynkIconButton.prototype, "href", 2);
__decorateClass([
  property()
], LynkIconButton.prototype, "target", 2);
__decorateClass([
  property()
], LynkIconButton.prototype, "download", 2);
__decorateClass([
  property()
], LynkIconButton.prototype, "label", 2);
__decorateClass([
  property({ type: Boolean, reflect: true })
], LynkIconButton.prototype, "disabled", 2);

export {
  LynkIconButton
};
