import {
  nav_group_styles_default
} from "./chunk.EYEMGZM7.js";
import {
  HasSlotController
} from "./chunk.OW5NIGGX.js";
import {
  watch
} from "./chunk.GMYPQTFK.js";
import {
  LynkElement
} from "./chunk.7M4AVQ6D.js";
import {
  component_styles_default
} from "./chunk.Y7724W4D.js";
import {
  __decorateClass
} from "./chunk.KAW7D32O.js";

// src/components/nav-group/nav-group.component.ts
import { classMap } from "lit/directives/class-map.js";
import { html } from "lit";
import { property, state } from "lit/decorators.js";
var LynkNavGroup = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.hasSlotController = new HasSlotController(this, "heading");
    this.squished = false;
    this.heading = "";
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "group");
  }
  firstUpdated() {
    this.handleSquished();
  }
  handleSquished() {
    if (this.squished) {
      this.setAttribute("squished", this.squished ? "true" : "false");
    } else {
      this.removeAttribute("squished");
    }
  }
  render() {
    const hasHeadingSlot = this.hasSlotController.test("heading");
    const hasHeading = this.heading ? true : !!hasHeadingSlot;
    return html`
      <div
        id="heading"
        part="base"
        class=${classMap({
      "nav-group__heading": true
    })}
        aria-hidden=${hasHeading ? "false" : "true"}
      >
        <slot name="heading">${this.heading}</slot>
      </div>

      <slot
        part="children"
        class=${classMap({
      "nav-group": true,
      "nav-group--squished": this.squished
    })}
      ></slot>
    `;
  }
};
LynkNavGroup.styles = [component_styles_default, nav_group_styles_default];
__decorateClass([
  state()
], LynkNavGroup.prototype, "squished", 2);
__decorateClass([
  property({ reflect: true })
], LynkNavGroup.prototype, "heading", 2);
__decorateClass([
  watch("squished", { waitUntilFirstUpdate: true })
], LynkNavGroup.prototype, "handleSquished", 1);

export {
  LynkNavGroup
};
