// src/components/icon-button/icon-button.styles.ts
import { css } from "lit";
var icon_button_styles_default = css`
  :host {
    display: inline-block;
    --max-width: fit-content(20em);
    --padding: var(--lynk-spacing-x-small);
  }

  .icon-button {
    flex: 0 0 auto;
    display: flex;
    max-width: var(--max-width);
    align-items: center;
    background: none;
    border: none;
    border-radius: var(--lynk-border-radius-medium);
    font-size: inherit;
    color: var(--lynk-color-neutral-600);
    padding: var(--padding);
    cursor: pointer;
    transition: var(--lynk-transition-medium) color;
    -webkit-appearance: none;
  }

  .icon-button:hover:not(.icon-button--disabled),
  .icon-button:focus:not(.icon-button--disabled) {
    color: var(--lynk-color-primary-600);
  }

  .icon-button:active:not(.icon-button--disabled) {
    color: var(--lynk-color-primary-700);
  }

  .icon-button:focus {
    outline: none;
  }

  .icon-button--disabled {
    opacity: 0.5;
    cursor: not-allowed;
  }

  .icon-button:focus-visible {
    outline: var(--lynk-focus-ring);
    outline-offset: var(--lynk-focus-ring-offset);
  }

  .icon-button__icon {
    pointer-events: none;
  }

  /* Primary */
  .icon-button.icon-button--primary {
    color: var(--lynk-color-primary-600);
  }

  .icon-button.icon-button--primary:hover:not(.icon-button--disabled),
  .icon-button.icon-button--primary:focus:not(.icon-button--disabled) {
    color: var(--lynk-color-primary-500);
  }

  .icon-button.icon-button--primary:active:not(.icon-button--disabled) {
    color: var(--lynk-color-primary-700);
  }

  /* Success */
  .icon-button.icon-button--success {
    color: var(--lynk-color-success-600);
  }

  .icon-button.icon-button--success:hover:not(.icon-button--disabled),
  .icon-button.icon-button--success:focus:not(.icon-button--disabled) {
    color: var(--lynk-color-success-500);
  }

  .icon-button.icon-button--success:active:not(.icon-button--disabled) {
    color: var(--lynk-color-success-700);
  }

  /* Neutral */
  .icon-button.icon-button--neutral {
    color: var(--lynk-color-neutral-600);
  }

  .icon-button.icon-button--neutral:hover:not(.icon-button--disabled),
  .icon-button.icon-button--neutral:focus:not(.icon-button--disabled) {
    color: var(--lynk-color-neutral-500);
  }

  .icon-button.icon-button--neutral:active:not(.icon-button--disabled) {
    color: var(--lynk-color-neutral-700);
  }

  /* Warning */
  .icon-button.icon-button--warning {
    color: var(--lynk-color-warning-600);
  }

  .icon-button.icon-button--warning:hover:not(.icon-button--disabled),
  .icon-button.icon-button--warning:focus:not(.icon-button--disabled) {
    color: var(--lynk-color-warning-500);
  }

  .icon-button.icon-button--warning:active:not(.icon-button--disabled) {
    color: var(--lynk-color-warning-700);
  }

  /* Danger */
  .icon-button.icon-button--danger {
    color: var(--lynk-color-danger-600);
  }

  .icon-button.icon-button--danger:hover:not(.icon-button--disabled),
  .icon-button.icon-button--danger:focus:not(.icon-button--disabled) {
    color: var(--lynk-color-danger-500);
  }

  .icon-button.icon-button--danger:active:not(.icon-button--disabled) {
    color: var(--lynk-color-danger-700);
  }

  .icon-button--has-prefix .icon-button__prefix {
    display: inline;
  }

  .icon-button--has-suffix .icon-button__suffix {
    display: inline;
  }

  .icon-button__prefix,
  .icon-button__suffix {
    padding: var(--padding);
    min-width: 0;
    flex: 1;
    display: none;
    align-items: center;
    pointer-events: none;
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
  }
`;

export {
  icon_button_styles_default
};
