import {
  truncate_default
} from "./chunk.UGKZTPJS.js";
import {
  breadcrumb_item_styles_default
} from "./chunk.NPKXQR25.js";
import {
  HasSlotController
} from "./chunk.OW5NIGGX.js";
import {
  watch
} from "./chunk.GMYPQTFK.js";
import {
  LynkElement
} from "./chunk.7M4AVQ6D.js";
import {
  component_styles_default
} from "./chunk.Y7724W4D.js";
import {
  __decorateClass
} from "./chunk.KAW7D32O.js";

// src/components/breadcrumb-item/breadcrumb-item.component.ts
import { classMap } from "lit/directives/class-map.js";
import { html } from "lit";
import { ifDefined } from "lit/directives/if-defined.js";
import { property, query, state } from "lit/decorators.js";
var LynkBreadcrumbItem = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.hasSlotController = new HasSlotController(this, "prefix", "suffix");
    this.renderType = "button";
    this.rel = "noreferrer noopener";
  }
  setRenderType() {
    const hasDropdown = this.defaultSlot.assignedElements({ flatten: true }).filter((i) => i.tagName.toLowerCase() === "lynk-dropdown").length > 0;
    if (this.href) {
      this.renderType = "link";
      return;
    }
    if (hasDropdown) {
      this.renderType = "dropdown";
      return;
    }
    this.renderType = "button";
  }
  hrefChanged() {
    this.setRenderType();
  }
  handleSlotChange() {
    this.setRenderType();
  }
  render() {
    return html`
      <div
        part="base"
        class=${classMap({
      "breadcrumb-item": true,
      "breadcrumb-item--has-prefix": this.hasSlotController.test("prefix"),
      "breadcrumb-item--has-suffix": this.hasSlotController.test("suffix")
    })}
      >
        <span part="prefix" class="breadcrumb-item__prefix">
          <slot name="prefix"></slot>
        </span>

        ${this.renderType === "link" ? html`
              <a
                part="label"
                class="breadcrumb-item__label breadcrumb-item__label--link"
                href="${this.href}"
                target="${ifDefined(this.target ? this.target : void 0)}"
                rel=${ifDefined(this.target ? this.rel : void 0)}
              >
                <lynk-truncate><slot @slotchange=${this.handleSlotChange}></slot></lynk-truncate>
              </a>
            ` : ""}
        ${this.renderType === "button" ? html`
              <button part="label" type="button" class="breadcrumb-item__label breadcrumb-item__label--button">
                <lynk-truncate><slot @slotchange=${this.handleSlotChange}></slot></lynk-truncate>
              </button>
            ` : ""}
        ${this.renderType === "dropdown" ? html`
              <div part="label" class="breadcrumb-item__label breadcrumb-item__label--drop-down">
                <lynk-truncate><slot @slotchange=${this.handleSlotChange}></slot></lynk-truncate>
              </div>
            ` : ""}

        <span part="suffix" class="breadcrumb-item__suffix">
          <slot name="suffix"></slot>
        </span>

        <span part="separator" class="breadcrumb-item__separator" aria-hidden="true">
          <slot name="separator"></slot>
        </span>
      </div>
    `;
  }
};
LynkBreadcrumbItem.styles = [component_styles_default, breadcrumb_item_styles_default];
LynkBreadcrumbItem.dependencies = { "lynk-truncate": truncate_default };
__decorateClass([
  query("slot:not([name])")
], LynkBreadcrumbItem.prototype, "defaultSlot", 2);
__decorateClass([
  state()
], LynkBreadcrumbItem.prototype, "renderType", 2);
__decorateClass([
  property()
], LynkBreadcrumbItem.prototype, "href", 2);
__decorateClass([
  property()
], LynkBreadcrumbItem.prototype, "target", 2);
__decorateClass([
  property()
], LynkBreadcrumbItem.prototype, "rel", 2);
__decorateClass([
  watch("href", { waitUntilFirstUpdate: true })
], LynkBreadcrumbItem.prototype, "hrefChanged", 1);

export {
  LynkBreadcrumbItem
};
