import {
  stack_styles_default
} from "./chunk.RTOHS727.js";
import {
  LynkElement
} from "./chunk.7M4AVQ6D.js";
import {
  component_styles_default
} from "./chunk.Y7724W4D.js";
import {
  __decorateClass
} from "./chunk.KAW7D32O.js";

// src/components/stack/stack.component.ts
import { classMap } from "lit/directives/class-map.js";
import { html } from "lit";
import { property } from "lit/decorators.js";
var LynkStack = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.horizontal = false;
    this.reverse = false;
    this.wrap = false;
    this.gap = "var(--lynk-spacing-small)";
  }
  render() {
    return html`
      <slot
        part="base"
        class=${classMap({
      stack: true,
      "stack--horizontal": this.horizontal,
      "stack--reverse": this.reverse,
      "stack--align-start": this.align === "start",
      "stack--align-center": this.align === "center",
      "stack--align-end": this.align === "end",
      "stack--align-stretch": this.align === "stretch",
      "stack--align-baseline": this.align === "baseline",
      "stack--justify-start": this.justify === "start",
      "stack--justify-center": this.justify === "center",
      "stack--justify-end": this.justify === "end",
      "stack--justify-between": this.justify === "between",
      "stack--justify-around": this.justify === "around",
      "stack--justify-evenly": this.justify === "evenly",
      "stack--wrap": this.wrap
    })}
        style="--gap: ${this.gap};"
      ></slot>
    `;
  }
};
LynkStack.styles = [component_styles_default, stack_styles_default];
__decorateClass([
  property({ type: Boolean, reflect: true })
], LynkStack.prototype, "horizontal", 2);
__decorateClass([
  property({ type: Boolean, reflect: true })
], LynkStack.prototype, "reverse", 2);
__decorateClass([
  property({ reflect: true })
], LynkStack.prototype, "justify", 2);
__decorateClass([
  property({ reflect: true })
], LynkStack.prototype, "align", 2);
__decorateClass([
  property({ type: Boolean, reflect: true })
], LynkStack.prototype, "wrap", 2);
__decorateClass([
  property({ type: String, reflect: true })
], LynkStack.prototype, "gap", 2);

export {
  LynkStack
};
