import {
  page_content_styles_default
} from "./chunk.IKWERGPF.js";
import {
  LynkPage
} from "./chunk.73YJAJZ5.js";
import {
  getScrollParent
} from "./chunk.WSPFGNPB.js";
import {
  LynkElement
} from "./chunk.7M4AVQ6D.js";
import {
  component_styles_default
} from "./chunk.Y7724W4D.js";
import {
  __decorateClass
} from "./chunk.KAW7D32O.js";

// src/components/page-content/page-content.component.ts
import { classMap } from "lit/directives/class-map.js";
import { html } from "lit";
import { property, query } from "lit/decorators.js";
var LynkPageContent = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.width = "fluid";
  }
  /** Scrolls the nearest scrollable parent element to the top. */
  scrollToTop() {
    const parent = this.hasParentLayout() ? this.parentElement.renderRoot.querySelector(".page__main") : getScrollParent(this.pageContent);
    if (parent) {
      parent.scrollTo({ top: 0, behavior: "smooth" });
    }
  }
  // Checks whether the page content is nested into a lynk-page
  hasParentLayout() {
    const parent = this.parentElement;
    return parent instanceof LynkPage;
  }
  render() {
    return html`
      <div
        part="base"
        class=${classMap({
      "page-content": true,
      "page-content--auto": this.width === "auto",
      "page-content--sm": this.width === "small",
      "page-content--md": this.width === "medium",
      "page-content--lg": this.width === "large",
      "page-content--xl": this.width === "x-large",
      "page-content--xxl": this.width === "2x-large",
      "page-content--fluid": this.width === "fluid"
    })}
      >
        <slot></slot>
      </div>
    `;
  }
};
LynkPageContent.styles = [component_styles_default, page_content_styles_default];
LynkPageContent.dependencies = { "lynk-page": LynkPage };
__decorateClass([
  property({ reflect: true })
], LynkPageContent.prototype, "width", 2);
__decorateClass([
  query(".page-content")
], LynkPageContent.prototype, "pageContent", 2);

export {
  LynkPageContent
};
