import {
  badge_styles_default
} from "./chunk.QYZPLX6T.js";
import {
  LynkElement
} from "./chunk.7M4AVQ6D.js";
import {
  component_styles_default
} from "./chunk.Y7724W4D.js";
import {
  __decorateClass
} from "./chunk.KAW7D32O.js";

// src/components/badge/badge.component.ts
import { classMap } from "lit/directives/class-map.js";
import { html } from "lit";
import { property } from "lit/decorators.js";
var LynkBadge = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.pill = false;
    this.pulse = false;
  }
  render() {
    return html`
      <span
        part="base"
        class=${classMap({
      badge: true,
      "badge--primary": this.type === "primary",
      "badge--accent": this.type === "accent",
      "badge--info": this.type === "info",
      "badge--success": this.type === "success",
      "badge--neutral": this.type === "neutral",
      "badge--warning": this.type === "warning",
      "badge--danger": this.type === "danger",
      "badge--pill": this.pill,
      "badge--pulse": this.pulse
    })}
        role="status"
      >
        <slot></slot>
      </span>
    `;
  }
};
LynkBadge.styles = [component_styles_default, badge_styles_default];
__decorateClass([
  property({ reflect: true })
], LynkBadge.prototype, "type", 2);
__decorateClass([
  property({ type: Boolean, reflect: true })
], LynkBadge.prototype, "pill", 2);
__decorateClass([
  property({ type: Boolean, reflect: true })
], LynkBadge.prototype, "pulse", 2);

export {
  LynkBadge
};
