import {
  card_styles_default
} from "./chunk.NLYYZVS2.js";
import {
  HasSlotController
} from "./chunk.OW5NIGGX.js";
import {
  LynkElement
} from "./chunk.7M4AVQ6D.js";
import {
  component_styles_default
} from "./chunk.Y7724W4D.js";
import {
  __decorateClass
} from "./chunk.KAW7D32O.js";

// src/components/card/card.component.ts
import { classMap } from "lit/directives/class-map.js";
import { html } from "lit";
import { property } from "lit/decorators.js";
var LynkCard = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.hasSlotController = new HasSlotController(
      this,
      "footer",
      "header",
      "image",
      "image-top-start",
      "image-top-end",
      "image-bottom-start",
      "image-bottom-end"
    );
    this.stealth = false;
    this.size = "inherit";
    this.interactive = false;
    this.active = false;
    this.pulse = false;
    this.aspectRatio = "16:9";
  }
  render() {
    return html`
      <div
        part="base"
        class=${classMap({
      card: true,
      // Modifiers
      "card--interactive": this.interactive,
      "card--active": this.active,
      "card--stealth": this.stealth,
      "card--pulse": this.pulse,
      // States
      "card--primary": this.state === "primary",
      "card--accent": this.state === "accent",
      "card--danger": this.state === "danger",
      "card--success": this.state === "success",
      "card--neutral": this.state === "neutral",
      "card--warning": this.state === "warning",
      "card--info": this.state === "info",
      // Sizes
      "card--small": this.size === "small",
      "card--medium": this.size === "medium",
      "card--large": this.size === "large",
      // Slots
      "card--has-footer": this.hasSlotController.test("footer"),
      "card--has-image": this.hasSlotController.test("image"),
      "card--has-header": this.hasSlotController.test("header")
    })}
      >
        <div part="image-block" class="card__image-block ${`aspect--${this.aspectRatio.replace(/[:.]/g, "-")}`}">
          <div part="image" class="card__image">
            <slot name="image"></slot>
          </div>

          <slot name="image-top-start" part="image-top-start" class="card__image-top-start"></slot>
          <slot name="image-top-end" part="image-top-end" class="card__image-top-end"></slot>
          <slot name="image-bottom-start" part="image-bottom-start" class="card__image-bottom-start"></slot>
          <slot name="image-bottom-end" part="image-bottom-end" class="card__image-bottom-end"></slot>
        </div>

        <slot name="header" part="header" class="card__header"></slot>
        <slot part="body" class="card__body"></slot>
        <slot name="footer" part="footer" class="card__footer"></slot>
      </div>
    `;
  }
};
LynkCard.styles = [component_styles_default, card_styles_default];
__decorateClass([
  property({ type: Boolean, reflect: true })
], LynkCard.prototype, "stealth", 2);
__decorateClass([
  property({ reflect: true })
], LynkCard.prototype, "size", 2);
__decorateClass([
  property({ reflect: true })
], LynkCard.prototype, "state", 2);
__decorateClass([
  property({ type: Boolean, reflect: true })
], LynkCard.prototype, "interactive", 2);
__decorateClass([
  property({ type: Boolean, reflect: true })
], LynkCard.prototype, "active", 2);
__decorateClass([
  property({ type: Boolean, reflect: true })
], LynkCard.prototype, "pulse", 2);
__decorateClass([
  property({ reflect: true, attribute: "aspect-ratio" })
], LynkCard.prototype, "aspectRatio", 2);

export {
  LynkCard
};
