// src/components/page/page.styles.ts
import { css } from "lit";
var page_styles_default = css`
  :host {
    display: contents;
  }

  .page {
    width: 100%;
    height: 100%;
    display: grid;
    grid-template:
      'left-sidebar left-inset-sidebar header right-inset-sidebar right-sidebar' min-content
      'left-sidebar left-inset-sidebar main right-inset-sidebar right-sidebar' 1fr
      'left-sidebar footer footer footer right-sidebar' min-content
      / auto auto 1fr auto auto;
  }

  .page__main {
    grid-area: main;
    display: block;
    overflow: auto;
  }

  .page__header {
    grid-area: header;
    display: block;
  }

  .page__footer {
    grid-area: footer;
    display: block;
  }

  .page__left-sidebar {
    grid-area: left-sidebar;
    display: block;
  }

  .page__right-sidebar {
    grid-area: right-sidebar;
    display: block;
  }

  .page__left-inset-sidebar {
    grid-area: left-inset-sidebar;
    display: block;
  }

  .page__right-inset-sidebar {
    grid-area: right-inset-sidebar;
    display: block;
  }
`;

export {
  page_styles_default
};
