import {
  intersection_observer_styles_default
} from "./chunk.UMHXN4BR.js";
import {
  watch
} from "./chunk.GMYPQTFK.js";
import {
  LynkElement
} from "./chunk.7M4AVQ6D.js";
import {
  component_styles_default
} from "./chunk.Y7724W4D.js";
import {
  __decorateClass
} from "./chunk.KAW7D32O.js";

// src/components/intersection-observer/intersection-observer.component.ts
import { html } from "lit";
import { property } from "lit/decorators.js";
var LynkIntersectionObserver = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.observedElements = [];
    this.disabled = false;
  }
  connectedCallback() {
    super.connectedCallback();
    this.intersectionObserver = new IntersectionObserver((entries) => {
      entries.forEach((entry) => {
        console.log(entry);
        if (entry.intersectionRatio > 0) {
          this.emit("ev-enter-view", { detail: { entry } });
        } else {
          this.emit("ev-exit-view", { detail: { entry } });
        }
      });
    });
    if (!this.disabled) {
      this.startObserver();
    }
  }
  handleSlotChange() {
    if (!this.disabled) {
      this.startObserver();
    }
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.stopObserver();
  }
  startObserver() {
    const slot = this.shadowRoot.querySelector("slot");
    if (slot !== null) {
      const elements = slot.assignedElements({ flatten: true });
      this.observedElements.forEach((el) => this.intersectionObserver.unobserve(el));
      this.observedElements = [];
      elements.forEach((el) => {
        this.intersectionObserver.observe(el);
        this.observedElements.push(el);
      });
    }
  }
  stopObserver() {
    this.intersectionObserver.disconnect();
  }
  handleDisabledChange() {
    if (this.disabled) {
      this.stopObserver();
    } else {
      this.startObserver();
    }
  }
  render() {
    return html`<slot @slotchange=${this.handleSlotChange}></slot> `;
  }
};
LynkIntersectionObserver.styles = [component_styles_default, intersection_observer_styles_default];
__decorateClass([
  property({ type: Boolean, reflect: true })
], LynkIntersectionObserver.prototype, "disabled", 2);
__decorateClass([
  watch("disabled", { waitUntilFirstUpdate: true })
], LynkIntersectionObserver.prototype, "handleDisabledChange", 1);

export {
  LynkIntersectionObserver
};
