// src/components/optgroup/optgroup.styles.ts
import { css } from "lit";
var optgroup_styles_default = css`
  :host {
    --display-divider: block;
  }

  .optgroup__divider {
    --spacing: var(--lynk-spacing-x-small);

    display: var(--display-divider);
  }

  .optgroup__label-container {
    align-items: center;
    box-sizing: border-box;
    color: var(--lynk-color-neutral-500);
    display: flex;
    gap: var(--lynk-spacing-small);
    min-height: var(--option-min-height, var(--lynk-input-height-medium));
  }

  /**
   * Only show the label container when there is a label at all
   */
  .optgroup--has-prefix .optgroup__label-container,
  .optgroup--has-label .optgroup__label-container,
  .optgroup--has-suffix .optgroup__label-container {
    padding: var(--option-padding, var(--lynk-spacing-small) var(--lynk-spacing-medium));
  }

  /**
   * Format main label.
   * Make sure this works for props and slotted content
   */
  .optgroup__label-content,
  .optgroup__label::slotted(*) {
    flex: 1;
    font-size: var(--lynk-font-size-small);
  }

  /* Disabled Label */
  .optgroup--is-disabled .optgroup__label-container {
    opacity: var(--lynk-input-disabled-opacity);
  }

  .optgroup__prefix,
  .optgroup__suffix {
    font-size: var(--font-size-medium);
  }

  .optgroup__options ::slotted(lynk-option[hidden]) {
    display: none;
  }
`;

export {
  optgroup_styles_default
};
