import {
  LynkPageContent
} from "./chunk.HAGGAFED.js";
import {
  page_header_styles_default
} from "./chunk.XDFCUAHU.js";
import {
  LynkPage
} from "./chunk.73YJAJZ5.js";
import {
  LynkElement
} from "./chunk.7M4AVQ6D.js";
import {
  component_styles_default
} from "./chunk.Y7724W4D.js";
import {
  __decorateClass
} from "./chunk.KAW7D32O.js";

// src/components/page-header/page-header.component.ts
import { html } from "lit";
import { property } from "lit/decorators.js";
var LynkPageHeader = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.width = "fluid";
  }
  connectedCallback() {
    super.connectedCallback();
    if (!this.slot && this.hasParentLayout()) {
      this.slot = "header";
    }
  }
  // Checks whether the heading is nested into a lynk-page
  hasParentLayout() {
    const parent = this.parentElement;
    return parent instanceof LynkPage;
  }
  render() {
    return html`
      <lynk-page-content width="${this.width}" style="--padding-top: 0; --padding-bottom: 0;">
        <header part="base" class="page-header">
          <slot name="breadcrumb" part="breadcrumb" class="page-header__breadcrumb"></slot>
          <slot name="aux" part="aux" class="page-header__aux"></slot>
          <slot class="page-header__main"></slot>
          <slot name="controls" part="controls" class="page-header__controls"></slot>
          <slot name="tabs" part="tabs" class="page-header__tabs"></slot>
        </header>
      </lynk-page-content>
    `;
  }
};
LynkPageHeader.styles = [component_styles_default, page_header_styles_default];
LynkPageHeader.dependencies = { "lynk-page-content": LynkPageContent, "lynk-page": LynkPage };
__decorateClass([
  property({ reflect: true })
], LynkPageHeader.prototype, "width", 2);

export {
  LynkPageHeader
};
