import {
  truncate_styles_default
} from "./chunk.N63FE7JX.js";
import {
  LynkElement
} from "./chunk.7M4AVQ6D.js";
import {
  component_styles_default
} from "./chunk.Y7724W4D.js";
import {
  __decorateClass
} from "./chunk.KAW7D32O.js";

// src/components/truncate/truncate.component.ts
import { classMap } from "lit/directives/class-map.js";
import { html } from "lit";
import { property, query, state } from "lit/decorators.js";
var LynkTruncate = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.hasDefaultSlot = false;
    this.hasEndSlot = false;
    this.title = "";
  }
  handleDefaultSlotChange() {
    const slottedElements = [...this.defaultSlot.assignedNodes({ flatten: true })];
    if (slottedElements.length) {
      this.hasDefaultSlot = true;
    } else {
      this.hasDefaultSlot = false;
    }
  }
  handleEndSlotChange() {
    const slottedElements = [...this.endSlot.assignedNodes({ flatten: true })];
    if (slottedElements.length) {
      this.hasEndSlot = true;
    } else {
      this.hasEndSlot = false;
    }
  }
  /** Returns a plain text label based on the option's content. */
  getTextLabel() {
    var _a;
    return ((_a = this.textContent) != null ? _a : "").trim();
  }
  render() {
    return html`
      <span
        part="base"
        title=${this.title || this.getTextLabel()}
        class=${classMap({
      truncate: true,
      "truncate--end": this.hasDefaultSlot && !this.hasEndSlot,
      "truncate--middle": this.hasDefaultSlot && this.hasEndSlot,
      "truncate--start": !this.hasDefaultSlot && this.hasEndSlot
    })}
      >
        <slot class="truncate__start" @slotchange=${this.handleDefaultSlotChange}></slot>
        <slot name="end" class="truncate__end" @slotchange=${this.handleEndSlotChange}></slot>
      </span>
    `;
  }
};
LynkTruncate.styles = [component_styles_default, truncate_styles_default];
__decorateClass([
  query("slot")
], LynkTruncate.prototype, "defaultSlot", 2);
__decorateClass([
  query('slot[name="end"]')
], LynkTruncate.prototype, "endSlot", 2);
__decorateClass([
  state()
], LynkTruncate.prototype, "hasDefaultSlot", 2);
__decorateClass([
  state()
], LynkTruncate.prototype, "hasEndSlot", 2);
__decorateClass([
  property()
], LynkTruncate.prototype, "title", 2);
__decorateClass([
  property({ type: Number })
], LynkTruncate.prototype, "clamp", 2);

export {
  LynkTruncate
};
