import {
  page_footer_styles_default
} from "./chunk.FGCC6BLV.js";
import {
  LynkPageContent
} from "./chunk.HAGGAFED.js";
import {
  LynkPage
} from "./chunk.73YJAJZ5.js";
import {
  LynkElement
} from "./chunk.7M4AVQ6D.js";
import {
  component_styles_default
} from "./chunk.Y7724W4D.js";
import {
  __decorateClass
} from "./chunk.KAW7D32O.js";

// src/components/page-footer/page-footer.component.ts
import { classMap } from "lit/directives/class-map.js";
import { html } from "lit";
import { property } from "lit/decorators.js";
var LynkPageFooter = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.width = "fluid";
  }
  connectedCallback() {
    super.connectedCallback();
    if (!this.slot && this.hasParentLayout()) {
      this.slot = "footer";
    }
  }
  // Checks whether the heading is nested into a lynk-page
  hasParentLayout() {
    const parent = this.parentElement;
    return parent instanceof LynkPage;
  }
  render() {
    return html`
      <lynk-page-content width="${this.width}" style="--padding-top: 0; --padding-bottom: 0;">
        <footer
          part="base"
          class=${classMap({
      "page-footer": true
    })}
        >
          <slot part="primary" class="page-footer__primary"></slot>
          <slot part="center" name="center" class="page-footer__center"></slot>
          <slot part="secondary" name="secondary" class="page-footer__secondary"></slot>
        </footer>
      </lynk-page-content>
    `;
  }
};
LynkPageFooter.styles = [component_styles_default, page_footer_styles_default];
LynkPageFooter.dependencies = { "lynk-page-content": LynkPageContent, "lynk-page": LynkPage };
__decorateClass([
  property({ reflect: true })
], LynkPageFooter.prototype, "width", 2);

export {
  LynkPageFooter
};
