import {
  responsive_media_styles_default
} from "./chunk.EUNO6J7H.js";
import {
  LynkElement
} from "./chunk.7M4AVQ6D.js";
import {
  component_styles_default
} from "./chunk.Y7724W4D.js";
import {
  __decorateClass
} from "./chunk.KAW7D32O.js";

// src/components/responsive-media/responsive-media.component.ts
import { classMap } from "lit/directives/class-map.js";
import { html } from "lit";
import { property } from "lit/decorators.js";
var LynkResponsiveMedia = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.aspectRatio = "16:9";
    this.fit = "cover";
  }
  render() {
    const split = this.aspectRatio.split(":");
    const x = parseFloat(split[0]);
    const y = parseFloat(split[1]);
    const paddingBottom = !isNaN(x) && !isNaN(y) && x > 0 && y > 0 ? `${y / x * 100}%` : "0";
    return html`
      <div
        class=${classMap({
      "responsive-media": true,
      "responsive-media--cover": this.fit === "cover",
      "responsive-media--contain": this.fit === "contain"
    })}
        style="padding-bottom: ${paddingBottom}"
      >
        <slot></slot>
      </div>
    `;
  }
};
LynkResponsiveMedia.styles = [component_styles_default, responsive_media_styles_default];
__decorateClass([
  property({ attribute: "aspect-ratio" })
], LynkResponsiveMedia.prototype, "aspectRatio", 2);
__decorateClass([
  property()
], LynkResponsiveMedia.prototype, "fit", 2);

export {
  LynkResponsiveMedia
};
