import {
  LynkElement
} from "./chunk.7M4AVQ6D.js";
import {
  component_styles_default
} from "./chunk.Y7724W4D.js";
import {
  accordion_styles_default
} from "./chunk.GLNM2JSX.js";
import {
  __decorateClass
} from "./chunk.KAW7D32O.js";

// src/components/accordion/accordion.component.ts
import { classMap } from "lit/directives/class-map.js";
import { html } from "lit";
import { property } from "lit/decorators.js";
var LynkAccordion = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.multiple = false;
  }
  getAllPanels() {
    return [...this.querySelectorAll("lynk-panel")];
  }
  handlePanelToggle(event) {
    const target = event.target.closest("lynk-panel");
    const panels = this.getAllPanels();
    if (target.disabled) {
      return;
    }
    if (!this.multiple) {
      panels.forEach((panel) => panel.expanded = panel === target);
    }
  }
  /** Expands all panels. */
  expandAll() {
    const panels = this.getAllPanels();
    panels.forEach((panel) => panel.expanded = true);
  }
  /** Collapses all panels */
  collapseAll() {
    const panels = this.getAllPanels();
    panels.forEach((panel) => panel.expanded = false);
  }
  render() {
    return html`
      <slot
        part="base"
        class=${classMap({
      accordion: true,
      "accordion--square": this.shape === "square",
      "accordion--flush": this.density === "flush",
      "accordion--compact": this.density === "compact",
      "accordion--comfy": this.density === "comfy"
    })}
        @ev-expand=${this.handlePanelToggle}
      ></slot>
    `;
  }
};
LynkAccordion.styles = [component_styles_default, accordion_styles_default];
__decorateClass([
  property({ type: Boolean })
], LynkAccordion.prototype, "multiple", 2);
__decorateClass([
  property({ reflect: true })
], LynkAccordion.prototype, "density", 2);
__decorateClass([
  property({ reflect: true })
], LynkAccordion.prototype, "shape", 2);

export {
  LynkAccordion
};
