import {
  grid_styles_default
} from "./chunk.5NWROM6H.js";
import {
  LynkElement
} from "./chunk.7M4AVQ6D.js";
import {
  component_styles_default
} from "./chunk.Y7724W4D.js";
import {
  __decorateClass
} from "./chunk.KAW7D32O.js";

// src/components/grid/grid.component.ts
import { html } from "lit";
import { property } from "lit/decorators.js";
var LynkGrid = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.container = false;
    this.item = false;
    this.gap = "base";
  }
  getBreakpointClasses() {
    return this.span ? this.span.split(",").map((key) => `span--${key.trim()}`).join(" ") : "";
  }
  render() {
    const containerClass = this.container ? "grid" : null;
    const directionClass = this.direction && this.container ? `grid--${this.direction}` : null;
    const justifyClass = this.justify && this.container ? `grid--justify-${this.justify}` : null;
    const alignClass = this.align && this.container ? `grid--align-${this.align}` : null;
    const itemClass = this.item ? "grid__item" : null;
    const spanClass = this.span && this.item ? this.getBreakpointClasses() : null;
    const classList = [containerClass, directionClass, justifyClass, alignClass, itemClass, spanClass];
    return html`
      <div part="base" class="${classList.join(" ")}" style="--gap: var(--lynk-spacing-${this.gap})">
        <slot></slot>
      </div>
    `;
  }
};
LynkGrid.styles = [component_styles_default, grid_styles_default];
__decorateClass([
  property({ type: Boolean, reflect: true })
], LynkGrid.prototype, "container", 2);
__decorateClass([
  property({ type: Boolean, reflect: true })
], LynkGrid.prototype, "item", 2);
__decorateClass([
  property({ reflect: true })
], LynkGrid.prototype, "direction", 2);
__decorateClass([
  property({ reflect: true })
], LynkGrid.prototype, "justify", 2);
__decorateClass([
  property({ reflect: true })
], LynkGrid.prototype, "align", 2);
__decorateClass([
  property({ reflect: true })
], LynkGrid.prototype, "span", 2);
__decorateClass([
  property({ reflect: true })
], LynkGrid.prototype, "gap", 2);

export {
  LynkGrid
};
