import {
  th_styles_default
} from "./chunk.B2F4ADSX.js";
import {
  LynkElement
} from "./chunk.7M4AVQ6D.js";
import {
  component_styles_default
} from "./chunk.Y7724W4D.js";
import {
  __decorateClass
} from "./chunk.KAW7D32O.js";

// src/components/th/th.component.ts
import { html } from "lit";
import { property } from "lit/decorators.js";
var LynkTh = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.sortDirection = 0 /* NONE */;
    this.sortable = false;
  }
  connectedCallback() {
    super.connectedCallback();
    this.addEventListener("click", this.handleClick);
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.removeEventListener("click", this.handleClick);
  }
  handleClick() {
    if (this.sortable) {
      this.emit("ev-table-sort", {
        detail: {
          key: this.key
        }
      });
    }
  }
  render() {
    return html`
      <slot part="base" class="lynk-th__label"></slot>
      ${this.sortable ? html`<lynk-icon
            library="system"
            name="${this.sortDirection === -1 /* ASC */ ? "arrow-up-short" : this.sortDirection === 1 /* DESC */ ? "arrow-down-short" : "arrow-up-down-short"}"
          ></lynk-icon>` : ``}
    `;
  }
};
LynkTh.styles = [component_styles_default, th_styles_default];
__decorateClass([
  property()
], LynkTh.prototype, "key", 2);
__decorateClass([
  property({ attribute: "sort-direction", reflect: true })
], LynkTh.prototype, "sortDirection", 2);
__decorateClass([
  property({ attribute: "sortable", type: Boolean, reflect: true })
], LynkTh.prototype, "sortable", 2);

export {
  LynkTh
};
