import {
  LocalizeController
} from "./chunk.6CTB5ZDJ.js";
import {
  LynkElement
} from "./chunk.7M4AVQ6D.js";
import {
  __decorateClass
} from "./chunk.KAW7D32O.js";

// src/components/format-number/format-number.component.ts
import { property } from "lit/decorators.js";
var LynkFormatNumber = class extends LynkElement {
  constructor() {
    super(...arguments);
    this.localize = new LocalizeController(this);
    this.value = 0;
    this.type = "decimal";
    this.noGrouping = false;
    this.currency = "USD";
    this.currencyDisplay = "symbol";
  }
  render() {
    if (isNaN(this.value)) {
      return "";
    }
    return this.localize.number(this.value, {
      style: this.type,
      currency: this.currency,
      currencyDisplay: this.currencyDisplay,
      useGrouping: !this.noGrouping,
      minimumIntegerDigits: this.minimumIntegerDigits,
      minimumFractionDigits: this.minimumFractionDigits,
      maximumFractionDigits: this.maximumFractionDigits,
      minimumSignificantDigits: this.minimumSignificantDigits,
      maximumSignificantDigits: this.maximumSignificantDigits
    });
  }
};
__decorateClass([
  property({ type: Number })
], LynkFormatNumber.prototype, "value", 2);
__decorateClass([
  property()
], LynkFormatNumber.prototype, "type", 2);
__decorateClass([
  property({ attribute: "no-grouping", type: Boolean })
], LynkFormatNumber.prototype, "noGrouping", 2);
__decorateClass([
  property()
], LynkFormatNumber.prototype, "currency", 2);
__decorateClass([
  property({ attribute: "currency-display" })
], LynkFormatNumber.prototype, "currencyDisplay", 2);
__decorateClass([
  property({ attribute: "minimum-integer-digits", type: Number })
], LynkFormatNumber.prototype, "minimumIntegerDigits", 2);
__decorateClass([
  property({ attribute: "minimum-fraction-digits", type: Number })
], LynkFormatNumber.prototype, "minimumFractionDigits", 2);
__decorateClass([
  property({ attribute: "maximum-fraction-digits", type: Number })
], LynkFormatNumber.prototype, "maximumFractionDigits", 2);
__decorateClass([
  property({ attribute: "minimum-significant-digits", type: Number })
], LynkFormatNumber.prototype, "minimumSignificantDigits", 2);
__decorateClass([
  property({ attribute: "maximum-significant-digits", type: Number })
], LynkFormatNumber.prototype, "maximumSignificantDigits", 2);

export {
  LynkFormatNumber
};
