// src/components/nav/nav.styles.ts
import { css } from "lit";
var nav_styles_default = css`
  :host {
    display: block;
    --max-width: 100%;
    --background: transparent;
    --padding: var(--lynk-spacing-x-small) 0;
    --border-color: transparent;
    --border-top: none;
    --border-right: none;
    --border-bottom: none;
    --border-left: none;
    --border-radius: 0;
  }

  .nav {
    max-width: var(--max-width);
    background: var(--background);
    border-top: var(--border-top);
    border-right: var(--border-right);
    border-bottom: var(--border-bottom);
    border-left: var(--border-left);
    border-radius: var(--border-radius);
    padding: var(--padding);
    display: flex;
    flex-direction: column;
    height: 100%;
    gap: var(--lynk-spacing-2x-small);
  }

  ::slotted(lynk-nav-group) {
    margin-top: var(--lynk-spacing-base);
  }

  .nav--squished ::slotted(lynk-nav-group) {
    text-align: center;
  }
`;

export {
  nav_styles_default
};
