import LynkElement from '../../internal/lynk-element.js';
import type { CSSResultGroup } from 'lit';
/**
 * @summary Button groups can be used to group related buttons into sections.
 * @documentation https://lynk.design/components/button-group
 * @since 1.0.0
 * @status stable
 *
 * @slot - One or more `<lynk-button>` elements to display in the button group.
 *
 * @csspart base - The component's internal wrapper.
 */
export default class LynkButtonGroup extends LynkElement {
    static styles: CSSResultGroup;
    defaultSlot: HTMLSlotElement;
    disableRole: boolean;
    /**
     * A label to use for the button group. This won't be displayed on the screen, but it will be announced by assistive
     * devices when interacting with the control and is strongly recommended.
     */
    label: string;
    private handleFocus;
    private handleBlur;
    private handleMouseOver;
    private handleMouseOut;
    private handleSlotChange;
    render(): import("lit").TemplateResult<1>;
}
