import "../../chunks/chunk.KAW7D32O.js";

// src/components/option/option-size.styles.ts
import { css } from "lit";
var option_size_styles_default = css`
  /**
   * Size adjustments for lynk-select and other widgets that use lynk-option
   * This allows to share the common settings between all components that
   * should be able to set the size of a lynk-option tag.
   */
  :host([size='small']) {
    --option-min-height: var(--lynk-input-height-small);
    --option-padding: 0 var(--lynk-input-spacing-small);
    --option-font-size: var(--lynk-input-font-size-small);
    --option-icon-size: var(--lynk-spacing-medium);
  }

  :host([size='medium']) {
    --option-min-height: var(--lynk-input-height-medium);
    --option-padding: 0 var(--lynk-input-spacing-medium);
    --option-font-size: var(--lynk-input-font-size-medium);
    --option-icon-size: var(--lynk-spacing-large);
  }

  :host([size='large']) {
    --option-min-height: var(--lynk-input-height-large);
    --option-padding: 0 var(--lynk-input-spacing-large);
    --option-font-size: var(--lynk-input-font-size-large);
    --option-icon-size: var(--lynk-spacing-x-large);
  }
`;
export {
  option_size_styles_default as default
};
