import LynkElement from '../../internal/lynk-element.js';
import type { CSSResultGroup } from 'lit';
/**
 * @summary Table `<lynk-td>` components will behave like a native `<td>` HTML element within a `<lynk-table>`.
 * @documentation https://lynk.design/components/td
 * @since 1.0.0
 * @status stable
 *
 * @slot - The contents of the table cell.
 *
 * @csspart base - The component's internal wrapper.
 */
export default class LynkTd extends LynkElement {
    static styles: CSSResultGroup;
    /** A visual state for this row of data to indicate */
    state: 'danger' | 'primary' | 'success' | 'warning' | 'neutral' | 'custom';
    /** Animates the state background in a barberpole style loop */
    barberpole: boolean;
    render(): import("lit").TemplateResult<1>;
}
