import LynkElement from '../../internal/lynk-element.js';
import type { CSSResultGroup } from 'lit';
/**
 * @summary Table `<lynk-thead>` components will behave like a native `<thead>` HTML elements within a `<lynk-table>`.
 * @documentation https://lynk.design/components/thead
 * @since 1.0.0
 * @status stable
 */
export default class LynkThead extends LynkElement {
    static styles: CSSResultGroup;
    /** Makes the header stick to the top of the table while its overflow is scrolling vertically */
    sticky: boolean;
    render(): import("lit").TemplateResult<1>;
}
