import LynkElement from '../../internal/lynk-element.js';
import type { CSSResultGroup } from 'lit';
/**
 * @summary Truncate is a tool used to shorten numeric and non-numeric character strings, typically when the string overflows its container.
 * @documentation https://lynk.design/components/truncate
 * @since 1.0.0
 * @status stable
 *
 * @slot - The default slot.
 * @slot end - Used when adding ellipsis at start or middle of truncated string.
 */
export default class LynkTruncate extends LynkElement {
    static styles: CSSResultGroup;
    defaultSlot: HTMLSlotElement;
    endSlot: HTMLSlotElement;
    private hasDefaultSlot;
    private hasEndSlot;
    title: string;
    /** Optionally clamp string at specified number of lines. */
    clamp?: '2' | '3' | '4' | '5';
    private handleDefaultSlotChange;
    private handleEndSlotChange;
    /** Returns a plain text label based on the option's content. */
    getTextLabel(): string;
    render(): import("lit").TemplateResult<1>;
}
