import LynkElement from '../../internal/lynk-element.js';
import type { CSSResultGroup } from 'lit';
/**
 * @summary The visually hidden utility makes content accessible to assistive devices without displaying it on the screen.
 * @documentation https://lynk.design/components/visually-hidden
 * @status stable
 * @since 1.0.0
 *
 * @slot - The content to be visually hidden.
 */
export default class LynkVisuallyHidden extends LynkElement {
    static styles: CSSResultGroup;
    render(): import("lit").TemplateResult<1>;
}
