import Component from '../../components/auto-grid/auto-grid.component.js';
/**
 * @summary A simple automatic two-dimensional grid-based layout system based off CSS Grid spec.
 * @documentation https://lynk.design/components/auto-grid
 * @since 1.0.0
 * @status stable
 *
 * @slot - The default slot.
 *
 * @csspart base - The component's internal wrapper.
 *
 * @cssproperty [--gap=var(--lynk-spacing-base)] - Customize the gap of the auto-grid group.
 * @cssproperty [--min-size=20rem] - Customize the allowed min-size of the auto-grid items.
 */
declare const reactWrapper: import("@lit/react").ReactWebComponent<Component, {}>;
export default reactWrapper;
