import Component from '../../components/icon-button/icon-button.component.js';
import { type EventName } from '@lit/react';
import type { LynkBlurEvent } from '../../events/events.js';
import type { LynkClickEvent } from '../../events/events.js';
import type { LynkFocusEvent } from '../../events/events.js';
export type { LynkBlurEvent } from '../../events/events.js';
export type { LynkClickEvent } from '../../events/events.js';
export type { LynkFocusEvent } from '../../events/events.js';
/**
 * @summary Icons buttons are simple, icon-only buttons that can be used for actions and in toolbars.
 * @documentation https://lynk.design/components/icon-button
 * @since 1.0.0
 * @status stable
 *
 * @dependency lynk-icon
 *
 * @event ev-blur - Emitted when the icon button loses focus.
 * @event ev-click - Emitted when the button is clicked.
 * @event ev-focus - Emitted when the icon button gains focus.
 *
 * @csspart base - The component's internal wrapper.
 */
declare const reactWrapper: import("@lit/react").ReactWebComponent<Component, {
    EvBlur: EventName<LynkBlurEvent>;
    EvClick: EventName<LynkClickEvent>;
    EvFocus: EventName<LynkFocusEvent>;
}>;
export default reactWrapper;
