import Component from '../../components/icon/icon.component.js';
import { type EventName } from '@lit/react';
import type { LynkLoadEvent } from '../../events/events.js';
import type { LynkErrorEvent } from '../../events/events.js';
export type { LynkLoadEvent } from '../../events/events.js';
export type { LynkErrorEvent } from '../../events/events.js';
/**
 * @summary Icons are symbols that can be used to represent various options within an application.
 * @documentation https://lynk.design/components/icon
 * @status stable
 * @since 1.0.0
 *
 * @event ev-load - Emitted when the icon has loaded. When using `spriteSheet: true` this will not emit.
 * @event ev-error - Emitted when the icon fails to load due to an error. When using `spriteSheet: true` this will not emit.
 *
 * @csspart svg - The internal SVG element.
 * @csspart use - The <use> element generated when using `spriteSheet: true`
 */
declare const reactWrapper: import("@lit/react").ReactWebComponent<Component, {
    EvLoad: EventName<LynkLoadEvent>;
    EvError: EventName<LynkErrorEvent>;
}>;
export default reactWrapper;
