import Component from '../../components/nav-group/nav-group.component.js';
/**
 * @summary Group navigation items into categories with a header.
 * @documentation https://lynk.design/components/nav-group
 * @since 1.0.0
 * @status stable
 *
 * @slot - the Nav Items to display in association with the heading
 * @slot heading - The nav groups heading. Alternatively, you can use the heading prop.
 *
 * @csspart base - The nav groups heading wrapper.
 * @csspart children - The nav groups children wrapper.
 *
 * @cssproperty [--color=var(--lynk-color-neutral-600)] - Customize the header color.
 *
 */
declare const reactWrapper: import("@lit/react").ReactWebComponent<Component, {}>;
export default reactWrapper;
