import Component from '../../components/page-footer/page-footer.component.js';
/**
 * @summary A Page Footer is used inside a [Page Layout](/components/page) to render a standardized sticky page footer with slots for typical page controls.
 * @documentation https://lynk.design/components/page-footer
 * @since 1.0.0
 * @status stable
 *
 * @dependency lynk-page
 * @dependency lynk-page-content
 *
 * @slot - The default start-aligned slot for primary page actions, Typically where `save` and `cancel` of form based pages should go.
 * @slot center - Typically used for pagination info or other non interactive page metadata.
 * @slot secondary - The end-aligned slot for secondary page actions. Typically where `delete` or other secondary destructive actions should go..
 *
 * @csspart base - The component's base wrapper.
 * @csspart primary - The component's primary slot area.
 * @csspart center - The component's center slot area.
 * @csspart secondary - The component's secondary slot area.
 */
declare const reactWrapper: import("@lit/react").ReactWebComponent<Component, {}>;
export default reactWrapper;
