import Component from '../../components/tab/tab.component.js';
import { type EventName } from '@lit/react';
import type { LynkCloseEvent } from '../../events/events.js';
export type { LynkCloseEvent } from '../../events/events.js';
/**
 * @summary Tabs are used inside [tab groups](/components/tab-group) to represent and activate [tab panels](/components/tab-panel).
 * @documentation https://lynk.design/components/tab
 * @status experimental
 * @since 1.0.0
 *
 * @dependency lynk-icon-button
 *
 * @slot - The tab's label.
 *
 * @event ev-close - Emitted when the tab is closable and the close button is activated.
 *
 * @csspart base - The component's base wrapper.
 * @csspart close-button - The close button, an `<lynk-icon-button>`.
 * @csspart close-button__base - The close button's exported `base` part.
 */
declare const reactWrapper: import("@lit/react").ReactWebComponent<Component, {
    EvClose: EventName<LynkCloseEvent>;
}>;
export default reactWrapper;
