import Component from '../../components/table/table.component.js';
/**
 * @summary Tables display tabular data in a basic grid composed of cells, columns, and rows. This format makes it easy for users to scan and compare large amounts of data. Lynk based tables are intended to behave like native html `<table>` elements.
 * @documentation https://lynk.design/components/table
 * @since 1.0.0
 * @status stable
 *
 * @slot - The tables content. If constructing manually, should contain 1 or more `<lynk-thead>` and `<lynk-tbody>` components. Should be unused for automatically constructed tables that use the `cols` and `rows` properties.
 *
 * @csspart base - The component's internal wrapper.
 */
declare const reactWrapper: import("@lit/react").ReactWebComponent<Component, {}>;
export default reactWrapper;
