import "../chunks/chunk.KAW7D32O.js";

// src/utilities/vue-binding-directive.ts
var vue_binding_directive_default = {
  name: "vue-lynk-model",
  install: (app, _options) => {
    const wm = /* @__PURE__ */ new WeakMap();
    app.directive("l-model", {
      beforeMount(el, binding) {
        var _a;
        const eventName = el.tagName === "LYNK-SELECT" ? "ev-change" : "input";
        const inputHandler = function(event) {
          const target = event.target;
          if (binding.instance && binding.value) {
            binding.instance[binding.value] = target.value;
          }
        };
        wm.set(el, inputHandler);
        const inputElement = el;
        inputElement.value = (_a = binding.value) != null ? _a : "";
        inputElement.addEventListener(eventName, inputHandler);
      },
      updated(el, binding) {
        var _a;
        const inputElement = el;
        inputElement.value = (_a = binding.value) != null ? _a : "";
      },
      unmounted(el) {
        const inputHandler = wm.get(el);
        if (inputHandler) {
          const eventName = el.tagName === "LYNK-SELECT" ? "ev-change" : "input";
          el.removeEventListener(eventName, inputHandler);
          wm.delete(el);
        }
      }
    });
  }
};
export {
  vue_binding_directive_default as default
};
